/*****************************************************************************
*  Copyright Statement:
*  --------------------
*  This software is protected by Copyright and the information contained
*  herein is confidential. The software may not be copied and the information
*  contained herein may not be used or disclosed except with the written
*  permission of MediaTek Inc. (C) 2005
*
*  BY OPENING THIS FILE, BUYER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND AGREES
*  THAT THE SOFTWARE/FIRMWARE AND ITS DOCUMENTATIONS ("MEDIATEK SOFTWARE")
*  RECEIVED FROM MEDIATEK AND/OR ITS REPRESENTATIVES ARE PROVIDED TO BUYER ON
*  AN "AS-IS" BASIS ONLY. MEDIATEK EXPRESSLY DISCLAIMS ANY AND ALL WARRANTIES,
*  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
*  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR NONINFRINGEMENT.
*  NEITHER DOES MEDIATEK PROVIDE ANY WARRANTY WHATSOEVER WITH RESPECT TO THE
*  SOFTWARE OF ANY THIRD PARTY WHICH MAY BE USED BY, INCORPORATED IN, OR
*  SUPPLIED WITH THE MEDIATEK SOFTWARE, AND BUYER AGREES TO LOOK ONLY TO SUCH
*  THIRD PARTY FOR ANY WARRANTY CLAIM RELATING THERETO. MEDIATEK SHALL ALSO
*  NOT BE RESPONSIBLE FOR ANY MEDIATEK SOFTWARE RELEASES MADE TO BUYER'S
*  SPECIFICATION OR TO CONFORM TO A PARTICULAR STANDARD OR OPEN FORUM.
*
*  BUYER'S SOLE AND EXCLUSIVE REMEDY AND MEDIATEK'S ENTIRE AND CUMULATIVE
*  LIABILITY WITH RESPECT TO THE MEDIATEK SOFTWARE RELEASED HEREUNDER WILL BE,
*  AT MEDIATEK'S OPTION, TO REVISE OR REPLACE THE MEDIATEK SOFTWARE AT ISSUE,
*  OR REFUND ANY SOFTWARE LICENSE FEES OR SERVICE CHARGE PAID BY BUYER TO
*  MEDIATEK FOR SUCH MEDIATEK SOFTWARE AT ISSUE.
*
*  THE TRANSACTION CONTEMPLATED HEREUNDER SHALL BE CONSTRUED IN ACCORDANCE
*  WITH THE LAWS OF THE STATE OF CALIFORNIA, USA, EXCLUDING ITS CONFLICT OF
*  LAWS PRINCIPLES.  ANY DISPUTES, CONTROVERSIES OR CLAIMS ARISING THEREOF AND
*  RELATED THERETO SHALL BE SETTLED BY ARBITRATION IN SAN FRANCISCO, CA, UNDER
*  THE RULES OF THE INTERNATIONAL CHAMBER OF COMMERCE (ICC).
*
*****************************************************************************/

/*****************************************************************************
 *
 * Filename:
 * ---------
 *   sensor.h
 *
 * Project:
 * --------
 *   DUMA
 *
 * Description:
 * ------------
 *   CMOS sensor header file
 *
 ****************************************************************************/
#ifndef __SENSOR_H
#define __SENSOR_H
#include "image_sensor.h"
//------------------------Engineer mode---------------------------------
#define FACTORY_START_ADDR 	0
#define ENGINEER_START_ADDR	10

typedef enum group_enum {
	PRE_GAIN=0,
	CMMCLK_CURRENT,
	FRAME_RATE_LIMITATION,
	REGISTER_EDITOR,
	GROUP_TOTAL_NUMS
} FACTORY_REGISTER_INDEX;

typedef enum register_index {
	SENSOR_BASEGAIN=FACTORY_START_ADDR,
	PRE_GAIN_R_INDEX,
	PRE_GAIN_Gr_INDEX,
	PRE_GAIN_Gb_INDEX,
	PRE_GAIN_B_INDEX,
	FACTORY_END_ADDR
} CCT_REGISTER_INDEX;

typedef enum engineer_index
{
	CMMCLK_CURRENT_INDEX=ENGINEER_START_ADDR,
	ENGINEER_END
} FACTORY_ENGINEER_INDEX;

//------------------------Engineer mode---------------------------------
typedef struct {
	SENSOR_REG_STRUCT Reg[ENGINEER_END];
	SENSOR_REG_STRUCT CCT[FACTORY_END_ADDR];
} SENSOR_DATA_STRUCT,*PSENSOR_DATA_STRUCT;

#define CAM_PREVIEW_30FPS
#define SYSTEM_CLK									(52*1000*1000)
/* PIXEL CLOCK USED BY BANDING FILTER CACULATION*/
#if defined(CAM_PREVIEW_15FPS)
	#define PIXEL_CLK								(SYSTEM_CLK/8)		// 52/8 MHz
#elif defined(CAM_PREVIEW_22FPS)
	#define PIXEL_CLK								(SYSTEM_CLK/6)		// 52/6 MHz
#elif defined(CAM_PREVIEW_30FPS)
	#define PIXEL_CLK								(SYSTEM_CLK/4)		// 52/4 MHz
#endif

#define BF3903_VIDEO_NORMALMODE_FRAME_RATE			15		// Limitation for MPEG4 Encode Only
#define BF3903_VIDEO_NIGHTMODE_FRAME_RATE			12

/* SENSOR PIXEL/LINE NUMBERS IN ONE PERIOD */
#define VGA_PERIOD_PIXEL_NUMS						784
#define VGA_PERIOD_LINE_NUMS						510

/* SENSOR EXPOSURE LINE LIMITATION */
#define VGA_EXPOSURE_LIMITATION						510

/* SENSOR GLOBAL GAIN AT NIGHT MODE */
#define BF3903_SENSOR_NIGHT_MODE_GAIN				0x08

/* SENSOR VGA SIZE */
#define IMAGE_SENSOR_VGA_WIDTH						640-16
#define IMAGE_SENSOR_VGA_HEIGHT						(480-6)

#define IMAGE_SENSOR_FULL_WIDTH						640
#define IMAGE_SENSOR_FULL_HEIGHT					(480-1)

#define IMAGE_SENSOR_PV_WIDTH						640-16
#define IMAGE_SENSOR_PV_HEIGHT						480-12

/* SETUP TIME NEED TO BE INSERTED */
#define IMAGE_SENSOR_VGA_INSERTED_PIXELS			128 //13
#define IMAGE_SENSOR_VGA_INSERTED_LINES	              18 //		1

#define BF3903_WRITE_ID								0xDC
#define BF3903_READ_ID								0xDD

//#define BF3903_SENSOR_ID							0x3803

//export functions
//UINT32 BF3903Open(void);
//UINT32 BF3903GetResolution(MSDK_SENSOR_RESOLUTION_INFO_STRUCT *pSensorResolution);
//UINT32 BF3903GetInfo(MSDK_SCENARIO_ID_ENUM ScenarioId, MSDK_SENSOR_INFO_STRUCT *pSensorInfo, MSDK_SENSOR_CONFIG_STRUCT *pSensorConfigData);
//UINT32 BF3903Control(MSDK_SCENARIO_ID_ENUM ScenarioId, MSDK_SENSOR_EXPOSURE_WINDOW_STRUCT *pImageWindow, MSDK_SENSOR_CONFIG_STRUCT *pSensorConfigData);
//UINT32 BF3903FeatureControl(MSDK_SENSOR_FEATURE_ENUM FeatureId, UINT8 *pFeaturePara,UINT32 *pFeatureParaLen);
//UINT32 BF3903Close(void);

#endif /* __SENSOR_H */

