/* Copyright Statement:
 *
 * This software/firmware and related documentation ("MediaTek Software") are
 * protected under relevant copyright laws. The information contained herein
 * is confidential and proprietary to MediaTek Inc. and/or its licensors.
 * Without the prior written permission of MediaTek inc. and/or its licensors,
 * any reproduction, modification, use or disclosure of MediaTek Software,
 * and information contained herein, in whole or in part, shall be strictly prohibited.
 */
/* MediaTek Inc. (C) 2010. All rights reserved.
 *
 * BY OPENING THIS FILE, RECEIVER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND AGREES
 * THAT THE SOFTWARE/FIRMWARE AND ITS DOCUMENTATIONS ("MEDIATEK SOFTWARE")
 * RECEIVED FROM MEDIATEK AND/OR ITS REPRESENTATIVES ARE PROVIDED TO RECEIVER ON
 * AN "AS-IS" BASIS ONLY. MEDIATEK EXPRESSLY DISCLAIMS ANY AND ALL WARRANTIES,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR NONINFRINGEMENT.
 * NEITHER DOES MEDIATEK PROVIDE ANY WARRANTY WHATSOEVER WITH RESPECT TO THE
 * SOFTWARE OF ANY THIRD PARTY WHICH MAY BE USED BY, INCORPORATED IN, OR
 * SUPPLIED WITH THE MEDIATEK SOFTWARE, AND RECEIVER AGREES TO LOOK ONLY TO SUCH
 * THIRD PARTY FOR ANY WARRANTY CLAIM RELATING THERETO. RECEIVER EXPRESSLY ACKNOWLEDGES
 * THAT IT IS RECEIVER'S SOLE RESPONSIBILITY TO OBTAIN FROM ANY THIRD PARTY ALL PROPER LICENSES
 * CONTAINED IN MEDIATEK SOFTWARE. MEDIATEK SHALL ALSO NOT BE RESPONSIBLE FOR ANY MEDIATEK
 * SOFTWARE RELEASES MADE TO RECEIVER'S SPECIFICATION OR TO CONFORM TO A PARTICULAR
 * STANDARD OR OPEN FORUM. RECEIVER'S SOLE AND EXCLUSIVE REMEDY AND MEDIATEK'S ENTIRE AND
 * CUMULATIVE LIABILITY WITH RESPECT TO THE MEDIATEK SOFTWARE RELEASED HEREUNDER WILL BE,
 * AT MEDIATEK'S OPTION, TO REVISE OR REPLACE THE MEDIATEK SOFTWARE AT ISSUE,
 * OR REFUND ANY SOFTWARE LICENSE FEES OR SERVICE CHARGE PAID BY RECEIVER TO
 * MEDIATEK FOR SUCH MEDIATEK SOFTWARE AT ISSUE.
 *
 * The following software/firmware and/or related documentation ("MediaTek Software")
 * have been modified by MediaTek Inc. All revisions are subject to any receiver's
 * applicable license agreements with MediaTek Inc.
 */

/*****************************************************************************
*  Copyright Statement:
*  --------------------
*  This software is protected by Copyright and the information contained
*  herein is confidential. The software may not be copied and the information
*  contained herein may not be used or disclosed except with the written
*  permission of MediaTek Inc. (C) 2008
*
*  BY OPENING THIS FILE, BUYER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND AGREES
*  THAT THE SOFTWARE/FIRMWARE AND ITS DOCUMENTATIONS ("MEDIATEK SOFTWARE")
*  RECEIVED FROM MEDIATEK AND/OR ITS REPRESENTATIVES ARE PROVIDED TO BUYER ON
*  AN "AS-IS" BASIS ONLY. MEDIATEK EXPRESSLY DISCLAIMS ANY AND ALL WARRANTIES,
*  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
*  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR NONINFRINGEMENT.
*  NEITHER DOES MEDIATEK PROVIDE ANY WARRANTY WHATSOEVER WITH RESPECT TO THE
*  SOFTWARE OF ANY THIRD PARTY WHICH MAY BE USED BY, INCORPORATED IN, OR
*  SUPPLIED WITH THE MEDIATEK SOFTWARE, AND BUYER AGREES TO LOOK ONLY TO SUCH
*  THIRD PARTY FOR ANY WARRANTY CLAIM RELATING THERETO. MEDIATEK SHALL ALSO
*  NOT BE RESPONSIBLE FOR ANY MEDIATEK SOFTWARE RELEASES MADE TO BUYER'S
*  SPECIFICATION OR TO CONFORM TO A PARTICULAR STANDARD OR OPEN FORUM.
*
*  BUYER'S SOLE AND EXCLUSIVE REMEDY AND MEDIATEK'S ENTIRE AND CUMULATIVE
*  LIABILITY WITH RESPECT TO THE MEDIATEK SOFTWARE RELEASED HEREUNDER WILL BE,
*  AT MEDIATEK'S OPTION, TO REVISE OR REPLACE THE MEDIATEK SOFTWARE AT ISSUE,
*  OR REFUND ANY SOFTWARE LICENSE FEES OR SERVICE CHARGE PAID BY BUYER TO
*  MEDIATEK FOR SUCH MEDIATEK SOFTWARE AT ISSUE.
*
*  THE TRANSACTION CONTEMPLATED HEREUNDER SHALL BE CONSTRUED IN ACCORDANCE
*  WITH THE LAWS OF THE STATE OF CALIFORNIA, USA, EXCLUDING ITS CONFLICT OF
*  LAWS PRINCIPLES.  ANY DISPUTES, CONTROVERSIES OR CLAIMS ARISING THEREOF AND
*  RELATED THERETO SHALL BE SETTLED BY ARBITRATION IN SAN FRANCISCO, CA, UNDER
*  THE RULES OF THE INTERNATIONAL CHAMBER OF COMMERCE (ICC).
*
*****************************************************************************/
/*****************************************************************************
 *
 * Filename:
 * ---------
 *   ov5640_sensor.c
 *
 * Project:
 * --------
 *   ALPS
 *
 * Description:
 * ------------
 *   Source code of Sensor driver
 *
 *
 * Author:
 * -------
 *   QH Geng (mtk70548)
 *
 *============================================================================
 *             HISTORY
 * Below this line, this part is controlled by CC/CQ. DO NOT MODIFY!!
 *------------------------------------------------------------------------------
 * $Revision:$
 * $Modtime:$
 * $Log:$
 *
 *
 *
 *------------------------------------------------------------------------------
 * Upper this line, this part is controlled by CC/CQ. DO NOT MODIFY!!
 *============================================================================
 ****************************************************************************/

#include <linux/videodev2.h>
#include <linux/i2c.h>
#include <linux/platform_device.h>
#include <linux/delay.h>
#include <linux/cdev.h>
#include <linux/uaccess.h>
#include <linux/fs.h>
#include <asm/atomic.h>
#include <linux/slab.h>


#include "kd_camera_hw.h"
#include "kd_imgsensor.h"
#include "kd_imgsensor_define.h"
#include "kd_imgsensor_errcode.h"

#include "ov5640_Sensor.h"
#include "ov5640_Camera_Sensor_para.h"
#include "ov5640_CameraCustomized.h"



extern int iReadReg(u16 a_u2Addr , u8 * a_puBuff , u16 i2cId);
extern int iWriteReg(u16 a_u2Addr , u32 a_u4Data , u32 a_u4Bytes , u16 i2cId);

void OV5640_write_cmos_sensor(kal_uint32 addr, kal_uint32 para)
{
	iWriteReg((u16) addr, (u32) para, 1 ,OV5640_WRITE_ID);
}

kal_uint16 OV5640_read_cmos_sensor(kal_uint16 addr)
{
	kal_uint8 get_byte=0;
    iReadReg((u16) addr ,(u8*)&get_byte, OV5640_WRITE_ID);
    return get_byte;
}

#define   OV5640_LIMIT_EXPOSURE_LINES                (1253)
#define   OV5640_VIDEO_NORMALMODE_30FRAME_RATE       (30)
#define   OV5640_VIDEO_NORMALMODE_FRAME_RATE         (15)

/* Global Valuable */
kal_uint16 OV5640_sensor_global_gain=BASEGAIN, OV5640_sensor_gain_base=BASEGAIN;
kal_uint16 OV5640_sensor_gain_array[4][4]={{0x0208, 0x0206, 0x020C, 0x020A},{0, 0, 0, 0},{0x0209, 0x0207, 0x020D, 0x020B},{0x18, 0x10, 0x10, 0x18}};

kal_uint32 OV5640_isp_master_clock;
kal_uint32 OV5640_sensor_pclk=48000000;
kal_uint16 OV5640_sensor_expo_width=1,OV5640_current_sensor_expo_width=1;
/* Max/Min Explosure Lines Used By AE Algorithm */
kal_uint16 OV5640_max_exposure_lines=OV5640_LIMIT_EXPOSURE_LINES;

// Start
kal_uint16 OV5640_PV_dummy_pixels=0, OV5640_PV_dummy_lines=0, OV5640_Cap_dummy_pixels=0, OV5640_Cap_dummy_lines=0;
UINT32 		OV5640_sensor_mirror_flip = 0;
kal_bool 	OV5640_PV_mode = KAL_TRUE;
kal_uint32 	OV5640_exposure_lines = 500;
kal_uint16 OV5640_last_line_length = OV5640_PV_PERIOD_PIXEL_NUMS;
kal_uint16 OV5640_last_frame_length = OV5640_PV_PERIOD_LINE_NUMS;
// End

/* Parameter For Engineer mode function */
kal_uint32 OV5640_FAC_SENSOR_REG;

kal_uint8 OV5640_sensor_write_I2C_address = OV5640_WRITE_ID;
kal_uint8 OV5640_sensor_read_I2C_address = OV5640_READ_ID;

SENSOR_REG_STRUCT OV5640SensorCCT[FACTORY_END_ADDR]=CAMERA_SENSOR_CCT_DEFAULT_VALUE;
SENSOR_REG_STRUCT OV5640SensorReg[ENGINEER_END]=CAMERA_SENSOR_REG_DEFAULT_VALUE;
MSDK_SENSOR_CONFIG_STRUCT OV5640SensorConfigData;

// write camera_para to sensor register
void OV5640_camera_para_to_sensor(void)
{
  kal_uint32  i;
  for(i=0; 0xFFFFFFFF!=OV5640SensorReg[i].Addr; i++)
  {
      OV5640_write_cmos_sensor(OV5640SensorReg[i].Addr, OV5640SensorReg[i].Para);
  }
  for(i=ENGINEER_START_ADDR; 0xFFFFFFFF!=OV5640SensorReg[i].Addr; i++)
  {
      OV5640_write_cmos_sensor(OV5640SensorReg[i].Addr, OV5640SensorReg[i].Para);
  }
  for(i=FACTORY_START_ADDR+1; i<5; i++)
  {
      OV5640_write_cmos_sensor(OV5640SensorCCT[i].Addr, OV5640SensorCCT[i].Para);
  }
}

// update camera_para from sensor register
void OV5640_sensor_to_camera_para(void)
{
  kal_uint32  i;
  for(i=0; 0xFFFFFFFF!=OV5640SensorReg[i].Addr; i++)
  {
      OV5640SensorReg[i].Para = OV5640_read_cmos_sensor(OV5640SensorReg[i].Addr);
  }
  for(i=ENGINEER_START_ADDR; 0xFFFFFFFF!=OV5640SensorReg[i].Addr; i++)
  {
      OV5640SensorReg[i].Para = OV5640_read_cmos_sensor(OV5640SensorReg[i].Addr);
  }
}

//------------------------Engineer mode---------------------------------
kal_int32  OV5640_get_sensor_group_count(void)
{
  return GROUP_TOTAL_NUMS;
}

void OV5640_get_sensor_group_info(kal_uint16 group_idx, kal_int8* group_name_ptr, kal_int32* item_count_ptr)
{
   switch (group_idx)
   {
      case PRE_GAIN:
          sprintf((char *)group_name_ptr, "CCT");
          *item_count_ptr = 5;
      break;
      case CMMCLK_CURRENT:
          sprintf((char *)group_name_ptr, "CMMCLK Current");
          *item_count_ptr = 1;
      break;
      case FRAME_RATE_LIMITATION:
          sprintf((char *)group_name_ptr, "Frame Rate Limitation");
          *item_count_ptr = 2;
      break;
      case REGISTER_EDITOR:
          sprintf((char *)group_name_ptr, "Register Editor");
          *item_count_ptr = 2;
      break;
      default:
         ASSERT(0);
  }
}

void OV5640_get_sensor_item_info(kal_uint16 group_idx,kal_uint16 item_idx, MSDK_SENSOR_ITEM_INFO_STRUCT* info_ptr)
{
  kal_int16 temp_reg=0;
  kal_uint16 temp_gain=0, temp_addr=0, temp_para=0;

  switch (group_idx)
  {
      case PRE_GAIN:
          switch (item_idx)
          {
              case 0:
                sprintf((char *)info_ptr->ItemNamePtr,"Pregain-R");
                  temp_addr = PRE_GAIN_R_INDEX;
              break;
              case 1:
                sprintf((char *)info_ptr->ItemNamePtr,"Pregain-Gr");
                  temp_addr = PRE_GAIN_Gr_INDEX;
              break;
              case 2:
                sprintf((char *)info_ptr->ItemNamePtr,"Pregain-Gb");
                  temp_addr = PRE_GAIN_Gb_INDEX;
              break;
              case 3:
                sprintf((char *)info_ptr->ItemNamePtr,"Pregain-B");
                  temp_addr = PRE_GAIN_B_INDEX;
              break;
              case 4:
                 sprintf((char *)info_ptr->ItemNamePtr,"SENSOR_BASEGAIN");
                 temp_addr = SENSOR_BASEGAIN;
              break;
              default:
                 ASSERT(0);
          }

          temp_para=OV5640SensorCCT[temp_addr].Para;

          if(temp_para>=0x08 && temp_para<=0xFF)
              temp_gain=(temp_para*BASEGAIN)/8;
          else if(temp_para>0xFF && temp_para<=0x1FF)
              temp_gain=(temp_para*BASEGAIN)/8;
          else
              ASSERT(0);

          temp_gain=(temp_gain*1000)/BASEGAIN;

          info_ptr->ItemValue=temp_gain;
                info_ptr->IsTrueFalse=KAL_FALSE;
                info_ptr->IsReadOnly=KAL_FALSE;
                info_ptr->IsNeedRestart=KAL_FALSE;
                info_ptr->Min=1000;
                info_ptr->Max=15875;
              break;
      case CMMCLK_CURRENT:
          switch (item_idx)
          {
              case 0:
                sprintf((char *)info_ptr->ItemNamePtr,"Drv Cur[2,4,6,8]mA");

                temp_reg=OV5640SensorReg[CMMCLK_CURRENT_INDEX].Para;
                if(temp_reg==ISP_DRIVING_2MA)
                {
                    info_ptr->ItemValue=2;
                }
                else if(temp_reg==ISP_DRIVING_4MA)
                {
                    info_ptr->ItemValue=4;
                }
                else if(temp_reg==ISP_DRIVING_6MA)
                {
                    info_ptr->ItemValue=6;
                }
                else if(temp_reg==ISP_DRIVING_8MA)
                {
                    info_ptr->ItemValue=8;
                }

                info_ptr->IsTrueFalse=KAL_FALSE;
                info_ptr->IsReadOnly=KAL_FALSE;
                info_ptr->IsNeedRestart=KAL_TRUE;
                info_ptr->Min=2;
                info_ptr->Max=8;
              break;
              default:
                 ASSERT(0);
          }
      break;
      case FRAME_RATE_LIMITATION:
          switch (item_idx)
          {
              case 0:
                sprintf((char *)info_ptr->ItemNamePtr,"Max Exposure Lines");
                info_ptr->ItemValue=OV5640_max_exposure_lines;
                info_ptr->IsTrueFalse=KAL_FALSE;
                info_ptr->IsReadOnly=KAL_TRUE;
                info_ptr->IsNeedRestart=KAL_FALSE;
                info_ptr->Min=0;
                info_ptr->Max=0;
              break;
              case 1:
                sprintf((char *)info_ptr->ItemNamePtr,"Min Frame Rate");
                info_ptr->ItemValue=12;
                info_ptr->IsTrueFalse=KAL_FALSE;
                info_ptr->IsReadOnly=KAL_TRUE;
                info_ptr->IsNeedRestart=KAL_FALSE;
                info_ptr->Min=0;
                info_ptr->Max=0;
              break;
              default:
                 ASSERT(0);
          }
      break;
      case REGISTER_EDITOR:
          switch (item_idx)
          {
              case 0:
                sprintf((char *)info_ptr->ItemNamePtr,"REG Addr.");
                info_ptr->ItemValue=0;
                info_ptr->IsTrueFalse=KAL_FALSE;
                info_ptr->IsReadOnly=KAL_FALSE;
                info_ptr->IsNeedRestart=KAL_FALSE;
                info_ptr->Min=0;
                info_ptr->Max=0xFFFF;
              break;
              case 1:
                sprintf((char *)info_ptr->ItemNamePtr,"REG Value");
                info_ptr->ItemValue=0;
                info_ptr->IsTrueFalse=KAL_FALSE;
                info_ptr->IsReadOnly=KAL_FALSE;
                info_ptr->IsNeedRestart=KAL_FALSE;
                info_ptr->Min=0;
                info_ptr->Max=0xFFFF;
              break;
              default:
                 ASSERT(0);
          }
      break;
      default:
          ASSERT(0);
  }
}

kal_bool OV5640_set_sensor_item_info(kal_uint16 group_idx, kal_uint16 item_idx, kal_int32 ItemValue)
{
   kal_uint16 temp_gain=0, temp_addr=0, temp_para=0;

   switch (group_idx)
  {
      case PRE_GAIN:
          switch (item_idx)
          {
              case 0:
                temp_addr = PRE_GAIN_R_INDEX;
              break;
              case 1:
                temp_addr = PRE_GAIN_Gr_INDEX;
              break;
              case 2:
                temp_addr = PRE_GAIN_Gb_INDEX;
              break;
              case 3:
                temp_addr = PRE_GAIN_B_INDEX;
              break;
              case 4:
                temp_addr = SENSOR_BASEGAIN;
              break;
              default:
                 ASSERT(0);
          }

          temp_gain=((ItemValue*BASEGAIN+500)/1000);          //+500:get closed integer value

          if(temp_gain>=1*BASEGAIN && temp_gain<=15*BASEGAIN)
          {
             temp_para=(temp_gain*8+BASEGAIN/2)/BASEGAIN;
          }
          else if(temp_gain>=16*BASEGAIN)
          {
             temp_para=(kal_uint16)(15.875*BASEGAIN*8+BASEGAIN/2)/BASEGAIN;
          }
          else
              return KAL_FALSE;

          OV5640SensorCCT[temp_addr].Para = temp_para;
          if(temp_addr != SENSOR_BASEGAIN)
          {
              //OV5640_write_cmos_sensor(OV5640SensorCCT[temp_addr].Addr,temp_para);
          }
      break;
      case CMMCLK_CURRENT:
          switch (item_idx)
          {
              case 0:
                if(ItemValue==2)
                {
                    OV5640SensorReg[CMMCLK_CURRENT_INDEX].Para = ISP_DRIVING_2MA;
                }
                else if(ItemValue==3 || ItemValue==4)
                {
                    OV5640SensorReg[CMMCLK_CURRENT_INDEX].Para = ISP_DRIVING_4MA;
                }
                else if(ItemValue==5 || ItemValue==6)
                {
                    OV5640SensorReg[CMMCLK_CURRENT_INDEX].Para = ISP_DRIVING_6MA;
                }
                else
                {
                    OV5640SensorReg[CMMCLK_CURRENT_INDEX].Para = ISP_DRIVING_8MA;
                }
              break;
              default:
                 ASSERT(0);
          }
      break;
      case FRAME_RATE_LIMITATION:
         ASSERT(0);
      break;
      case REGISTER_EDITOR:
          switch (item_idx)
          {
              case 0:
                OV5640_FAC_SENSOR_REG=ItemValue;
              break;
              case 1:
                OV5640_write_cmos_sensor(OV5640_FAC_SENSOR_REG,ItemValue);
              break;
              default:
                 ASSERT(0);
          }
      break;
      default:
         ASSERT(0);
  }

  return KAL_TRUE;
}

void OV5640InitialSetting(void)
{
	OV5640_write_cmos_sensor(0x3008, 0x82);
	msleep(20);
	
	/* Disable LENC, GMA, Black/White pixel cancelation color interpolation, CMX, SDE, AWB */
	OV5640_write_cmos_sensor(0x5000, 0x06);	//0x00 , DPC
	OV5640_write_cmos_sensor(0x5001, 0x00);
	
	OV5640_write_cmos_sensor(0x3000, 0x00);	/* Reset Individual Block */
	OV5640_write_cmos_sensor(0x3002, 0x1c);

	OV5640_write_cmos_sensor(0x3004, 0xff);	/* Clock Enable Control */
	OV5640_write_cmos_sensor(0x3006, 0xc3);
	OV5640_write_cmos_sensor(0x302c, 0x82); // I/O drive capability OVT
	
	OV5640_write_cmos_sensor(0x3103, 0x03); 			 
	OV5640_write_cmos_sensor(0x3034, 0x1a); 			 
	OV5640_write_cmos_sensor(0x3035, 0x21); 			 
	OV5640_write_cmos_sensor(0x3036, 0x6E); 	// 0x69: 42Mhz. 			
	OV5640_write_cmos_sensor(0x3037, 0x13); 			 
	OV5640_write_cmos_sensor(0x3108, 0x01); 		  
	
	OV5640_write_cmos_sensor(0x460b, 0x37); 			 
	OV5640_write_cmos_sensor(0x460c, 0x22);
	OV5640_write_cmos_sensor(0x3824, 0x02);
	OV5640_write_cmos_sensor(0x300e, 0x58);	/* Power down mipi module */
	
	OV5640_write_cmos_sensor(0x302e, 0x00);	/* System control register */
	OV5640_write_cmos_sensor(0x4300, 0xf8);	/* Format control, RGB order */
	OV5640_write_cmos_sensor(0x501f, 0x03);	/* Format MUX control, output ISP RAW(DPC) */
	OV5640_write_cmos_sensor(0x4713, 0x03);	/* JPEG mode 3 */
	OV5640_write_cmos_sensor(0x4407, 0x04); /* JPEG Disable read QTA ncreacement */

	/* Input/Output Control (FREX, VSYNC, HREF, PCLK, D[9:0], GPIO1, GPIO0) */
	OV5640_write_cmos_sensor(0x3017, 0xff);
	OV5640_write_cmos_sensor(0x3018, 0xff);
	
	OV5640_write_cmos_sensor(0x3630, 0x2e);	/* Reserved */
	OV5640_write_cmos_sensor(0x3632, 0xe2);	/* Reserved */
	OV5640_write_cmos_sensor(0x3633, 0x23);	/* Reserved */
	OV5640_write_cmos_sensor(0x3621, 0xe0);	/* Bit[0]-Horizontal binning enable, current disable */
	OV5640_write_cmos_sensor(0x3704, 0xa0);	/* Reserved */
	OV5640_write_cmos_sensor(0x3703, 0x5a);	/* Reserved */
	OV5640_write_cmos_sensor(0x3715, 0x78);	/* Reserved */
	OV5640_write_cmos_sensor(0x3717, 0x01);	/* Reserved */
	OV5640_write_cmos_sensor(0x370b, 0x60);	/* Reserved */
	OV5640_write_cmos_sensor(0x3705, 0x1a);	/* Reserved */
	OV5640_write_cmos_sensor(0x3905, 0x02);	/* Reserved */
	OV5640_write_cmos_sensor(0x3906, 0x10);	/* Reserved */
	OV5640_write_cmos_sensor(0x3901, 0x0a);	/* Reserved */
	OV5640_write_cmos_sensor(0x3731, 0x12);	/* Reserved */
	OV5640_write_cmos_sensor(0x3600, 0x08);	/* Debug Mode */
	OV5640_write_cmos_sensor(0x3601, 0x33);	/* Debug Mode */
	
	OV5640_write_cmos_sensor(0x302d, 0x60);	/* System control */
	OV5640_write_cmos_sensor(0x3620, 0x52);	/* Reserved */
	OV5640_write_cmos_sensor(0x371b, 0x20);	/* Reserved */
	OV5640_write_cmos_sensor(0x471c, 0x50);	/* Reserved */
	
	OV5640_write_cmos_sensor(0x3a18, 0x00);	/* Gain output top limit */
	OV5640_write_cmos_sensor(0x3a19, 0xf8);
	
	OV5640_write_cmos_sensor(0x3635, 0x1c);	/* Reserved */
	OV5640_write_cmos_sensor(0x3634, 0x40);	/* Reserved */
	OV5640_write_cmos_sensor(0x3622, 0x01);	/* Reserved */
	OV5640_write_cmos_sensor(0x3820, 0x41);	/* Flip control */
	OV5640_write_cmos_sensor(0x3821, 0x01);	/* Mirror control */
	OV5640_write_cmos_sensor(0x3814, 0x31);	/* Bit[7:4] Horizontal odd subsample inc, Bit[3:0] Horizontal even subsample inc */
	OV5640_write_cmos_sensor(0x3815, 0x31);	/* Bit[7:4] Vertical odd subsample inc, Bit[3:0] Vertical even subsample inc */
	OV5640_write_cmos_sensor(0x3618, 0x00);	/* Reserved */
	OV5640_write_cmos_sensor(0x3612, 0x29);	/* Reserved */
	OV5640_write_cmos_sensor(0x3708, 0x62);	/* Reserved */
	OV5640_write_cmos_sensor(0x3709, 0x52);	/* Reserved */
	OV5640_write_cmos_sensor(0x370c, 0x03);	/* Reserved */
	  
	//;; manual AWB,manual AE,close Lenc,open WBC                
	//;;manual AE
	OV5640_write_cmos_sensor(0x3503, 0x03);	/* AEC manual mode control */
	OV5640_write_cmos_sensor(0x3501, 0x20); /* Shutter */                                
	OV5640_write_cmos_sensor(0x3502, 0x80);
	OV5640_write_cmos_sensor(0x350a, 0x00);	/* Real Analog Gain */
	OV5640_write_cmos_sensor(0x350b, 0x3f); 
	// Manual AWB, and set the awb gain to 1x (0x400)
	OV5640_write_cmos_sensor(0x3406, 0x01);	/* Manual AWB */
	OV5640_write_cmos_sensor(0x3400, 0x04);                                 
	OV5640_write_cmos_sensor(0x3401, 0x00);                                 
	OV5640_write_cmos_sensor(0x3402, 0x04);                                 
	OV5640_write_cmos_sensor(0x3403, 0x00);                                 
	OV5640_write_cmos_sensor(0x3404, 0x04);                                 
	OV5640_write_cmos_sensor(0x3405, 0x00);                                                                   
	         
	OV5640_write_cmos_sensor(0x4001, 0x02);	/* BLC Start line */
	OV5640_write_cmos_sensor(0x4005, 0x1A); /* BLC always update */
	
	OV5640_write_cmos_sensor(0x3008, 0x42);       

	OV5640_PV_mode = KAL_TRUE;
	OV5640_sensor_pclk = 48000000;
}	/*  OV5647_Sensor_Init  */


void OV5640PvSetting(void)
{
	// Switch to 1296x972
	
	OV5640_write_cmos_sensor(0x370c, 0x03); /* Reserved */
	OV5640_write_cmos_sensor(0x3618, 0x00); /* Reserved */
	OV5640_write_cmos_sensor(0x3612, 0x29); /* Reserved */
	
	OV5640_write_cmos_sensor(0x380c, 0x07); /* Total horizontal size, 1896 */
	OV5640_write_cmos_sensor(0x380d, 0x68);
	OV5640_write_cmos_sensor(0x380e, 0x03); /* Total vertical size, 984 */
	OV5640_write_cmos_sensor(0x380f, 0xd8);
	
	OV5640_write_cmos_sensor(0x3814, 0x31); /* Bit[7:4] Horizontal odd subsample inc, Bit[3:0] Horizontal even subsample inc */
	OV5640_write_cmos_sensor(0x3815, 0x31); /* Bit[7:4] Vertical odd subsample inc, Bit[3:0] Vertical even subsample inc */
	OV5640_write_cmos_sensor(0x3708, 0x62); /* Reserved */
	OV5640_write_cmos_sensor(0x3709, 0x52); /* Reserved */
	OV5640_write_cmos_sensor(0x3808, 0x05); /* DVP output horizontal width, 1296 */
	OV5640_write_cmos_sensor(0x3809, 0x10);
	OV5640_write_cmos_sensor(0x380a, 0x03); /* DVP output vertical height, 972 */
	OV5640_write_cmos_sensor(0x380b, 0xcc);
	
	OV5640_write_cmos_sensor(0x3800, 0x00); /*	X Address start */
	OV5640_write_cmos_sensor(0x3801, 0x00);
	OV5640_write_cmos_sensor(0x3802, 0x00); /*	Y Address start */
	OV5640_write_cmos_sensor(0x3803, 0x00);
	OV5640_write_cmos_sensor(0x3804, 0x0a); /*	X Address end */
	OV5640_write_cmos_sensor(0x3805, 0x3f);
	OV5640_write_cmos_sensor(0x3806, 0x07); /*	Y Address end */
	OV5640_write_cmos_sensor(0x3807, 0x9f);
	
	OV5640_write_cmos_sensor(0x3810, 0x00);
	OV5640_write_cmos_sensor(0x3811, 0x08); /* Horizontal Offset */
	OV5640_write_cmos_sensor(0x3812, 0x00);
	OV5640_write_cmos_sensor(0x3813, 0x02); /* Vertical Offset */
	
	OV5640_write_cmos_sensor(0x3820, 0x41); /* Flip */
	OV5640_write_cmos_sensor(0x3821, 0x07); /* Mirror, Binning */

	OV5640_write_cmos_sensor(0x4004, 0x02); /* BLC Line number */
	OV5640_write_cmos_sensor(0x3008, 0x02);

	OV5640_PV_mode = KAL_TRUE;
	OV5640_sensor_pclk = 48000000;
}


static void OV5640CapSetting(void)
{
	// Switch to 2608 x 1952
	
	OV5640_write_cmos_sensor(0x370c, 0x00); /* Reserved */
	OV5640_write_cmos_sensor(0x3612, 0x2b); /* Reserved */
	OV5640_write_cmos_sensor(0x3618, 0x04); /* Reserved */
	
	OV5640_write_cmos_sensor(0x380c, 0x0b); /* Total horizontal size, 2844 */			  
	OV5640_write_cmos_sensor(0x380d, 0x1c); 			 
	OV5640_write_cmos_sensor(0x380e, 0x07); /* Total vertical size, 1968 */ 			 
	OV5640_write_cmos_sensor(0x380f, 0xb0);  
	
	OV5640_write_cmos_sensor(0x3814, 0x11); /* Bit[7:4] Horizontal odd subsample inc, Bit[3:0] Horizontal even subsample inc */ 			 
	OV5640_write_cmos_sensor(0x3815, 0x11); /* Bit[7:4] Vertical odd subsample inc, Bit[3:0] Vertical even subsample inc */ 			 
	OV5640_write_cmos_sensor(0x3708, 0x21); /* Reserved */				
	OV5640_write_cmos_sensor(0x3709, 0x12); /* Reserved */			   
	
	OV5640_write_cmos_sensor(0x3808, 0x0a); /* DVP output horizontal width, 2608 */
	OV5640_write_cmos_sensor(0x3809, 0x30); 			 
	OV5640_write_cmos_sensor(0x380a, 0x07); /* DVP output horizontal width, 1952 */
	OV5640_write_cmos_sensor(0x380b, 0xa0); 	
	
	OV5640_write_cmos_sensor(0x3800, 0x00); /*	X Address start */				
	OV5640_write_cmos_sensor(0x3801, 0x00); 			 
	OV5640_write_cmos_sensor(0x3802, 0x00); /*	Y Address start */				
	OV5640_write_cmos_sensor(0x3803, 0x00); 			 
	OV5640_write_cmos_sensor(0x3804, 0x0a); /*	X Address end */			  
	OV5640_write_cmos_sensor(0x3805, 0x3f); 			 
	OV5640_write_cmos_sensor(0x3806, 0x07); /*	Y Address end */			  
	OV5640_write_cmos_sensor(0x3807, 0xa4);
	
	OV5640_write_cmos_sensor(0x3810, 0x00); /* Horizontal Offset */ 			
	OV5640_write_cmos_sensor(0x3811, 0x08); 			
	OV5640_write_cmos_sensor(0x3812, 0x00); /* Vertical Offset */			  
	OV5640_write_cmos_sensor(0x3813, 0x02);
	
	OV5640_write_cmos_sensor(0x3821, 0x00); /* Flip */			  
	OV5640_write_cmos_sensor(0x3820, 0x40); /* Mirror, Binning */
	
	OV5640_write_cmos_sensor(0x4004, 0x06); /* BLC Line number */
	OV5640_write_cmos_sensor(0x3008, 0x02);

	OV5640_PV_mode = KAL_FALSE;
	OV5640_sensor_pclk = 48000000;
}


/*************************************************************************
* FUNCTION
* OV5640_set_dummy
*
* DESCRIPTION
* This function set dummy lines & dummy pixels to adjust the frame rate.
*
* PARAMETERS
* dummy_pixels: Dummy pixels (Horizontal Blanking)
* dummy_lines: Dummy lines (Vertical Blanking)
*
* RETURNS
* None
*
* GLOBALS AFFECTED
*
*************************************************************************/
void OV5640_set_dummy(kal_uint32 dummy_pixels, kal_uint32 dummy_lines)
{
	kal_uint32 new_line_length = 0;
	kal_uint32 new_frame_length = 0;

	if (KAL_TRUE == OV5640_PV_mode)
	{
		new_line_length = OV5640_PV_PERIOD_PIXEL_NUMS + dummy_pixels;
		new_frame_length = OV5640_PV_PERIOD_LINE_NUMS + dummy_lines;
	}
	else
	{
		new_line_length = OV5640_FULL_PERIOD_PIXEL_NUMS + dummy_pixels;
		new_frame_length = OV5640_FULL_PERIOD_LINE_NUMS + dummy_lines;
	}

	OV5640_TRACE("[OV5640_set_dummy] PV=%d, line_length=%d, frame_length=%d\n", OV5640_PV_mode, new_line_length, new_frame_length);

	/* Total horizontal size */
	if (new_line_length >= OV5640_last_line_length)
	{
		OV5640_write_cmos_sensor(0x380c, (new_line_length>>8) & 0x0F);
		OV5640_write_cmos_sensor(0x380d, (new_line_length & 0xFF));
	}
	else
	{
		OV5640_write_cmos_sensor(0x380d, (new_line_length & 0xFF));
		OV5640_write_cmos_sensor(0x380c, (new_line_length>>8) & 0x0F);
	}

	/* Total vertical size */
	if (new_frame_length >= OV5640_last_frame_length)
	{
		OV5640_write_cmos_sensor(0x380e, (new_frame_length>>8) & 0xFF);
		OV5640_write_cmos_sensor(0x380f, (new_frame_length & 0xFF));
	}
	else
	{
		OV5640_write_cmos_sensor(0x380f, (new_frame_length & 0xFF));
		OV5640_write_cmos_sensor(0x380e, (new_frame_length>>8) & 0xFF);
	}

	OV5640_last_line_length = new_line_length;
	OV5640_last_frame_length = new_frame_length;
} /* OV5640_set_dummy */

/*************************************************************************
* FUNCTION
* OV5640_set_shutter
*
* DESCRIPTION
* This function set e-shutter of OV5640 to change exposure time.
*
* PARAMETERS
* shutter : exposured lines
*
* RETURNS
* None
*
* GLOBALS AFFECTED
*
*************************************************************************/
void OV5640_set_shutter(kal_uint32 shutter)
{
	kal_uint32 max_shutter = 0;
	kal_uint32 extra_dummy_lines = 0;
	kal_uint32 frame_length = 0;

	//if (OV5640_exposure_lines == shutter)
	//	return ;

	OV5640_exposure_lines = shutter;

	if (KAL_TRUE == OV5640_PV_mode)
	{
		max_shutter = OV5640_PV_PERIOD_LINE_NUMS + OV5640_PV_dummy_lines - 4;
	}
	else
	{
		max_shutter = OV5640_FULL_PERIOD_LINE_NUMS + OV5640_Cap_dummy_lines - 4;
	}

	if (OV5640_exposure_lines > max_shutter)
		extra_dummy_lines = OV5640_exposure_lines - max_shutter;
	else
		extra_dummy_lines = 0;

	if (KAL_TRUE == OV5640_PV_mode)			//SXGA size output
	{
		frame_length = OV5640_PV_PERIOD_LINE_NUMS + OV5640_PV_dummy_lines + extra_dummy_lines;
	}
	else									//QSXGA size output
	{
		frame_length = OV5640_FULL_PERIOD_LINE_NUMS + OV5640_Cap_dummy_lines + extra_dummy_lines;
	}
	
	/* Set Total vertical size */
	if (frame_length >= OV5640_last_frame_length)
	{
		OV5640_write_cmos_sensor(0x380e, (frame_length>>8) & 0xFF);
		OV5640_write_cmos_sensor(0x380f, (frame_length & 0xFF));
	}
	else
	{
		OV5640_write_cmos_sensor(0x380f, (frame_length & 0xFF));
		OV5640_write_cmos_sensor(0x380e, (frame_length>>8) & 0xFF);
	}
	OV5640_last_frame_length = frame_length;

	OV5640_TRACE("[OV5640_set_shutter] OV5640_exposure_lines=%d,frame_length=%d\n", OV5640_exposure_lines, frame_length);

	/* Shutter = 0x3500<<12 + 0x3501<<4 + x3502>>4 */
	OV5640_write_cmos_sensor(0x3500, (OV5640_exposure_lines>>12) & 0x0F);
	OV5640_write_cmos_sensor(0x3501, (OV5640_exposure_lines>>4) & 0xFF);
	OV5640_write_cmos_sensor(0x3502, (OV5640_exposure_lines<<4) & 0xF0);	/* Don't use the fraction part. */
}


/*************************************************************************
* FUNCTION
* OV5640_get_gain
*
* DESCRIPTION
* This function is to get global gain to sensor.
*
* PARAMETERS
* boid
*
* RETURNS
* the actually gain set to sensor.
*
* GLOBALS AFFECTED
*
*************************************************************************/
kal_uint32 OV5640_get_gain(void)
{
	kal_uint32 reg_gain = 0;
	kal_uint32 analog_gain = 0;

	reg_gain = OV5640_read_cmos_sensor(0x350b);

	analog_gain = (reg_gain * BASEGAIN) / 16;		/* 1x sensor gain. */

	OV5640_TRACE("[OV5640_set_gain] analog_gain=%d, Reg=%x\n", analog_gain, reg_gain);

	return reg_gain;
}


/*************************************************************************
* FUNCTION
* OV5640_set_gain
*
* DESCRIPTION
* This function is to set global gain to sensor.
*
* PARAMETERS
* gain : sensor global gain(base: 0x40)
*
* RETURNS
* the actually gain set to sensor.
*
* GLOBALS AFFECTED
*
*************************************************************************/
kal_uint32 OV5640_set_gain(kal_uint32 analog_gain)
{
	kal_uint32 reg_gain = 0;

	static kal_uint32 last_analog_gain = 0;

	//if (last_analog_gain == analog_gain)
	//	return 64;

	last_analog_gain = analog_gain;

	analog_gain = (analog_gain * OV5640_sensor_gain_base) / BASEGAIN;

	if (analog_gain >= 16*BASEGAIN)		/* Limit max gain to 16x, it's enough for mobile phone */
	{
		/* Warning, Gain exeed the limitation. */
		OV5640_TRACE("Warning, Gain=%x exeed the limitation 32x\n", analog_gain);
		return 0;
	}

	reg_gain = (analog_gain * 16) / BASEGAIN;

	OV5640_TRACE("[OV5640_set_gain] analog_gain=%d, Reg=%x\n", analog_gain, reg_gain);

	OV5640_write_cmos_sensor(0x350b, reg_gain);

	return reg_gain;
}

/*************************************************************************
* FUNCTION
* OV5640_night_mode
*
* DESCRIPTION
* This function night mode of OV5640.
*
* PARAMETERS
* none
*
* RETURNS
* None
*
* GLOBALS AFFECTED
*
*************************************************************************/
void OV5640_night_mode(kal_bool enable)
{
	/* No need or raw sensor, it use function OV5640SetVideoMode to fix the frame rate. */
} /* OV5640_night_mode */

/*************************************************************************
* FUNCTION
*	OV5640SetMirror
*
* DESCRIPTION
*	This function mirror, flip or mirror & flip the sensor output image.
*
*	IMPORTANT NOTICE: For some sensor, it need re-set the output order RGrGbB after
*	mirror or flip.
*
* PARAMETERS
*	1. kal_uint16 : horizontal mirror or vertical flip direction.
*
* RETURNS
*	None
*
*************************************************************************/
void OV5640SetMirror(UINT32 image_mirror)
{
	UINT32 curr_mirror = 0, curr_flip = 0;

	// TODO: For debug the V project only.
#if defined(SIMCOM_I3200)	
	image_mirror = IMAGE_V_MIRROR;
#else
	image_mirror = IMAGE_H_MIRROR;
#endif

	OV5640_sensor_mirror_flip = image_mirror;

	curr_flip = (OV5640_read_cmos_sensor(0x3820) & 0xF9);		/* bit[1]-Sensor Flip, bit[2]-ISP Flip */
	curr_mirror = (OV5640_read_cmos_sensor(0x3821) & 0xF9);	/* bit[1]-Sensor Mirror, bit[2]-ISP Mirror */	
	
	switch (image_mirror)
	{
	case IMAGE_NORMAL:
		/* Do nothing. */
		break;
	case IMAGE_H_MIRROR:
		curr_mirror |= 0x06; 
		break;
	case IMAGE_V_MIRROR:
		curr_flip |= 0x06;
		break;
	case IMAGE_HV_MIRROR:
		curr_mirror |= 0x06;
		curr_flip |= 0x06;
		break;
	default:
		break;
	}

	OV5640_write_cmos_sensor(0x3820, curr_flip);
	OV5640_write_cmos_sensor(0x3821, curr_mirror);
}


/*************************************************************************
* FUNCTION
*   OV5640GetSensorID
*
* DESCRIPTION
*   This function get the sensor ID 
*
* PARAMETERS
*   *sensor_id : return the sensor ID 
*
* RETURNS
*   None
*
* GLOBALS AFFECTED
*
*************************************************************************/
UINT32 OV5640GetSensorID(UINT32 *sensor_id) 
{
    *sensor_id = (OV5640_read_cmos_sensor(0x300A)<<8) | OV5640_read_cmos_sensor(0x300B);
	
    if (*sensor_id != OV5640_SENSOR_ID)
	{
		OV5640_TRACE("Read Sensor ID Fail = 0x%04x\n", *sensor_id); 
        *sensor_id = 0xFFFFFFFF; 
		
        return ERROR_SENSOR_CONNECT_FAIL;
    }
	
    return ERROR_NONE;
}

/*****************************************************************************/
/* Windows Mobile Sensor Interface */
/*****************************************************************************/
/*************************************************************************
* FUNCTION
* OV5640Open
*
* DESCRIPTION
* This function initialize the registers of CMOS sensor
*
* PARAMETERS
* None
*
* RETURNS
* None
*
* GLOBALS AFFECTED
*
*************************************************************************/
UINT32 OV5640Open(void)
{
	volatile signed char i;
	kal_uint16 sensor_id = 0;

	mdelay(10);
	OV5640_write_cmos_sensor(0x3008, 0x82);    // Do the software reset
	mdelay(20); 

	//  Read sensor ID to adjust I2C is OK?
	sensor_id = (OV5640_read_cmos_sensor(0x300A)<<8) | OV5640_read_cmos_sensor(0x300B);
	OV5640_TRACE("OV5640 Sensor ID =%x \n", sensor_id); 

	if (sensor_id != OV5640_SENSOR_ID)
	{
		return ERROR_SENSOR_CONNECT_FAIL;
	}

	OV5640InitialSetting();
	
	return ERROR_NONE;
} /* OV5640Open() */

/*************************************************************************
* FUNCTION
* OV5640Close
*
* DESCRIPTION
* This function is to turn off sensor module power.
*
* PARAMETERS
* None
*
* RETURNS
* None
*
* GLOBALS AFFECTED
*
*************************************************************************/
UINT32 OV5640Close(void)
{
   mdelay(20); 
  return ERROR_NONE;
} /* OV5640Close() */

/*************************************************************************
* FUNCTION
* OV5640Preview
*
* DESCRIPTION
* This function start the sensor preview.
*
* PARAMETERS
* *image_window : address pointer of pixel numbers in one period of HSYNC
*  *sensor_config_data : address pointer of line numbers in one period of VSYNC
*
* RETURNS
* None
*
* GLOBALS AFFECTED
*
*************************************************************************/
UINT32 OV5640Preview(MSDK_SENSOR_EXPOSURE_WINDOW_STRUCT *image_window,
					  MSDK_SENSOR_CONFIG_STRUCT *sensor_config_data)
{
	kal_uint32 backup_PV_dummy_lines;

	OV5640_TRACE("OV5640Preview, op_mode=%x, mirror=%d, Size=%d x %d\n", \
		sensor_config_data->SensorOperationMode, sensor_config_data->SensorImageMirror, \
		image_window->ImageTargetWidth, image_window->ImageTargetHeight);

	OV5640PvSetting();

	OV5640_current_sensor_expo_width = OV5640_sensor_expo_width;    // No TV out

	OV5640_PV_dummy_pixels = 0;
	OV5640_PV_dummy_lines = 0;

	OV5640SetMirror(sensor_config_data->SensorImageMirror);

	OV5640_set_shutter(OV5640_exposure_lines);

	/* Config Image Window */
	image_window->GrabStartX		= OV5640_IMAGE_SENSOR_PV_INSERTED_PIXELS;
	image_window->GrabStartY		= OV5640_IMAGE_SENSOR_PV_INSERTED_LINES;
	image_window->ExposureWindowWidth	= OV5640_IMAGE_SENSOR_PV_WIDTH;
	image_window->ExposureWindowHeight	= OV5640_IMAGE_SENSOR_PV_HEIGHT;

	image_window->CurrentExposurePixel=OV5640_current_sensor_expo_width;
	image_window->ExposurePixel=OV5640_sensor_expo_width;

	memcpy(&OV5640SensorConfigData, sensor_config_data, sizeof(MSDK_SENSOR_CONFIG_STRUCT));

	return ERROR_NONE;
}	/* OV5640Preview() */

UINT32 OV5640Capture(MSDK_SENSOR_EXPOSURE_WINDOW_STRUCT *image_window,
					  MSDK_SENSOR_CONFIG_STRUCT *sensor_config_data)
{
	volatile kal_uint32 shutter = OV5640_exposure_lines;

	OV5640_TRACE("OV5640Capture, op_mode=%x, mirror=%d, Size=%d x %d\n", \
		sensor_config_data->SensorOperationMode, sensor_config_data->SensorImageMirror, \
		image_window->ImageTargetWidth, image_window->ImageTargetHeight);

	OV5640CapSetting();

	OV5640SetMirror(OV5640_sensor_mirror_flip);

	OV5640_Cap_dummy_pixels = 0;
	OV5640_Cap_dummy_lines = 0;

	OV5640_TRACE("OV5640Capture II, Input shutter=%d\n", shutter);

	shutter = ((shutter*(OV5640_PV_PERIOD_PIXEL_NUMS+OV5640_PV_dummy_pixels)+((OV5640_FULL_PERIOD_PIXEL_NUMS+OV5640_Cap_dummy_pixels)>>1))/(OV5640_FULL_PERIOD_PIXEL_NUMS+OV5640_Cap_dummy_pixels));

	OV5640_TRACE("OV5640Capture II, Output shutter=%d\n", shutter);

	if (shutter < 1)
		shutter = 1;
	
	OV5640_set_shutter(shutter);

	image_window->GrabStartX		= OV5640_IMAGE_SENSOR_FULL_INSERTED_PIXELS;
	image_window->GrabStartY		= OV5640_IMAGE_SENSOR_FULL_INSERTED_LINES;
	image_window->ExposureWindowWidth	= OV5640_IMAGE_SENSOR_FULL_WIDTH;
	image_window->ExposureWindowHeight	= OV5640_IMAGE_SENSOR_FULL_HEIGHT;

	// Config flashlight preview setting
	sensor_config_data->DefaultPclk = 48000000;
	sensor_config_data->Pixels = OV5640_FULL_PERIOD_PIXEL_NUMS+OV5640_Cap_dummy_pixels;
	sensor_config_data->FrameLines = OV5640_FULL_PERIOD_LINE_NUMS+OV5640_Cap_dummy_lines;
	sensor_config_data->Lines = image_window->ExposureWindowHeight;
	sensor_config_data->Shutter = shutter;

	memcpy(&OV5640SensorConfigData, sensor_config_data, sizeof(MSDK_SENSOR_CONFIG_STRUCT));
	
	return ERROR_NONE;
}	/* OV5640Capture() */

UINT32 OV5640GetResolution(MSDK_SENSOR_RESOLUTION_INFO_STRUCT *pSensorResolution)
{
	pSensorResolution->SensorPreviewWidth	= OV5640_IMAGE_SENSOR_PV_WIDTH;
	pSensorResolution->SensorPreviewHeight	= OV5640_IMAGE_SENSOR_PV_HEIGHT;
	pSensorResolution->SensorFullWidth		= OV5640_IMAGE_SENSOR_FULL_WIDTH;
	pSensorResolution->SensorFullHeight 	= OV5640_IMAGE_SENSOR_FULL_HEIGHT;

	return ERROR_NONE;
}	/* OV5640GetResolution() */

UINT32 OV5640GetInfo(MSDK_SCENARIO_ID_ENUM ScenarioId,
							MSDK_SENSOR_INFO_STRUCT *pSensorInfo,
							MSDK_SENSOR_CONFIG_STRUCT *pSensorConfigData)
{
	ACDK_ISP_BINNING_INFO_STRUCT *OV5640_ISO_Binning_Info = NULL;
		
	pSensorInfo->SensorPreviewResolutionX		= OV5640_IMAGE_SENSOR_PV_WIDTH;
	pSensorInfo->SensorPreviewResolutionY		= OV5640_IMAGE_SENSOR_PV_HEIGHT;
	pSensorInfo->SensorFullResolutionX			= OV5640_IMAGE_SENSOR_FULL_WIDTH;
	pSensorInfo->SensorFullResolutionY			= OV5640_IMAGE_SENSOR_FULL_HEIGHT;

	pSensorInfo->SensorCameraPreviewFrameRate	= 30;
	pSensorInfo->SensorVideoFrameRate			= 30;
	pSensorInfo->SensorStillCaptureFrameRate	= 10;
	pSensorInfo->SensorWebCamCaptureFrameRate	= 15;
	pSensorInfo->SensorResetActiveHigh			= FALSE;
	pSensorInfo->SensorResetDelayCount			= 1;
	pSensorInfo->SensorOutputDataFormat			= SENSOR_OUTPUT_FORMAT_RAW_Gr;

	/* Configure the VSYNC, HSYNC, PCLK polarity. */
	pSensorInfo->SensorClockPolarity			= SENSOR_CLOCK_POLARITY_LOW;
	pSensorInfo->SensorClockFallingPolarity		= SENSOR_CLOCK_POLARITY_LOW;
	pSensorInfo->SensorHsyncPolarity			= SENSOR_CLOCK_POLARITY_LOW;	// HSync, High Valid
	pSensorInfo->SensorVsyncPolarity			= SENSOR_CLOCK_POLARITY_LOW;	// VSync, Low Valid
	
	pSensorInfo->SensorInterruptDelayLines		= 1;
	pSensorInfo->SensroInterfaceType			= SENSOR_INTERFACE_TYPE_PARALLEL;

	/* Configure the iso & binning support information. */
	OV5640_ISO_Binning_Info = pSensorInfo->SensorISOBinningInfo.ISOBinningInfo;

	OV5640_ISO_Binning_Info[ISO_100_MODE].MaxWidth		= OV5640_CAM_SIZE_5M_WIDTH;
	OV5640_ISO_Binning_Info[ISO_100_MODE].MaxHeight		= OV5640_CAM_SIZE_5M_HEIGHT;
	OV5640_ISO_Binning_Info[ISO_100_MODE].ISOSupported	= TRUE;
	OV5640_ISO_Binning_Info[ISO_100_MODE].BinningEnable	= FALSE;

	OV5640_ISO_Binning_Info[ISO_200_MODE].MaxWidth		= OV5640_CAM_SIZE_5M_WIDTH;
	OV5640_ISO_Binning_Info[ISO_200_MODE].MaxHeight		= OV5640_CAM_SIZE_5M_HEIGHT;
	OV5640_ISO_Binning_Info[ISO_200_MODE].ISOSupported	= TRUE;
	OV5640_ISO_Binning_Info[ISO_200_MODE].BinningEnable	= FALSE;

	OV5640_ISO_Binning_Info[ISO_400_MODE].MaxWidth		= OV5640_CAM_SIZE_5M_WIDTH;
	OV5640_ISO_Binning_Info[ISO_400_MODE].MaxHeight		= OV5640_CAM_SIZE_5M_HEIGHT;
	OV5640_ISO_Binning_Info[ISO_400_MODE].ISOSupported	= TRUE;
	OV5640_ISO_Binning_Info[ISO_400_MODE].BinningEnable	= FALSE;

	OV5640_ISO_Binning_Info[ISO_800_MODE].MaxWidth		= OV5640_CAM_SIZE_1M_WIDTH;
	OV5640_ISO_Binning_Info[ISO_800_MODE].MaxHeight		= OV5640_CAM_SIZE_1M_HEIGHT;
	OV5640_ISO_Binning_Info[ISO_800_MODE].ISOSupported	= TRUE;
	OV5640_ISO_Binning_Info[ISO_800_MODE].BinningEnable	= TRUE;

	OV5640_ISO_Binning_Info[ISO_1600_MODE].MaxWidth		= OV5640_CAM_SIZE_1M_WIDTH;
	OV5640_ISO_Binning_Info[ISO_1600_MODE].MaxHeight	= OV5640_CAM_SIZE_1M_HEIGHT;
	OV5640_ISO_Binning_Info[ISO_1600_MODE].ISOSupported	= TRUE;
	OV5640_ISO_Binning_Info[ISO_1600_MODE].BinningEnable= TRUE;

	pSensorInfo->CaptureDelayFrame 			= 2; 
	pSensorInfo->PreviewDelayFrame 			= 5; 
	pSensorInfo->VideoDelayFrame 			= 6; 
	
	pSensorInfo->SensorDrivingCurrent 		= ISP_DRIVING_2MA;   	
	pSensorInfo->AEShutDelayFrame 			= 0;		/* The frame of setting shutter default 0 for TG int */
	pSensorInfo->AESensorGainDelayFrame 	= 0;		/* The frame of setting sensor gain */
	pSensorInfo->AEISPGainDelayFrame 		= 1;	

	switch (ScenarioId)
	{
		case MSDK_SCENARIO_ID_CAMERA_PREVIEW:
		case MSDK_SCENARIO_ID_VIDEO_PREVIEW:
		case MSDK_SCENARIO_ID_VIDEO_CAPTURE_MPEG4:
		case MSDK_SCENARIO_ID_CAMERA_CAPTURE_JPEG:
		case MSDK_SCENARIO_ID_CAMERA_CAPTURE_MEM:
			pSensorInfo->SensorMasterClockSwitch 	= 0; 	/* Select the master clock source, 0: 52Mhz, 1: 48Mhz */
			pSensorInfo->SensorClockFreq			= 26;
			pSensorInfo->SensorClockDividCount		= 3;		/* Not used now. */
			pSensorInfo->SensorClockRisingCount		= 0;		/* Not used now. */
			pSensorInfo->SensorClockFallingCount	= 2;		/* Not used now. */
			
			pSensorInfo->SensorPixelClockCount		= 3;		/* Not used now. */
			pSensorInfo->SensorDataLatchCount		= 2;		/* Not used now. */
			
			pSensorInfo->SensorGrabStartX 			= OV5640_IMAGE_SENSOR_PV_INSERTED_PIXELS;
			pSensorInfo->SensorGrabStartY 			= OV5640_IMAGE_SENSOR_PV_INSERTED_LINES;
		break;
	}
	
	memcpy(pSensorConfigData, &OV5640SensorConfigData, sizeof(MSDK_SENSOR_CONFIG_STRUCT));
	
	return ERROR_NONE;
}	/* OV5640GetInfo() */


UINT32 OV5640Control(MSDK_SCENARIO_ID_ENUM ScenarioId, MSDK_SENSOR_EXPOSURE_WINDOW_STRUCT *pImageWindow,
					  MSDK_SENSOR_CONFIG_STRUCT *pSensorConfigData)
{
	switch (ScenarioId)
	{
		case MSDK_SCENARIO_ID_CAMERA_PREVIEW:
		case MSDK_SCENARIO_ID_VIDEO_PREVIEW:
		case MSDK_SCENARIO_ID_VIDEO_CAPTURE_MPEG4:
			OV5640Preview(pImageWindow, pSensorConfigData);
		break;
		case MSDK_SCENARIO_ID_CAMERA_CAPTURE_JPEG:
		case MSDK_SCENARIO_ID_CAMERA_CAPTURE_MEM:
			OV5640Capture(pImageWindow, pSensorConfigData);
		break;
        default:
            return ERROR_INVALID_SCENARIO_ID;
	}
	return TRUE;
}	/* OV5640Control() */

UINT32 OV5640SetVideoMode(UINT16 u2FrameRate)
{
    kal_uint16 video_frame_rate = u2FrameRate;
	kal_uint32 line_length = 0, frame_length = 0;

	OV5640_TRACE("[OV5640SetVideoMode] fix frame rate video_frame_rate=%d", video_frame_rate);

	line_length = OV5640_PV_PERIOD_PIXEL_NUMS + OV5640_PV_dummy_pixels;
	frame_length = OV5640_sensor_pclk / video_frame_rate / line_length;

	if (frame_length <= OV5640_PV_PERIOD_LINE_NUMS)
	{
		frame_length = OV5640_PV_PERIOD_LINE_NUMS;

		OV5640_TRACE("Warining!!! Target frame rate exeed sensor limitation: tar=%d, lim=%d", \
			video_frame_rate, OV5640_sensor_pclk / line_length / frame_length);

		video_frame_rate = OV5640_sensor_pclk /(OV5640_PV_PERIOD_PIXEL_NUMS + OV5640_PV_dummy_pixels) / (OV5640_PV_PERIOD_LINE_NUMS);
	}

	OV5640_PV_dummy_lines = frame_length - OV5640_PV_PERIOD_LINE_NUMS;

	OV5640_set_dummy(OV5640_PV_dummy_pixels, OV5640_PV_dummy_lines);

    return TRUE;
}

UINT32 OV5640FeatureControl(MSDK_SENSOR_FEATURE_ENUM FeatureId,
							 UINT8 *pFeaturePara,UINT32 *pFeatureParaLen)
{
    UINT16 *pFeatureReturnPara16=(UINT16 *) pFeaturePara;
    UINT16 *pFeatureData16=(UINT16 *) pFeaturePara;
	UINT32 *pFeatureReturnPara32=(UINT32 *) pFeaturePara;
	UINT32 *pFeatureData32=(UINT32 *) pFeaturePara;
	UINT32 SensorRegNumber;
	UINT32 i;
	PNVRAM_SENSOR_DATA_STRUCT pSensorDefaultData=(PNVRAM_SENSOR_DATA_STRUCT) pFeaturePara;
	MSDK_SENSOR_CONFIG_STRUCT *pSensorConfigData=(MSDK_SENSOR_CONFIG_STRUCT *) pFeaturePara;
    MSDK_SENSOR_REG_INFO_STRUCT *pSensorRegData=(MSDK_SENSOR_REG_INFO_STRUCT *) pFeaturePara;
    MSDK_SENSOR_GROUP_INFO_STRUCT *pSensorGroupInfo=(MSDK_SENSOR_GROUP_INFO_STRUCT *) pFeaturePara;
    MSDK_SENSOR_ITEM_INFO_STRUCT *pSensorItemInfo=(MSDK_SENSOR_ITEM_INFO_STRUCT *) pFeaturePara;
	MSDK_SENSOR_ENG_INFO_STRUCT	*pSensorEngInfo=(MSDK_SENSOR_ENG_INFO_STRUCT *) pFeaturePara;		
	PSET_SENSOR_CALIBRATION_DATA_STRUCT pSetSensorCalData=(PSET_SENSOR_CALIBRATION_DATA_STRUCT)pFeaturePara;
	switch (FeatureId)
	{
      case SENSOR_FEATURE_GET_RESOLUTION:
          *pFeatureReturnPara16++=OV5640_IMAGE_SENSOR_FULL_WIDTH;
          *pFeatureReturnPara16=OV5640_IMAGE_SENSOR_FULL_HEIGHT;
          *pFeatureParaLen=4;
      break;
      case SENSOR_FEATURE_GET_PERIOD:
          *pFeatureReturnPara16++=OV5640_PV_PERIOD_PIXEL_NUMS+OV5640_PV_dummy_pixels;
          *pFeatureReturnPara16=OV5640_PV_PERIOD_LINE_NUMS+OV5640_PV_dummy_lines;
          *pFeatureParaLen=4;
      break;
      case SENSOR_FEATURE_GET_PIXEL_CLOCK_FREQ:
          *pFeatureReturnPara32 = OV5640_sensor_pclk;
          *pFeatureParaLen=4;
      break;
		case SENSOR_FEATURE_SET_ESHUTTER:
			OV5640_set_shutter(*pFeatureData16);
		break;
		case SENSOR_FEATURE_SET_NIGHTMODE:
			OV5640_night_mode((BOOL) *pFeatureData16);
		break;
		case SENSOR_FEATURE_SET_GAIN:
			OV5640_set_gain((UINT16) *pFeatureData16);
		break;
        case SENSOR_FEATURE_SET_FLASHLIGHT:
        break;
		case SENSOR_FEATURE_SET_ISP_MASTER_CLOCK_FREQ:
            OV5640_isp_master_clock=*pFeatureData32;
		break;
		case SENSOR_FEATURE_SET_REGISTER:
			if (pSensorRegData->RegAddr == 0xFFF0)		/* Set shutter */
			{
				OV5640_set_shutter(pSensorRegData->RegData);
			}
			else if (pSensorRegData->RegAddr == 0xFFF1)	/* Set Dummy lines */
			{
				OV5640_set_dummy(0, pSensorRegData->RegData);
			}
			else if (pSensorRegData->RegAddr == 0xFFF2)	/* Set Gain */
			{
				OV5640_set_gain(pSensorRegData->RegData);
			}
			else
			{
           		OV5640_write_cmos_sensor(pSensorRegData->RegAddr, pSensorRegData->RegData);
			}
		break;
		case SENSOR_FEATURE_GET_REGISTER:
            pSensorRegData->RegData = OV5640_read_cmos_sensor(pSensorRegData->RegAddr);
		break;
		case SENSOR_FEATURE_SET_CCT_REGISTER:
			SensorRegNumber=FACTORY_END_ADDR;
			for (i=0;i<SensorRegNumber;i++)
			{
				OV5640SensorCCT[i].Addr=*pFeatureData32++;
				OV5640SensorCCT[i].Para=*pFeatureData32++;
			}
		break;
        case SENSOR_FEATURE_GET_CCT_REGISTER:
            SensorRegNumber=FACTORY_END_ADDR;
            if (*pFeatureParaLen<(SensorRegNumber*sizeof(SENSOR_REG_STRUCT)+4))
                return FALSE;
            *pFeatureData32++=SensorRegNumber;
            for (i=0;i<SensorRegNumber;i++)
            {
                *pFeatureData32++=OV5640SensorCCT[i].Addr;
                *pFeatureData32++=OV5640SensorCCT[i].Para;
            }
        break;
		case SENSOR_FEATURE_SET_ENG_REGISTER:

			SensorRegNumber=ENGINEER_END;
			for (i=0;i<SensorRegNumber;i++)
			{
				OV5640SensorReg[i].Addr=*pFeatureData32++;
				OV5640SensorReg[i].Para=*pFeatureData32++;
			}
		break;
        case SENSOR_FEATURE_GET_ENG_REGISTER:
            SensorRegNumber=ENGINEER_END;
            if (*pFeatureParaLen<(SensorRegNumber*sizeof(SENSOR_REG_STRUCT)+4))
                return FALSE;
            *pFeatureData32++=SensorRegNumber;
            for (i=0;i<SensorRegNumber;i++)
            {
                *pFeatureData32++=OV5640SensorReg[i].Addr;
                *pFeatureData32++=OV5640SensorReg[i].Para;
            }
        break;
		case SENSOR_FEATURE_GET_REGISTER_DEFAULT:
			if (*pFeatureParaLen>=sizeof(NVRAM_SENSOR_DATA_STRUCT))
			{
				pSensorDefaultData->Version=NVRAM_CAMERA_SENSOR_FILE_VERSION;
				pSensorDefaultData->SensorId=OV5640_SENSOR_ID;
				memcpy(pSensorDefaultData->SensorEngReg, OV5640SensorReg, sizeof(SENSOR_REG_STRUCT)*ENGINEER_END);
				memcpy(pSensorDefaultData->SensorCCTReg, OV5640SensorCCT, sizeof(SENSOR_REG_STRUCT)*FACTORY_END_ADDR);
			}
			else
				return FALSE;
			*pFeatureParaLen=sizeof(NVRAM_SENSOR_DATA_STRUCT);
		break;
		case SENSOR_FEATURE_GET_CONFIG_PARA:
			memcpy(pSensorConfigData, &OV5640SensorConfigData, sizeof(MSDK_SENSOR_CONFIG_STRUCT));
			*pFeatureParaLen=sizeof(MSDK_SENSOR_CONFIG_STRUCT);
			break;
		case SENSOR_FEATURE_CAMERA_PARA_TO_SENSOR:
            OV5640_camera_para_to_sensor();
		break;
		case SENSOR_FEATURE_SENSOR_TO_CAMERA_PARA:
            OV5640_sensor_to_camera_para();
		break;
		case SENSOR_FEATURE_GET_GROUP_COUNT:
            *pFeatureReturnPara32++=OV5640_get_sensor_group_count();
			*pFeatureParaLen=4;
		break;
		case SENSOR_FEATURE_GET_GROUP_INFO:
            OV5640_get_sensor_group_info(pSensorGroupInfo->GroupIdx, pSensorGroupInfo->GroupNamePtr, &pSensorGroupInfo->ItemCount);
			*pFeatureParaLen=sizeof(MSDK_SENSOR_GROUP_INFO_STRUCT);
		break;
		case SENSOR_FEATURE_GET_ITEM_INFO:
            OV5640_get_sensor_item_info(pSensorItemInfo->GroupIdx,pSensorItemInfo->ItemIdx, pSensorItemInfo);
			*pFeatureParaLen=sizeof(MSDK_SENSOR_ITEM_INFO_STRUCT);
		break;
		case SENSOR_FEATURE_SET_ITEM_INFO:
            OV5640_set_sensor_item_info(pSensorItemInfo->GroupIdx, pSensorItemInfo->ItemIdx, pSensorItemInfo->ItemValue);
			*pFeatureParaLen=sizeof(MSDK_SENSOR_ITEM_INFO_STRUCT);
		break;
		case SENSOR_FEATURE_GET_ENG_INFO:
			pSensorEngInfo->SensorId = 150;
			pSensorEngInfo->SensorType = CMOS_SENSOR;
			pSensorEngInfo->SensorOutputDataFormat=SENSOR_OUTPUT_FORMAT_RAW_Gr;
			*pFeatureParaLen=sizeof(MSDK_SENSOR_ENG_INFO_STRUCT);
		break;
		case SENSOR_FEATURE_GET_LENS_DRIVER_ID:
			// get the lens driver ID from EEPROM or just return LENS_DRIVER_ID_DO_NOT_CARE
			// if EEPROM does not exist in camera module.
			*pFeatureReturnPara32=LENS_DRIVER_ID_DO_NOT_CARE;
			*pFeatureParaLen=4;
		break;
		case SENSOR_FEATURE_SET_VIDEO_MODE:
			OV5640SetVideoMode(*pFeatureData16);
		break; 
		case SENSOR_FEATURE_CHECK_SENSOR_ID:
            OV5640GetSensorID(pFeatureReturnPara32); 
        break; 
		default:
			break;
	}
	return ERROR_NONE;
}	/* OV5640FeatureControl() */

SENSOR_FUNCTION_STRUCT	SensorFuncOV5640=
{
	OV5640Open,
	OV5640GetInfo,
	OV5640GetResolution,
	OV5640FeatureControl,
	OV5640Control,
	OV5640Close
};

UINT32 OV5640SensorInit(PSENSOR_FUNCTION_STRUCT *pfFunc)
{

  /* To Do : Check Sensor status here */
  if (pfFunc != NULL)
      *pfFunc = &SensorFuncOV5640;

  return ERROR_NONE;
} /* OV5640SensorInit() */


