/* Copyright Statement:
 *
 * This software/firmware and related documentation ("MediaTek Software") are
 * protected under relevant copyright laws. The information contained herein
 * is confidential and proprietary to MediaTek Inc. and/or its licensors.
 * Without the prior written permission of MediaTek inc. and/or its licensors,
 * any reproduction, modification, use or disclosure of MediaTek Software,
 * and information contained herein, in whole or in part, shall be strictly prohibited.
 */
/* MediaTek Inc. (C) 2010. All rights reserved.
 *
 * BY OPENING THIS FILE, RECEIVER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND AGREES
 * THAT THE SOFTWARE/FIRMWARE AND ITS DOCUMENTATIONS ("MEDIATEK SOFTWARE")
 * RECEIVED FROM MEDIATEK AND/OR ITS REPRESENTATIVES ARE PROVIDED TO RECEIVER ON
 * AN "AS-IS" BASIS ONLY. MEDIATEK EXPRESSLY DISCLAIMS ANY AND ALL WARRANTIES,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR NONINFRINGEMENT.
 * NEITHER DOES MEDIATEK PROVIDE ANY WARRANTY WHATSOEVER WITH RESPECT TO THE
 * SOFTWARE OF ANY THIRD PARTY WHICH MAY BE USED BY, INCORPORATED IN, OR
 * SUPPLIED WITH THE MEDIATEK SOFTWARE, AND RECEIVER AGREES TO LOOK ONLY TO SUCH
 * THIRD PARTY FOR ANY WARRANTY CLAIM RELATING THERETO. RECEIVER EXPRESSLY ACKNOWLEDGES
 * THAT IT IS RECEIVER'S SOLE RESPONSIBILITY TO OBTAIN FROM ANY THIRD PARTY ALL PROPER LICENSES
 * CONTAINED IN MEDIATEK SOFTWARE. MEDIATEK SHALL ALSO NOT BE RESPONSIBLE FOR ANY MEDIATEK
 * SOFTWARE RELEASES MADE TO RECEIVER'S SPECIFICATION OR TO CONFORM TO A PARTICULAR
 * STANDARD OR OPEN FORUM. RECEIVER'S SOLE AND EXCLUSIVE REMEDY AND MEDIATEK'S ENTIRE AND
 * CUMULATIVE LIABILITY WITH RESPECT TO THE MEDIATEK SOFTWARE RELEASED HEREUNDER WILL BE,
 * AT MEDIATEK'S OPTION, TO REVISE OR REPLACE THE MEDIATEK SOFTWARE AT ISSUE,
 * OR REFUND ANY SOFTWARE LICENSE FEES OR SERVICE CHARGE PAID BY RECEIVER TO
 * MEDIATEK FOR SUCH MEDIATEK SOFTWARE AT ISSUE.
 *
 * The following software/firmware and/or related documentation ("MediaTek Software")
 * have been modified by MediaTek Inc. All revisions are subject to any receiver's
 * applicable license agreements with MediaTek Inc.
 */

 
#include "tpd.h"
#include <linux/interrupt.h>
#include <cust_eint.h>
#include <linux/i2c.h>
#include <linux/sched.h>
#include <linux/kthread.h>
#include <linux/rtpm_prio.h>
#include <linux/wait.h>
#include <linux/time.h>
#include <linux/delay.h>

#include "tpd_custom_mms100.h"
#ifdef MT6575
#include <mach/mt6575_pm_ldo.h>
#include <mach/mt6575_typedefs.h>
#include <mach/mt6575_boot.h>
#endif
#include "bin_isc.h"
#include "cust_gpio_usage.h"

#include "melfas_ts.h"
//#include "bin_tsp.h"

extern struct tpd_device *tpd;
 
static struct i2c_client *i2c_client = NULL;
static struct task_struct *thread = NULL;
enum
{
	None = 0,
	TOUCH_SCREEN,
	TOUCH_KEY
};
static DECLARE_WAIT_QUEUE_HEAD(waiter);
 
 
static void tpd_eint_interrupt_handler(void);
 
 
 extern void mt65xx_eint_unmask(unsigned int line);
 extern void mt65xx_eint_mask(unsigned int line);
 extern void mt65xx_eint_set_hw_debounce(kal_uint8 eintno, kal_uint32 ms);
 extern kal_uint32 mt65xx_eint_set_sens(kal_uint8 eintno, kal_bool sens);
 extern void mt65xx_eint_registration(kal_uint8 eintno, kal_bool Dbounce_En,
									  kal_bool ACT_Polarity, void (EINT_FUNC_PTR)(void),
									  kal_bool auto_umask);

 
static int __devinit tpd_probe(struct i2c_client *client, const struct i2c_device_id *id);
static int tpd_detect(struct i2c_client *client, int kind, struct i2c_board_info *info);
static int __devexit tpd_remove(struct i2c_client *client);
static int touch_event_handler(void *unused);
 extern int isp_fw_download(const u8 *data, size_t len);

static int tpd_flag = 0;
static int point_num = 0;

//#define TPD_CLOSE_POWER_IN_SLEEP
//#define ESD_CHECK


#define TPD_OK 0
//register define

#define TS_MAX_TOUCH 	5//Model Dependent
#define TS_READ_REGS_LEN 66 //Fixed value
#if defined(I5000_P156)
static int tsp_keycodes[4] = {KEY_MENU, KEY_HOME, KEY_BACK, KEY_BACK};
#else
static int tsp_keycodes[4] = {KEY_MENU, KEY_BACK, KEY_HOME, KEY_BACK};
#endif
static int tpd_keys_local[TPD_KEY_COUNT] = TPD_KEYS;
static int tpd_keys_dim_local[TPD_KEY_COUNT][4] = TPD_KEYS_DIM;

struct touch_info {
    int y[CFG_MAX_TOUCH_POINTS];
    int x[CFG_MAX_TOUCH_POINTS];
    int p[CFG_MAX_TOUCH_POINTS];
    int id[CFG_MAX_TOUCH_POINTS];	
    int count;
};
 
static const struct i2c_device_id tpd_id[] = {{TPD_DEVICE,0},{}};
static  unsigned short force[] = {0,0x70,I2C_CLIENT_END,I2C_CLIENT_END}; 
static const unsigned short * const forces[] = { force, NULL };
static struct i2c_client_address_data addr_data = { .forces = forces, };
 
 
 static struct i2c_driver tpd_i2c_driver = {
  .driver = {
	 .name = TPD_DEVICE,
	 .owner = THIS_MODULE,
  },
  .probe = tpd_probe,
  .remove = __devexit_p(tpd_remove),
  .id_table = tpd_id,
  .detect = tpd_detect,
  .address_data = &addr_data,
 };

 ////////////////////////////////////////////////////////////////////////////////
#if 1  //upgrade related

static u16 gen_crc(u8 data, u16 pre_crc)
{
    u16 crc;
    u16 cur;
    u16 temp;
    u16 bit_1;
    u16 bit_2;
    int i;
    crc = pre_crc;
    for (i = 7; i >= 0; i--)
    {
        cur = ((data >> i) & 0x01) ^(crc & 0x0001);
        bit_1 = cur ^(crc >> 11 & 0x01);
        bit_2 = cur ^(crc >> 4 & 0x01);
        temp = (cur << 4) | (crc >> 12 & 0x0F);
        temp = (temp << 7) | (bit_1 << 6) | (crc >> 5 & 0x3F);
        temp = (temp << 4) | (bit_2 << 3) | (crc >> 1 & 0x0007);
        crc = temp;
    }
    return crc;
}

static int isc_fw_download(const u8 *data, size_t len)
{
    u8 *buff;
    u16 crc_buf;
    int src_idx;
    int dest_idx;
    int ret;
    int i, j;

    buff = kzalloc(ISC_PKT_SIZE, GFP_KERNEL);
    if (!buff)
    {
        printk("%s: failed to allocate memory\n", __func__);
        kfree(buff);

        ret = -1;
        return ret;
    }

    /* enterring ISC mode */
    *buff = ISC_ENTER_ISC_DATA;
    ret = i2c_smbus_write_byte_data(i2c_client, ISC_ENTER_ISC_CMD, *buff);
    if (ret < 0)
    {
        printk("fail to enter ISC mode(err=%d)\n", ret);
        goto fail_to_isc_enter;
    }
    msleep(15);
    //dev_info(i2c_client.dev, "Enter ISC mode\n");

    /*enter ISC update mode */
    *buff = ISC_ENTER_UPDATE_DATA;
    ret = i2c_smbus_write_i2c_block_data(i2c_client, ISC_CMD, ISC_ENTER_UPDATE_DATA_LEN, buff);
    //ret=i2c_write_bytes(i2c_client,ISC_CMD);
    if (ret < 0)
    {
        printk("fail to enter ISC update mode(err=%d)\n", ret);
        goto fail_to_isc_update;
    }
    //dev_info(i2c_client.dev, "Enter ISC update mode\n");

    /* firmware write */
    *buff = ISC_CMD;
    *(buff + 1) = ISC_DATA_WRITE_SUB_CMD;
    for (i = 0; i < ISC_PKT_NUM; i++)
    {
        *(buff + 2) = i;                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 
        crc_buf = gen_crc(*(buff + 2), ISC_DEFAULT_CRC);
        for (j = 0; j < ISC_PKT_DATA_SIZE; j++)
        {
            dest_idx = ISC_PKT_HEADER_SIZE + j;
            src_idx = i * ISC_PKT_DATA_SIZE + ((int)(j / WORD_SIZE)) * WORD_SIZE - (j % WORD_SIZE) + 3;
            *(buff + dest_idx) = *(data + src_idx);
            crc_buf = gen_crc(*(buff + dest_idx), crc_buf);
        }
        *(buff + ISC_PKT_DATA_SIZE + ISC_PKT_HEADER_SIZE + 1) = crc_buf & 0xFF;
        *(buff + ISC_PKT_DATA_SIZE + ISC_PKT_HEADER_SIZE) = crc_buf >> 8 & 0xFF;
        ret = i2c_master_send(i2c_client, buff, ISC_PKT_SIZE);
        if (ret < 0)
        {
            printk("fail to firmware writing on packet %d.(%d)\n", i, ret);
            goto fail_to_fw_write;
        }
        udelay(5);

        /* confirm CRC */
        ret = i2c_smbus_read_byte_data(i2c_client, ISC_CHECK_STATUS_CMD);
        if (ret == ISC_CONFIRM_CRC)
        {
            //dev_info(i2c_client.dev, "updating %dth firmware data packet.\n", i);
        }
        else
        {
            printk("fail to firmware update on %dth (%X).\n", i, ret);
            ret = -1;
            goto fail_to_confirm_crc;
        }
    }
    ret = 0;

fail_to_confirm_crc:
fail_to_fw_write:
    /* exit ISC mode */
    *buff = ISC_EXIT_ISC_SUB_CMD;
    *(buff + 1) = ISC_EXIT_ISC_SUB_CMD2;
    i2c_smbus_write_i2c_block_data(i2c_client, ISC_CMD, 2, buff);
    msleep(20);

fail_to_isc_update:
fail_to_isc_enter:
    //hw_reboot_normal(info);
    kfree(buff);
    
    return ret;
}


static int check_firmware(u8 *val)
{
    int ret = 0;
    uint8_t i = 0;

    for (i = 0; i < I2C_RETRY_CNT; i++)
    {
        ret = i2c_smbus_read_i2c_block_data(i2c_client, TS_READ_HW_VER_ADDR, 1, &val[0]);
        ret = i2c_smbus_read_i2c_block_data(i2c_client, TS_READ_FW_VER_ADDR, 1, &val[1]);

        if (ret >= 0)
        {
            printk("[MMS100] : HW Revision[0x%02x] FW  Version[0x%02x] \n", val[0], val[1]);
            break; // i2c success
        }
    }

    if (ret < 0)
    {
        printk("[MMS100] %s,%d: i2c read fail[%d] \n", __FUNCTION__, __LINE__, ret);
        return ret;
    }
}

static int firmware_update(void)
{
    int ret = 0;
    uint8_t fw_ver[2] = {0, };

    //struct melfas_ts_data *info = context;
    //struct i2c_client *client = info->client;
    //struct i2c_adapter *adapter = to_i2c_adapter(client->dev.parent);


    ret = check_firmware(fw_ver);
    if (ret < 0)
        printk("[MMS100] check_firmware fail! [%d]", ret);
    else
    {
        if (fw_ver[1] != MELFAS_FW_VERSION)
        {
		int ver;
		
		printk("[MMS100] %s: \n", __func__);
		mt_set_gpio_mode(GPIO_CTP_EINT_PIN, GPIO_CTP_EINT_PIN_M_GPIO);
		mt_set_gpio_dir(GPIO_CTP_EINT_PIN, GPIO_DIR_OUT);

		//ret = isc_fw_download(MELFAS_binary, MELFAS_binary_nLength);
		ret = isp_fw_download(MELFAS_binary, MELFAS_binary_nLength);
		if (ret != 0)
		{
		    printk("[MMS100] error updating firmware to version 0x%02x \n", MELFAS_FW_VERSION);
		    ret = -1;
		}
        }
    }

    return ret;
}

#endif

static  void tpd_down(int x, int y, int p, int id) {
	// input_report_abs(tpd->dev, ABS_PRESSURE, p);
	 input_report_key(tpd->dev, BTN_TOUCH, 1);
	 input_report_abs(tpd->dev, ABS_MT_TOUCH_MAJOR, p);
	 input_report_abs(tpd->dev, ABS_MT_POSITION_X, x);
	 input_report_abs(tpd->dev, ABS_MT_POSITION_Y, y);
	 input_report_abs(tpd->dev,ABS_MT_TRACKING_ID,id);
	 printk("D[%4d %4d %4d] ", x, y, p);
	 input_mt_sync(tpd->dev);
   if (FACTORY_BOOT == get_boot_mode())
   {   
       tpd_button(x, y, 1);  
   }	 
	 TPD_DOWN_DEBUG_TRACK(x,y);
	// printk("[LONG][tp_down]X=%d,y=%d,id=%d\r\n",x,y,id);
 }
 
static  int tpd_up(int x, int y,int *count, int id) {
	 //if(*count>0) {
		 input_report_abs(tpd->dev, ABS_PRESSURE, 0);
		 input_report_key(tpd->dev, BTN_TOUCH, 0);
		 input_report_abs(tpd->dev, ABS_MT_TOUCH_MAJOR, 0);
		 input_report_abs(tpd->dev, ABS_MT_POSITION_X, x);
		 input_report_abs(tpd->dev, ABS_MT_POSITION_Y, y);
		 input_report_abs(tpd->dev,ABS_MT_TRACKING_ID,id);
		 printk("U[%4d %4d %4d] ", x, y, 0);
		 input_mt_sync(tpd->dev);
		 TPD_UP_DEBUG_TRACK(x,y);
	//	 (*count)--;
     if (FACTORY_BOOT == get_boot_mode())
     {   
        tpd_button(x, y, 0); 
     }   	
	 	// printk("[LONG][tp_up]X=%d,y=%d,id=%d\r\n",x,y,id);

		 return 1;
	 //} 
          return 0;
 }
// melfas parkyj 120510 [] insert new func.
static int tpd_read_touchinfo_for_mtk( int addr, int length, char * buffer )
{
    int StartIdx, Remains, ReadBytes;
    int ret = -1;

    StartIdx = 0; Remains = length; ReadBytes = 0;

	do{
		ReadBytes = ( Remains > 8 ) ? 8 : Remains;

		ret = i2c_smbus_read_i2c_block_data(i2c_client, (addr + StartIdx), ReadBytes, (char *)(buffer + StartIdx));

		if( ret < 0 )
		{
			TPD_DMESG("I2C transfer error, line: %d\n", __LINE__);
			break;
		}

		StartIdx += ReadBytes;
		Remains -= ReadBytes;
	} while ( Remains > 0 );

    return ret;
}

 static int tpd_touchinfo(struct touch_info *cinfo, struct touch_info *pinfo)
 {

	int i = 0;

	char data[35] = {0};
	char data1[5] = {0};
	
	int read_num, fingerID, Touch_Type = 0, keyID = 0, touchState = 0;

	u16 high_byte,low_byte;

	//p_point_num = point_num;
// melfas parkyj 120510 [[ modify begin
	if( i2c_smbus_read_i2c_block_data(i2c_client, 0x0f, 1, &(data1[0])) >= 0 )
	{
		read_num = data1[0];
		point_num = (data1[0])/6;

      TPD_DEBUG("read_num=%d, point_num =%d\n", read_num, point_num);

	if( read_num < 6 || read_num > (6*CFG_MAX_TOUCH_POINTS) )
	{
		return false;
	}

	if( tpd_read_touchinfo_for_mtk( 0x10, read_num, data ) >= 0 )
	{
		for (i = 0; i < point_num; i = i ++)
		{
            		Touch_Type = (data[i*6] >> 5) & 0x03;

            		/* touch type is panel */
            		if (Touch_Type == TOUCH_SCREEN)
            		{
				fingerID = (data[i*6] & 0x0F)-1;
				cinfo->id[fingerID]  = fingerID;
				cinfo->x[fingerID] = (uint16_t)(data[i*6 + 1] & 0x0F) << 8 | data[i*6 + 2];
				cinfo->y[fingerID] = (uint16_t)(data[i*6 + 1] & 0xF0) << 4 | data[i*6 + 3];
				cinfo->p[fingerID] = (uint16_t)(data[i*6 + 4]);

				TPD_DEBUG("'[MMS100] ID=%d, X=%d,Y=%d, P=%d\n",cinfo->id[fingerID], cinfo->x[fingerID] ,cinfo->y[fingerID],cinfo->p[fingerID] );
            		}
            		/* touch type is key */
#if 1
            		else if (Touch_Type == TOUCH_KEY)
            		{
            			keyID = data[i] & 0x0F;
            			touchState = data[i] & 0x80;
            			input_report_key(tpd->dev, tsp_keycodes[keyID-1], touchState ? PRESS_KEY : RELEASE_KEY);
            			TPD_DMESG("[MMS100] melfas_ts_get_data: keyID : %d, touchState: %d \n", keyID, touchState);
            		}
#endif
            }
        }

	for( i=0; i<CFG_MAX_TOUCH_POINTS ; i++ )
	{
		tpd_down(TPD_WARP_X(cinfo->x[i]), TPD_WARP_Y(cinfo->y[i]), cinfo->p[i], cinfo->id[i]);
	}

        input_sync(tpd->dev);
    }

// melfas parkyj 120510 ]] modify end
	return true;

 };

 static int touch_event_handler(void *unused)
 {
  
    struct touch_info cinfo, pinfo;
	int idx;
#ifdef TPD_HAVE_BUTTON
	static u8 button_state=0;
#endif

	static u8 id_mask = 0;
	u8 cur_mask;
	char esd_data=0;

	static int x_history[CFG_MAX_TOUCH_POINTS];
	static int y_history[CFG_MAX_TOUCH_POINTS];
	static int event_history[CFG_MAX_TOUCH_POINTS];

	struct sched_param param = { .sched_priority = RTPM_PRIO_TPD };
	sched_setscheduler(current, SCHED_RR, &param);
 
	do
	{
		mt65xx_eint_unmask(CUST_EINT_TOUCH_PANEL_NUM); 
		set_current_state(TASK_INTERRUPTIBLE); 
		wait_event_interruptible(waiter,tpd_flag!=0);
				 
		tpd_flag = 0;

		set_current_state(TASK_RUNNING);
		tpd_touchinfo(&cinfo, &pinfo);

 	}while(!kthread_should_stop());
 
	 return 0;
 }
 
 static int tpd_detect (struct i2c_client *client, int kind, struct i2c_board_info *info) 
 {
	strcpy(info->type, TPD_DEVICE);	
	return 0;
 }
 

 static void tpd_eint_interrupt_handler(void)
 {
	 TPD_DEBUG("TPD interrupt has been triggered\n");
	 tpd_flag = 1;
	 wake_up_interruptible(&waiter);
	 
 }
 int __devinit tpd_probe(struct i2c_client *client, const struct i2c_device_id *id)
 {	 
	int retval = TPD_OK;
	char data;
	int ret;
	i2c_client = client;
	int i =0;
	#ifdef MT6575
	//power on, need confirm with SA
	hwPowerOn(TPD_POWER_SOURCE, VOL_2800, "TP");     // CTP_VDD_2.8V  MT65XX_POWER_LDO_VGP2
	#endif

	mt_set_gpio_mode(GPIO_CTP_EINT_PIN, GPIO_CTP_EINT_PIN_M_EINT);
	mt_set_gpio_dir(GPIO_CTP_EINT_PIN, GPIO_DIR_IN);
	mt_set_gpio_pull_enable(GPIO_CTP_EINT_PIN, GPIO_PULL_ENABLE);
	mt_set_gpio_pull_select(GPIO_CTP_EINT_PIN, GPIO_PULL_UP);
 
	mt65xx_eint_set_sens(CUST_EINT_TOUCH_PANEL_NUM, CUST_EINT_TOUCH_PANEL_SENSITIVE);
	mt65xx_eint_set_hw_debounce(CUST_EINT_TOUCH_PANEL_NUM, CUST_EINT_TOUCH_PANEL_DEBOUNCE_CN);
	mt65xx_eint_registration(CUST_EINT_TOUCH_PANEL_NUM, CUST_EINT_TOUCH_PANEL_DEBOUNCE_EN, CUST_EINT_TOUCH_PANEL_POLARITY, tpd_eint_interrupt_handler, 1); 
	mt65xx_eint_unmask(CUST_EINT_TOUCH_PANEL_NUM);
 
	msleep(300);//100-->200  //make sure CTP already finish startup process
 
	if((i2c_smbus_read_i2c_block_data(i2c_client, TS_READ_HW_VER_ADDR, 1, &data))< 0)
	{
		TPD_DMESG("I2C transfer error, line: %d\n", __LINE__);
		return -1; 
	} 
		TPD_DMESG("[TSP] HW version = 0x%x\n", data);
#if 1
	ret = firmware_update();

	if (ret < 0)
	{
		TPD_DMESG("[TSP] %s: firmware update fail\n", __FUNCTION__);
	}
#endif
	tpd_load_status = 1;
 
    //get some register information
	i2c_smbus_read_i2c_block_data(i2c_client, TS_READ_SW_VER_ADDR, 1, &data);
	TPD_DMESG("[TSP] SW version = 0x%x\n", data);

	thread = kthread_run(touch_event_handler, 0, TPD_DEVICE);
	if (IS_ERR(thread))
	{ 
		retval = PTR_ERR(thread);
		TPD_DMESG(TPD_DEVICE " failed to create kernel thread: %d\n", retval);
	}

	TPD_DMESG("Touch Panel Device Probe %s\n", (retval < TPD_OK) ? "FAIL" : "PASS");
	return 0;
   
 }

 static int __devexit tpd_remove(struct i2c_client *client)
 {
	TPD_DEBUG("TPD removed\n");
	return 0;
 }
 
 
 static int tpd_local_init(void)
 {
	TPD_DMESG("Focaltech MMS100 I2C Touchscreen Driver (Built %s @ %s)\n", __DATE__, __TIME__);

	if(i2c_add_driver(&tpd_i2c_driver)!=0)
	{
		TPD_DMESG("unable to add i2c driver.\n");
		return -1;
	}

	if(tpd_load_status == 0) 
	{
		TPD_DMESG("mms100 add error touch panel driver.\n");
		i2c_del_driver(&tpd_i2c_driver);
		return -1;
	}
	tpd_button_setting(TPD_KEY_COUNT, tpd_keys_local, tpd_keys_dim_local);// initialize tpd button data

	TPD_DMESG("end %s, %d\n", __FUNCTION__, __LINE__);  
	return 0; 
 }

 static int tpd_resume(struct i2c_client *client)
 {
	int retval = TPD_OK;
 
	TPD_DEBUG("TPD wake up\n");
	
	hwPowerOn(TPD_POWER_SOURCE, VOL_2800, "TP");     // CTP_VDD_2.8V  MT65XX_POWER_LDO_VGP2
	msleep(50);//350-->300

	mt_set_gpio_mode(GPIO_CTP_RST_PIN, GPIO_CTP_RST_PIN_M_GPIO);
	mt_set_gpio_dir(GPIO_CTP_RST_PIN, GPIO_DIR_OUT);
	mt_set_gpio_out(GPIO_CTP_RST_PIN, GPIO_OUT_ONE);
	msleep(50);//350-->300

	mt65xx_eint_unmask(CUST_EINT_TOUCH_PANEL_NUM);  

	return retval;
 }
 
 static int tpd_suspend(struct i2c_client *client, pm_message_t message)
 {
	 int retval = TPD_OK;
	 static char data = 0x3;
 
	TPD_DEBUG("TPD enter sleep\n");

	mt65xx_eint_mask(CUST_EINT_TOUCH_PANEL_NUM);

	mt_set_gpio_mode(GPIO_CTP_RST_PIN, GPIO_CTP_RST_PIN_M_GPIO);
	mt_set_gpio_dir(GPIO_CTP_RST_PIN, GPIO_DIR_OUT);
	mt_set_gpio_out(GPIO_CTP_RST_PIN, GPIO_OUT_ZERO);
	
	hwPowerDown(TPD_POWER_SOURCE,"TP");     // CTP_VDD_2.8V  MT65XX_POWER_LDO_VGP2
	
	return retval;
 } 


 static struct tpd_driver_t tpd_device_driver = {
		 .tpd_device_name = "MMS100",
		 .tpd_local_init = tpd_local_init,
		 .suspend = tpd_suspend,
		 .resume = tpd_resume,
#ifdef TPD_HAVE_BUTTON
		 .tpd_have_button = 1,
#else
		 .tpd_have_button = 0,
#endif		
 };
 /* called when loaded into kernel */
 static int __init tpd_driver_init(void) {
	 TPD_DMESG("MediaTek MMS100 touch panel driver init\n");
		 if(tpd_driver_add(&tpd_device_driver) < 0)
			 TPD_DMESG("add MMS100 driver failed\n");
	 return 0;
 }
 
 /* should never be called */
 static void __exit tpd_driver_exit(void) {
	 TPD_DMESG("MediaTek MMS100 touch panel driver exit\n");
	 //input_unregister_device(tpd->dev);
	 tpd_driver_remove(&tpd_device_driver);
 }
 
 module_init(tpd_driver_init);
 module_exit(tpd_driver_exit);


