
//--------------------------------------------------------
//
//
//	Melfas MMS100 Series Download base v1.0
//
//
//--------------------------------------------------------

#ifndef __MELFAS_DOWNLOAD_PORTING_H_INCLUDED__
#define __MELFAS_DOWNLOAD_PORTING_H_INCLUDED__

#include <linux/module.h>
#include <linux/input.h>
#include <linux/interrupt.h>
#include <linux/platform_device.h>
#include <linux/i2c.h>
#include <linux/delay.h>
#include <linux/interrupt.h>
#include <linux/irq.h>
#include <linux/earlysuspend.h>
#include <linux/slab.h>
#include <mach/hardware.h>
#include <linux/jiffies.h>
#include <mach/mt6575_gpio.h>
#include <mach/mt6575_pm_ldo.h>
#include "tpd_custom_mms100.h"

//============================================================
//
//	Type define
//
//============================================================
#if 0
typedef char				INT8;
typedef unsigned char		UINT8;
typedef short				INT16;
typedef unsigned short		UINT16;
typedef int					INT32;
typedef unsigned int		UINT32;
typedef unsigned char		BOOLEAN;
#endif

//============================================================
//
//	Porting Download Options
//
//============================================================
#define MCSDL_USE_CE_CONTROL 0
#define MCSDL_USE_VDD_CONTROL 1
#define MCSDL_USE_RESETB_CONTROL 1

#define MELFAS_ENABLE_DBG_PRINT 1
#define MELFAS_ENABLE_DBG_PROGRESS_PRINT 1



//----------------
// VDD
//----------------
#if MCSDL_USE_VDD_CONTROL
#define mcsdl_vdd_on()                  
#define mcsdl_vdd_off()                 

#define MCSDL_VDD_SET_HIGH()            hwPowerOn(TPD_POWER_SOURCE, VOL_2800, "TP")
#define MCSDL_VDD_SET_LOW()             hwPowerDown(TPD_POWER_SOURCE,"TP")
#else
#define MCSDL_VDD_SET_HIGH()            // Nothing
#define MCSDL_VDD_SET_LOW()             // Nothing
#endif

//----------------
// CE
//----------------
#if MCSDL_USE_CE_CONTROL
#define MCSDL_CE_SET_HIGH()   	       gpio_set_value(TOUCH_EN, 1)
#define MCSDL_CE_SET_LOW()      	   gpio_set_value(TOUCH_EN, 0)
#define MCSDL_CE_SET_OUTPUT()   	   gpio_tlmm_config(GPIO_CFG(TOUCH_EN, 0, GPIO_CFG_OUTPUT, GPIO_CFG_NO_PULL, GPIO_CFG_16MA),GPIO_CFG_ENABLE)
#else
#define MCSDL_CE_SET_HIGH()				// Nothing
#define MCSDL_CE_SET_LOW()				// Nothing
#define MCSDL_CE_SET_OUTPUT()			// Nothing
#endif


//----------------
// RESETB
//----------------
#if MCSDL_USE_RESETB_CONTROL
#define MCSDL_RESETB_SET_HIGH()         mt_set_gpio_out(GPIO_CTP_EINT_PIN, 1)
#define MCSDL_RESETB_SET_LOW()          mt_set_gpio_out(GPIO_CTP_EINT_PIN, 0)
#define MCSDL_RESETB_SET_OUTPUT()       mt_set_gpio_dir(GPIO_CTP_EINT_PIN, GPIO_DIR_OUT);
#define MCSDL_RESETB_SET_INPUT()        mt_set_gpio_dir(GPIO_CTP_EINT_PIN, GPIO_DIR_IN);
//#define MCSDL_RESETB_SET_ALT()  	    s3c_gpio_cfgpin(GPIO_CTP_EINT_PIN, S3C_GPIO_SFN(0xF));
#else
#define MCSDL_RESETB_SET_HIGH()
#define MCSDL_RESETB_SET_LOW()
#define MCSDL_RESETB_SET_OUTPUT()
#define MCSDL_RESETB_SET_ALT()
#define MCSDL_RESETB_SET_INPUT()
#endif

//------------------
// I2C SCL & SDA
//------------------
#define MCSDL_GPIO_SCL_SET_HIGH()		mt_set_gpio_out(GPIO_I2C0_SCA_PIN, GPIO_OUT_ONE)
#define MCSDL_GPIO_SCL_SET_LOW()		mt_set_gpio_out(GPIO_I2C0_SCA_PIN, GPIO_OUT_ZERO)

#define MCSDL_GPIO_SDA_SET_HIGH()		mt_set_gpio_out(GPIO_I2C0_SDA_PIN, GPIO_OUT_ONE)
#define MCSDL_GPIO_SDA_SET_LOW()		mt_set_gpio_out(GPIO_I2C0_SDA_PIN, GPIO_OUT_ZERO)

#define MCSDL_GPIO_SCL_SET_OUTPUT()	    mt_set_gpio_dir(GPIO_I2C0_SCA_PIN, GPIO_DIR_OUT);
#define MCSDL_GPIO_SCL_SET_INPUT()	    mt_set_gpio_dir(GPIO_I2C0_SCA_PIN, GPIO_DIR_IN);
#define MCSDL_GPIO_SCL_SET_ALT()		mt_set_gpio_mode(GPIO_I2C0_SCA_PIN, GPIO_I2C0_SCA_PIN_M_SCL)
#define MCSDL_GPIO_SCL_SET_GPIO()   mt_set_gpio_mode(GPIO_I2C0_SCA_PIN, GPIO_I2C0_SCA_PIN_M_GPIO);

#define MCSDL_GPIO_SDA_SET_OUTPUT()	    mt_set_gpio_dir(GPIO_I2C0_SDA_PIN,GPIO_DIR_OUT)
#define MCSDL_GPIO_SDA_SET_INPUT()	    mt_set_gpio_dir(GPIO_I2C0_SDA_PIN, GPIO_DIR_IN);
#define MCSDL_GPIO_SDA_SET_ALT()		mt_set_gpio_mode(GPIO_I2C0_SDA_PIN, GPIO_I2C0_SDA_PIN_M_SDA)
#define MCSDL_GPIO_SDA_SET_GPIO()      mt_set_gpio_mode(GPIO_I2C0_SDA_PIN, GPIO_I2C0_SCA_PIN_M_GPIO)

#define MCSDL_GPIO_SDA_IS_HIGH()		((mt_get_gpio_in(GPIO_I2C0_SDA_PIN) > 0) ? 1 : 0)

#endif

