/* Copyright Statement:
 *
 * This software/firmware and related documentation ("MediaTek Software") are
 * protected under relevant copyright laws. The information contained herein
 * is confidential and proprietary to MediaTek Inc. and/or its licensors.
 * Without the prior written permission of MediaTek inc. and/or its licensors,
 * any reproduction, modification, use or disclosure of MediaTek Software,
 * and information contained herein, in whole or in part, shall be strictly prohibited.
 */
/* MediaTek Inc. (C) 2010. All rights reserved.
 *
 * BY OPENING THIS FILE, RECEIVER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND AGREES
 * THAT THE SOFTWARE/FIRMWARE AND ITS DOCUMENTATIONS ("MEDIATEK SOFTWARE")
 * RECEIVED FROM MEDIATEK AND/OR ITS REPRESENTATIVES ARE PROVIDED TO RECEIVER ON
 * AN "AS-IS" BASIS ONLY. MEDIATEK EXPRESSLY DISCLAIMS ANY AND ALL WARRANTIES,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR NONINFRINGEMENT.
 * NEITHER DOES MEDIATEK PROVIDE ANY WARRANTY WHATSOEVER WITH RESPECT TO THE
 * SOFTWARE OF ANY THIRD PARTY WHICH MAY BE USED BY, INCORPORATED IN, OR
 * SUPPLIED WITH THE MEDIATEK SOFTWARE, AND RECEIVER AGREES TO LOOK ONLY TO SUCH
 * THIRD PARTY FOR ANY WARRANTY CLAIM RELATING THERETO. RECEIVER EXPRESSLY ACKNOWLEDGES
 * THAT IT IS RECEIVER'S SOLE RESPONSIBILITY TO OBTAIN FROM ANY THIRD PARTY ALL PROPER LICENSES
 * CONTAINED IN MEDIATEK SOFTWARE. MEDIATEK SHALL ALSO NOT BE RESPONSIBLE FOR ANY MEDIATEK
 * SOFTWARE RELEASES MADE TO RECEIVER'S SPECIFICATION OR TO CONFORM TO A PARTICULAR
 * STANDARD OR OPEN FORUM. RECEIVER'S SOLE AND EXCLUSIVE REMEDY AND MEDIATEK'S ENTIRE AND
 * CUMULATIVE LIABILITY WITH RESPECT TO THE MEDIATEK SOFTWARE RELEASED HEREUNDER WILL BE,
 * AT MEDIATEK'S OPTION, TO REVISE OR REPLACE THE MEDIATEK SOFTWARE AT ISSUE,
 * OR REFUND ANY SOFTWARE LICENSE FEES OR SERVICE CHARGE PAID BY RECEIVER TO
 * MEDIATEK FOR SUCH MEDIATEK SOFTWARE AT ISSUE.
 *
 * The following software/firmware and/or related documentation ("MediaTek Software")
 * have been modified by MediaTek Inc. All revisions are subject to any receiver's
 * applicable license agreements with MediaTek Inc.
 */

#include <linux/init.h>
#include <linux/module.h>
#include <linux/delay.h>
#include <linux/i2c.h>
#include <linux/input.h>
#include <linux/slab.h>
#include <linux/gpio.h>
#include <linux/sched.h>
#include <linux/kthread.h>
#include <linux/bitops.h>
#include <linux/kernel.h>
#include <linux/delay.h>
#include <linux/byteorder/generic.h>
#ifdef CONFIG_HAS_EARLYSUSPEND
#include <linux/earlysuspend.h>
#endif 
#include <linux/interrupt.h>
#include <linux/time.h>
#include <linux/rtpm_prio.h>

#include "tpd_custom_ssd2531.h"
#include "tpd.h"
#include <cust_eint.h>

#ifndef TPD_NO_GPIO 
#include "cust_gpio_usage.h"
#endif

#include <linux/hrtimer.h>


/////////////////////////longxw add  statrt////////////////////////////////////
#ifdef TPD_HAVE_BUTTON 
#define TPD_KEY_COUNT           4
#define TPD_KEYS                {KEY_HOME, KEY_MENU, KEY_BACK,KEY_SEARCH}
#define TPD_KEYS_DIM            {{40,505,80,50},{120,505,80,50},{200,505,80,50},{280,505,80,50}}

static int tpd_keys_local[TPD_KEY_COUNT] = TPD_KEYS;
static int tpd_keys_dim_local[TPD_KEY_COUNT][4] = TPD_KEYS_DIM;
#endif
#if (defined(TPD_WARP_START) && defined(TPD_WARP_END))
static int tpd_wb_start_local[TPD_WARP_CNT] = TPD_WARP_START;
static int tpd_wb_end_local[TPD_WARP_CNT]   = TPD_WARP_END;
#endif
#if (defined(TPD_HAVE_CALIBRATION) && !defined(TPD_CUSTOM_CALIBRATION))
static int tpd_calmat_local[8]     = TPD_CALIBRATION_MATRIX;
static int tpd_def_calmat_local[8] = TPD_CALIBRATION_MATRIX;
#endif
/////////////////////////longxw add  end////////////////////////////////////


// TODO: should be moved into mach/xxx.h 
#ifdef MT6516
extern void MT6516_EINTIRQUnmask(unsigned int line);
extern void MT6516_EINTIRQMask(unsigned int line);
extern void MT6516_EINT_Set_HW_Debounce(kal_uint8 eintno, kal_uint32 ms);
extern kal_uint32 MT6516_EINT_Set_Sensitivity(kal_uint8 eintno, kal_bool sens);
extern void MT6516_EINT_Registration(kal_uint8 eintno, kal_bool Dbounce_En,
                                     kal_bool ACT_Polarity, void (EINT_FUNC_PTR)(void),
                                     kal_bool auto_umask);

extern void MT6516_IRQMask(unsigned int line);
extern void MT6516_IRQUnmask(unsigned int line);
extern void MT6516_IRQClearInt(unsigned int line);
#endif

#ifdef MT6575
#include <mach/mt6575_pm_ldo.h>
#include <mach/mt6575_typedefs.h>
#include <mach/mt6575_boot.h>

extern void mt65xx_eint_unmask(unsigned int line);
extern void mt65xx_eint_mask(unsigned int line);
extern void mt65xx_eint_set_polarity(kal_uint8 eintno, kal_bool ACT_Polarity);
extern void mt65xx_eint_set_hw_debounce(kal_uint8 eintno, kal_uint32 ms);
extern kal_uint32 mt65xx_eint_set_sens(kal_uint8 eintno, kal_bool sens);
extern void mt65xx_eint_registration(kal_uint8 eintno, kal_bool Dbounce_En,
                                     kal_bool ACT_Polarity, void (EINT_FUNC_PTR)(void),
                                     kal_bool auto_umask);
#endif


static struct task_struct *thread = NULL;
extern struct tpd_device *tpd;
static DECLARE_WAIT_QUEUE_HEAD(waiter);
static int tpd_flag=0;
static int tpd_halt=0;

////////////////////////////////////////////////////////////////////
struct ssl_ts_priv {
	struct i2c_client *client;
	struct input_dev *input;
	struct hrtimer timer;
	struct work_struct  ssl_work;
	u32 fingers;
	u32 buttons;
	int cal_counter;
	int cal_tick;
	int irq;
	int prev_x[4];
	int prev_y[4];
	u8	keys[4];
	u8	keyindex[4];
	u32 fingerbits;
	unsigned long touchtime[10];
	u32	tp_id;
	unsigned long cal_end_time;
	int finger_count;
	int working_mode;
	int drives;
	int senses;
#ifdef CONFIG_HAS_EARLYSUSPEND
	struct early_suspend early_suspend;
#endif
	u8	r25h;
	u8	bsleep;
	u8	binitialrun;
	u8	bcalibrating;
	u8	rawout;
};

struct ssl_ts_priv ssd2531_priv;

#define LCD_RANGE_X 320
#define LCD_RANGE_Y 480

#define SSL_DEBUG

#ifdef SSL_DEBUG
#define SSL_PRINT(x...)		printk("SSD253X:"x)
#else
#define SSL_PRINT(x...)
#endif

/****** auto-calibration conditions (only applied to SSD2531) ******/
/****** define auto-calibration threshold ******/
#define CAL_THRESHOLD  -100//-160   //longxuewei 20111227
/****** define auto-calibration checking interval ******/
#define CAL_INTERVAL	50	//in ms
/****** define auto-calibration checking times ******/
#define CAL_COUNT		35	//check 35 seconds after boot-up/sleep out
/****** define delay time for calibration ******/
#define CAL_DELAY		300	//in ms
/****** define the number of finger that used to report coodinates ******/
#define FINGER_USED		2
/****** define delay time for bending restore ******/
#define BENDING_DELAY	200	//in ms

/////////////////////////////////////////////////////////////////////////////////////


#define TPD_SLAVE_ADDR 0xB8//0x5C for 7bit address
static void tpd_eint_interrupt_handler(void);
static int touch_event_handler(void *unused);
static int tpd_i2c_probe(struct i2c_client *client, const struct i2c_device_id *id);
static int tpd_i2c_detect(struct i2c_client *client, int kind, struct i2c_board_info *info);
static int tpd_i2c_remove(struct i2c_client *client);
static struct i2c_client *i2c_client = NULL;
static const struct i2c_device_id tpd_i2c_id[] = {{"mtk-tpd",0},{}};
static unsigned short force[] = {0, TPD_SLAVE_ADDR, I2C_CLIENT_END,I2C_CLIENT_END};
static const unsigned short * const forces[] = { force, NULL };
static struct i2c_client_address_data addr_data = { .forces = forces,};
static struct i2c_driver tpd_i2c_driver =
{                       
    .probe = tpd_i2c_probe,                                   
    .remove = tpd_i2c_remove,                           
    .detect = tpd_i2c_detect,                           
    .driver.name = "mtk-tpd", 
    .id_table = tpd_i2c_id,                             
    .address_data = &addr_data,                        
}; 


static int i2c_send(char  *buf, int inlen)
{
	uint8_t i;
 	i2c_client->timing=350;
	for (i = 0; i < 3; i++) {
		if (i2c_master_send(i2c_client,buf,inlen) == inlen) {
			break;
		}
		mdelay(3);
	}

	if (i >= 3) {
		pr_err("%s: retry over 3\n", __FUNCTION__);
		return -EIO;
	}
	return 0;
}

static int i2c_recv(uint8_t *buf, uint8_t inlen, uint8_t outlen)
{
    uint8_t i;
 	i2c_client->timing=350;
    i2c_client->addr = (i2c_client->addr & I2C_MASK_FLAG) | I2C_WR_FLAG |I2C_RS_FLAG;

	for (i = 0; i < 3; i++) {
		if (i2c_master_send(i2c_client, (const char*)buf, outlen<<8 | inlen)) {
			break;
		}
		mdelay(3);
	}

	if (i >= 3) {
		pr_err("%s: retry over 3\n", __FUNCTION__);
		return -EIO;
	}

	i2c_client->addr = i2c_client->addr& I2C_MASK_FLAG;
  	return 0;
}



static int deviceInit(void)
{
    unsigned char I2CSend_2231_data[4] = {0x00, 0x00, 0x00,0x00};
    unsigned char I2CRecv_2231_data[4] = {0x00, 0x00, 0x00,0x00};

    //ssd2531_config_setting(&ssd2531_priv);
SSL_PRINT("Run into %s.\n",__FUNCTION__);

    mt_set_gpio_out(GPIO_CTP_RST_PIN, GPIO_OUT_ZERO);
    msleep(10);
    mt_set_gpio_out(GPIO_CTP_RST_PIN, GPIO_OUT_ONE);
    msleep(10);

    TPD_DEBUG("SSD2531_init start");
    I2CSend_2231_data[0] = 0x23;
    I2CSend_2231_data[1] = 0x00;
    i2c_send(I2CSend_2231_data,2); //system enable (wake up)
    mdelay(30);
	
    I2CRecv_2231_data[0]=0x02;
    if(i2c_recv(I2CRecv_2231_data,1,2) ==0)     // get chip iD
	{
        TPD_DEBUG("get ssd2531 chip id = %x,%x\r\n",I2CRecv_2231_data[0],I2CRecv_2231_data[1]);
	}
    else
	{
        TPD_DEBUG("read ssd2531 i2c error!!\r\n");
		return -1;	
	}
	
    I2CSend_2231_data[0] = 0x2b;
    I2CSend_2231_data[1] = 0x03;
    i2c_send(I2CSend_2231_data,2); //enable clock
    mdelay(30);
    I2CSend_2231_data[0] = 0xD4;
    I2CSend_2231_data[1] = 0x00;  
    i2c_send(I2CSend_2231_data,2); //reg = 0xD4 value= 0x00
    I2CSend_2231_data[0] = 0x06;
    I2CSend_2231_data[1] = 0x08;  //drive pin 12
    i2c_send(I2CSend_2231_data,2); //reg = 0x06 value= 0x06 drive pin
    I2CSend_2231_data[0] = 0x07;
    I2CSend_2231_data[1] = 0x05;  //sense pin 8
    i2c_send(I2CSend_2231_data,2); //reg = 0x07 value= 0x02 sensing pin
    I2CSend_2231_data[0] = 0x08;
    I2CSend_2231_data[1] = 0x09;  
    i2c_send(I2CSend_2231_data,2); //reg = 0x08 value= 0x0B 
    I2CSend_2231_data[0] = 0x09;
    I2CSend_2231_data[1] = 0x08;  
    i2c_send(I2CSend_2231_data,2); //reg = 0x09 value= 0x0A
    I2CSend_2231_data[0] = 0x0A;
    I2CSend_2231_data[1] = 0x07;  
    i2c_send(I2CSend_2231_data,2); 
    I2CSend_2231_data[0] = 0x0B;
    I2CSend_2231_data[1] = 0x06;  
    i2c_send(I2CSend_2231_data,2); 
    I2CSend_2231_data[0] = 0x0C;
    I2CSend_2231_data[1] = 0x05;  
    i2c_send(I2CSend_2231_data,2); 
    I2CSend_2231_data[0] = 0x0D;
    I2CSend_2231_data[1] = 0x04;  
    i2c_send(I2CSend_2231_data,2); 
    I2CSend_2231_data[0] = 0x0E;
    I2CSend_2231_data[1] = 0x11;  
    i2c_send(I2CSend_2231_data,2); 
    I2CSend_2231_data[0] = 0x0F;
    I2CSend_2231_data[1] = 0x10;  
    i2c_send(I2CSend_2231_data,2); 
    I2CSend_2231_data[0] = 0x10;
    I2CSend_2231_data[1] = 0x0f;  
    i2c_send(I2CSend_2231_data,2); 
    I2CSend_2231_data[0] = 0x11;
    I2CSend_2231_data[1] = 0x0e;  
    i2c_send(I2CSend_2231_data,2); 
    I2CSend_2231_data[0] = 0x12;
    I2CSend_2231_data[1] = 0x0d;  
    i2c_send(I2CSend_2231_data,2); 
    I2CSend_2231_data[0] = 0x13;
    I2CSend_2231_data[1] = 0x0c;  
    i2c_send(I2CSend_2231_data,2); 
    I2CSend_2231_data[0] = 0x14;
    I2CSend_2231_data[1] = 0x0b;  
    i2c_send(I2CSend_2231_data,2); 
    I2CSend_2231_data[0] = 0x15;
    I2CSend_2231_data[1] = 0x0a;  
    i2c_send(I2CSend_2231_data,2); 
    I2CSend_2231_data[0] = 0x16;
    I2CSend_2231_data[1] = 0x0a;  
    i2c_send(I2CSend_2231_data,2); 
    I2CSend_2231_data[0] = 0x17;
    I2CSend_2231_data[1] = 0x11;  
    i2c_send(I2CSend_2231_data,2); 
    I2CSend_2231_data[0] = 0x18;
    I2CSend_2231_data[1] = 0x08;  
    i2c_send(I2CSend_2231_data,2); 


    I2CSend_2231_data[0] = 0x19;
    I2CSend_2231_data[1] = 0x08;  
    i2c_send(I2CSend_2231_data,2); 
    I2CSend_2231_data[0] = 0x1A;
    I2CSend_2231_data[1] = 0x00;  
    i2c_send(I2CSend_2231_data,2); 
    I2CSend_2231_data[0] = 0x1B;
    I2CSend_2231_data[1] = 0x0a;  
    i2c_send(I2CSend_2231_data,2); 
    
    I2CSend_2231_data[0] = 0x27;
    I2CSend_2231_data[1] = 0x07;  
    i2c_send(I2CSend_2231_data,2); 
    I2CSend_2231_data[0] = 0x28;
    I2CSend_2231_data[1] = 0x0f;  
    i2c_send(I2CSend_2231_data,2); 
    I2CSend_2231_data[0] = 0x29;
    I2CSend_2231_data[1] = 0x03;  
    i2c_send(I2CSend_2231_data,2); 
    I2CSend_2231_data[0] = 0x2A;
    I2CSend_2231_data[1] = 0x03;
    i2c_send(I2CSend_2231_data,2); //reg = 0x07 value= 0x05 sensing pin
    I2CSend_2231_data[0] = 0x2c;
    I2CSend_2231_data[1] = 0x02;
    i2c_send(I2CSend_2231_data,2); //Median Filter select
    I2CSend_2231_data[0] = 0x33;
    I2CSend_2231_data[1] = 0x01;
    i2c_send(I2CSend_2231_data,2); //Median Filter select
    I2CSend_2231_data[0] = 0x34;
    I2CSend_2231_data[1] = 0x50;
    i2c_send(I2CSend_2231_data,2); // Min Finger level
    I2CSend_2231_data[0] = 0x35;
    I2CSend_2231_data[1] = 0x00;
    I2CSend_2231_data[2] = 0x50;
    i2c_send(I2CSend_2231_data,3); //Median Filter select
    I2CSend_2231_data[0] = 0x36;
    I2CSend_2231_data[1] = 0x20;
    i2c_send(I2CSend_2231_data,2); //Max Finger Area
    I2CSend_2231_data[0] = 0x37;
    I2CSend_2231_data[1] = 0x03;
    i2c_send(I2CSend_2231_data,2); //Max Finger Area
    I2CSend_2231_data[0] = 0x38;
    I2CSend_2231_data[1] = 0x00;
    i2c_send(I2CSend_2231_data,2); //Max Finger Area
    I2CSend_2231_data[0] = 0x39;
    I2CSend_2231_data[1] = 0x00;  //0x00 20111216  0x01
    i2c_send(I2CSend_2231_data,2); //Max Finger Area
    I2CSend_2231_data[0] = 0x3D;
    I2CSend_2231_data[1] = 0x01;
    i2c_send(I2CSend_2231_data,2); 
    I2CSend_2231_data[0] = 0x51;
    I2CSend_2231_data[1] = 0x00;
    I2CSend_2231_data[2] = 0x64;
    i2c_send(I2CSend_2231_data,3);
    I2CSend_2231_data[0] = 0x52;
    I2CSend_2231_data[1] = 0x02;
    I2CSend_2231_data[2] = 0x00;
    i2c_send(I2CSend_2231_data,3); 
    I2CSend_2231_data[0] = 0x53;
    I2CSend_2231_data[1] = 0x08;
    i2c_send(I2CSend_2231_data,2); //CG Tolerance
    I2CSend_2231_data[0] = 0x54;
    I2CSend_2231_data[1] = 0x30;
    i2c_send(I2CSend_2231_data,2); // X Tracking Tolerance
    I2CSend_2231_data[0] = 0x55;
    I2CSend_2231_data[1] = 0x30;
    i2c_send(I2CSend_2231_data,2); // Y Tracking Tolerance
    I2CSend_2231_data[0] = 0x56;
    I2CSend_2231_data[1] = 0x01;
    i2c_send(I2CSend_2231_data,2);// Moving Average Filter
    I2CSend_2231_data[0] = 0x58;
    I2CSend_2231_data[1] = 0x01;
    i2c_send(I2CSend_2231_data,2);
    I2CSend_2231_data[0] = 0x59;
    I2CSend_2231_data[1] = 0x01;
    i2c_send(I2CSend_2231_data,2);// Moving Average Filter
    I2CSend_2231_data[0] = 0x5A;
    I2CSend_2231_data[1] = 0x00;
    i2c_send(I2CSend_2231_data,2);
 
    I2CSend_2231_data[0] = 0x5b;
    I2CSend_2231_data[1] = 0x08;
    i2c_send(I2CSend_2231_data,2);// Moving Average Filter
 
    I2CSend_2231_data[0] = 0x65;
    I2CSend_2231_data[1] = 0x00;
    i2c_send(I2CSend_2231_data,2);// Moving Average Filter
 
    I2CSend_2231_data[0] = 0x66;
    I2CSend_2231_data[1] = 0x40;  //320  //0X47
    i2c_send(I2CSend_2231_data,2); 
    I2CSend_2231_data[0] = 0x67;
    I2CSend_2231_data[1] = 0x49;  //480    //0X4a
    i2c_send(I2CSend_2231_data,2);// Moving Average Filter

    I2CSend_2231_data[0] = 0x7A;
    I2CSend_2231_data[1] = 0xff; 
    I2CSend_2231_data[2] = 0xff;
    i2c_send(I2CSend_2231_data,3);// 
    I2CSend_2231_data[0] = 0x7B;
    I2CSend_2231_data[1] = 0xB0;
    i2c_send(I2CSend_2231_data,2);// 
    
    I2CSend_2231_data[0] = 0xc1;
    I2CSend_2231_data[1] = 0x02;
    i2c_send(I2CSend_2231_data,2); //Charge Pump Clock
    I2CSend_2231_data[0] = 0xd5;
    I2CSend_2231_data[1] = 0x0F;
    i2c_send(I2CSend_2231_data,2); //Driving Voltage
    I2CSend_2231_data[0] = 0xd9;
    I2CSend_2231_data[1] = 0x01;
    i2c_send(I2CSend_2231_data,2); //Enable Sense Filter
    I2CSend_2231_data[0] = 0x25;
    I2CSend_2231_data[1] = 0x04;  //0x06
    i2c_send(I2CSend_2231_data,2); //scan speed
 //   mdelay(300);
    TPD_DEBUG("SSD2531_init end\r\n");


	ssd2531_priv.senses=11;//reg(0x07)+6
	ssd2531_priv.drives=14;//reg(0x06)+6
	
	return 0;
}

void StartWork(struct ssl_ts_priv *ssl_priv)
{
	u8 buf[2];
	buf[0]=0x25;
	buf[1]=0x04;
	i2c_send(buf,2);

	ssl_priv->cal_tick=1-(500/CAL_INTERVAL);
	ssl_priv->fingers=0;
	ssl_priv->buttons=0;
	ssl_priv->fingerbits=0;	
	ssl_priv->binitialrun=1;
	ssl_priv->cal_counter=0;
	ssl_priv->cal_end_time=jiffies+HZ*CAL_COUNT;
	hrtimer_start(&ssl_priv->timer, ktime_set(0, 300*1000000), HRTIMER_MODE_REL); //check status after 300ms
	ssl_priv->bsleep=0;
}

void StopWork(void)
{
	int i;
	unsigned char buf[4];
	//struct ssl_ts_priv *ssl_priv = dev_get_drvdata(&client->dev);

	for(i=0;i<5;i++){
		buf[0]=0x25;
		buf[1]=0x00;
		i2c_send(buf,2);
		mdelay(50);
		buf[0]=0x26;
		i2c_recv(buf,1,1);
		if(buf[0]==0)
			break;
	}
	buf[0]=0x24;
	buf[1]=0x00;
	i2c_send(buf,2);
}


void deviceWakeUp(struct ssl_ts_priv *ssl_priv)
{
	deviceInit();
	StartWork(ssl_priv);
}

void deviceSleep(struct ssl_ts_priv *ssl_priv)
{
	ssl_priv->bsleep=1;
	hrtimer_cancel(&ssl_priv->timer);
	mdelay(10);
	//gpio_set_value(TOUCH_RES_PIN,0);
 	//mt_set_gpio_out(GPIO_CTP_RST_PIN, GPIO_OUT_ZERO);
 	StopWork();
}


static int ssd253x_delta(struct ssl_ts_priv *ssl_priv, int bout)
{
	int max_delta=-256,min_delta=4095,temp;
	int i,j;
	u8 reg_buff[4]={0};
	volatile unsigned long time0=jiffies;
	
	reg_buff[0]=0x8d;
	reg_buff[1]=1;
	i2c_send(reg_buff,2);
	mdelay(10);	
	
	reg_buff[0]=0x8e;
	reg_buff[1]=0;
	i2c_send(reg_buff,2);
	reg_buff[0]=0x8f;
	reg_buff[1]=0;
	i2c_send(reg_buff,2);
	reg_buff[0]=0x90;
	reg_buff[1]=0;
	i2c_send(reg_buff,2);

	for(i=0;i<ssl_priv->drives;i++){
		for(j=0;j<ssl_priv->senses;j++){
			reg_buff[0]=0x92;
			i2c_recv(reg_buff,1,2);		
			temp=reg_buff[1]+((reg_buff[0]&0x01)<<8);
			if(temp>255)
				temp-=512;
			
			if(ssl_priv->rawout)
				printk("%4d ",temp);
			if(max_delta<temp)
				max_delta=temp;
			if(min_delta>temp)
				min_delta=temp;
		}
		if(ssl_priv->rawout)
			printk("\n");
	}
	if(bout)
		printk("Delta (read in %u ms): max=%d, min=%d\n",jiffies_to_msecs(jiffies-time0),max_delta,min_delta);


	reg_buff[0]=0x8d;
	reg_buff[1]=0;
	i2c_send(reg_buff,2);

	if(min_delta<CAL_THRESHOLD)
		return 1;
	else
		return 0;
}


static enum hrtimer_restart ssd253x_ts_timer(struct hrtimer *timer)
{
	struct ssl_ts_priv *ssl_priv = container_of(timer, struct ssl_ts_priv, timer);
	SSL_PRINT("Run into %s.\n",__FUNCTION__);
	if(ssl_priv->bcalibrating==1){
		ssl_priv->bcalibrating=0;
	}
	tpd_flag=1; 
	wake_up_interruptible(&waiter);
	return HRTIMER_NORESTART;
}


static void tpd_eint_interrupt_handler(void)
{ 
	TPD_DEBUG("tpd_eint_interrupt_handler\r\n");
	if(ssd2531_priv.bcalibrating==1)
		return IRQ_HANDLED;
	hrtimer_cancel(&ssd2531_priv.timer);
	SSL_PRINT("Run into %s.\n",__FUNCTION__);
	tpd_flag=1;
	wake_up_interruptible(&waiter);
	return IRQ_HANDLED;
} 


static void tpd_down(int x, int y)
{
    input_report_abs(tpd->dev, ABS_PRESSURE, 128);
    input_report_key(tpd->dev, BTN_TOUCH, 1);
    input_report_abs(tpd->dev, ABS_MT_TOUCH_MAJOR, 128);
    input_report_abs(tpd->dev, ABS_MT_WIDTH_MAJOR, 128);
    input_report_abs(tpd->dev, ABS_MT_POSITION_X, x);
    input_report_abs(tpd->dev, ABS_MT_POSITION_Y, y);
    input_mt_sync(tpd->dev);
TPD_DEBUG("tpd_down:X=%x,y=%x\r\n",x,y);

printk("tpd_down:X=%x,y=%x\r\n",x,y);

}

static void tpd_up(int x, int y)
{
    input_report_abs(tpd->dev, ABS_PRESSURE, 0);
    input_report_key(tpd->dev, BTN_TOUCH, 0);
    input_report_abs(tpd->dev, ABS_MT_TOUCH_MAJOR, 0);
    input_report_abs(tpd->dev, ABS_MT_WIDTH_MAJOR, 0);
    input_report_abs(tpd->dev, ABS_MT_POSITION_X, x);
    input_report_abs(tpd->dev, ABS_MT_POSITION_Y, y);
    input_mt_sync(tpd->dev);
TPD_DEBUG("tpd_up:X=%x,y=%x\r\n",x,y);

}


static int IsWrongReport(u32 oldflag,u32 newflag)
{
	int i;
	u32 bitmask;
	u32 bitmark=0;
	oldflag&=0x3ff0;
	newflag&=0x3ff0;
	for(i=4;i<14;i++){
		bitmask=1<<i;
		if((oldflag&bitmask)==0){	//old=0
			if(bitmask&newflag){	//new =1
				if(bitmark&(bitmask-1)){	//unexpected finger on, eg. old=0x20, new=0x60(should be 0x30)
					printk("SSD253X: Wrong finger id, need calibrate!\n");
					return 1;
				}
			}
			else{
				bitmark|=bitmask;
			}
		}		
	}
	
	return 0;
}



//#define X_COOR (reg_buff[0] + (((u16)reg_buff[2] & 0xF0) << 4))
//#define Y_COOR (reg_buff[1] + (((u16)reg_buff[2] & 0x0F) << 8))
#define PRESS_PRESSURE ((reg_buff[3] >> 4) & 0x0F)
#define PRESS_SPEED  (reg_buff[3]&0x0F)
static void ssd253x_ts_work(struct ssl_ts_priv *ssl_priv)
{
	static int wmode=0;
	int ret = 0;
	int i,j,smode;
	u8 reg_buff[4] = { 0 };
	u32 finger_flag = 0;
	u32 old_flag=0;
	u32 button_flag=0;
	u32 bitmask;
	int px,py;
	//struct ssl_ts_priv *ssl_priv = container_of(work,struct ssl_ts_priv,ssl_work);
	SSL_PRINT("Run into %s.\n",__FUNCTION__);
	if(ssl_priv->bsleep)
		return;
	
	reg_buff[0]=0x79;
	ret=i2c_recv(reg_buff,1,1);	
	finger_flag=((reg_buff[0]&0xF0)>>4)|((reg_buff[0]&0x0F)<<4);
	SSL_PRINT("R79h:0x%02X.\n",finger_flag);
	
	if(ret){
		finger_flag=0;
		//I2C Device fail
	}
	else{
		for(i=0;i<FINGER_USED;i++){
			bitmask=0x10<<i;
			if(finger_flag & bitmask) { /*finger exists*/
				reg_buff[0]=0x7c+i;
				ret = i2c_recv(reg_buff,1,4);
				if(ret) {
					//I2C device fail
				}
				else{
					px=(reg_buff[0] + (((u16)reg_buff[2] & 0xF0) << 4));
					py=(reg_buff[1] + (((u16)reg_buff[2] & 0x0F) << 8));
					if((px!=0xFFF)&&(py!=0xFFF)){
						ssl_priv->prev_x[i]=px;
						ssl_priv->prev_y[i]=py;
					}

					if(finger_flag&0x04)	//don't report finger if there is large object
						continue;

					if(ssl_priv->prev_x[i]>=LCD_RANGE_X)
						ssl_priv->prev_x[i]=LCD_RANGE_X-1;
					if(ssl_priv->prev_y[i]>=LCD_RANGE_Y)
						ssl_priv->prev_y[i]=LCD_RANGE_Y-1;
					if(ssl_priv->fingerbits & (1<<i)){
						SSL_PRINT("Finger%d move:(%d,%d)\n",i,ssl_priv->prev_x[i],ssl_priv->prev_y[i]);
						//finger[i] move
					}
					else{
						SSL_PRINT("Finger%d enter:(%d,%d)\n",i,ssl_priv->prev_x[i],ssl_priv->prev_y[i]);
						ssl_priv->fingerbits|=(1<<i);
						ssl_priv->touchtime[i]=jiffies+HZ*30/1000;
						//finger[i] enter
					}
					//report finger[i] coordinate here
					SSL_PRINT("line%d\n",__LINE__);
					tpd_down(ssl_priv->prev_x[i], ssl_priv->prev_y[i]);					
				}
			}
			else{
				if(ssl_priv->fingers & bitmask){
					//finger[i] leave
					SSL_PRINT("Finger%d leave:(%d,%d)\n",i,ssl_priv->prev_x[i],ssl_priv->prev_y[i]);
					
					tpd_up(ssl_priv->prev_x[i],ssl_priv->prev_y[i]);

					ssl_priv->fingerbits&=~(1<<i);

				}
			}
		}
		old_flag=ssl_priv->fingers;
		ssl_priv->fingers=finger_flag;
	}

	//input_sync(ssl_priv->input);
	input_sync(tpd->dev);
	if(IsWrongReport(old_flag,finger_flag)){
		deviceWakeUp(ssl_priv);
		return;
	}
	if((old_flag==0) && (finger_flag!=0) && (ssl_priv->binitialrun==1)){	//the first time finger on after sleep out
		ssl_priv->binitialrun=2;
		{	//only SSD2531 needs auto-calibration  //longxuewei 20111227
			ssl_priv->bcalibrating=1;
			if(ssd253x_delta(ssl_priv,0)){	//oops, there is abnormal finger hole
				printk("SSD253X: Lens deformation detected, now reset!\n");
				/*
				reg_buff[0]=0xa2;
				reg_buff[1]=0x01;
				mdelay(BENDING_DELAY);
				i2c_send(reg_buff,2);
				//ssd253x_write_cmd(ssl_priv->client,0xA2,reg_buff,1);
				ssl_priv->cal_tick=-1;
				hrtimer_start(&ssl_priv->timer, ktime_set(0, 300*1000000), HRTIMER_MODE_REL); //check again after 300ms
				*/
				deviceWakeUp(ssl_priv);
				return;
			}
			else{
				ssl_priv->bcalibrating=0;
			}
		}
	}

	if(button_flag==0 && finger_flag ==0){	//no finger or button on, so no need to monitor status
		SSL_PRINT("No finger or button on.\n");
		if(ssl_priv->cal_tick>=1){
			ssl_priv->cal_tick=0;
			reg_buff[0]=0x26;
			ret=i2c_recv(reg_buff,1,1);   //ssd253x_read_reg(ssl_priv->client,0x26,reg_buff,1,1);
			if((ret!=0)||(reg_buff[0]==0)){	//oops, the TP was reset, need re-init
				printk("SSD253X: TP was reset, now restart it!\n");
				deviceWakeUp(ssl_priv);
			}
			else{
				if(ssl_priv->binitialrun){
					if(time_before(jiffies,ssl_priv->cal_end_time)){	//only check when bootup/sleepout
						ssl_priv->cal_counter++;
						ssl_priv->bcalibrating=1;
						if(ssd253x_delta(ssl_priv,0)){	//oops, there is abnormal finger hole
							printk("SSD253X: Finger hole detected, now calibrate!\n");
							reg_buff[0]=0xa2;
							reg_buff[1]=0x01;
							i2c_send(reg_buff,2);
							ssl_priv->cal_tick=-1;
							SSL_PRINT("Calibrate! ssl_priv->cal_counter=%d.\n",ssl_priv->cal_counter);
						}
						else{
								ssl_priv->bcalibrating=0;
						}
					}
					else{
						printk("SSD253X: Totally checked finger hole for %d times.\n",ssl_priv->cal_counter);
						ssl_priv->binitialrun=0;
					}
				}
			}
		}
		ssl_priv->cal_tick++;
		if(ssl_priv->bcalibrating==1){
			hrtimer_start(&ssl_priv->timer, ktime_set(0, CAL_DELAY*1000000), HRTIMER_MODE_REL); //check again after 300ms
			return;
		}
		if(ssl_priv->binitialrun==1)
			hrtimer_start(&ssl_priv->timer, ktime_set(0, CAL_INTERVAL*1000000), HRTIMER_MODE_REL); //check again after 30ms
		else if(ssl_priv->binitialrun==2)
			hrtimer_start(&ssl_priv->timer, ktime_set(0, 500000000), HRTIMER_MODE_REL); //check again after 500ms
		else
			hrtimer_start(&ssl_priv->timer, ktime_set(0, 1000000000), HRTIMER_MODE_REL); //check again after 1s
	}
	else{
		ssl_priv->cal_tick=0;
		hrtimer_start(&ssl_priv->timer, ktime_set(0, 16600000), HRTIMER_MODE_REL); //polling for finger up after 16.6ms.
	}
}


static int touch_event_handler(void *unused) {
    struct sched_param param = { .sched_priority = RTPM_PRIO_TPD };

    sched_setscheduler(current, SCHED_RR, &param);
    do {		
/*
	#ifdef MT6516	
        MT6516_EINTIRQUnmask(CUST_EINT_TOUCH_PANEL_NUM); // possibly to lose event?
        #endif
	#ifdef MT6573
        mt65xx_eint_unmask(CUST_EINT_TOUCH_PANEL_NUM); // possibly to lose event?
	#endif
*/
SSL_PRINT("Run into %s.\n",__FUNCTION__);
        set_current_state(TASK_INTERRUPTIBLE);
	while ( tpd_halt )
        {
            tpd_flag = 0;
            msleep(20);
        }
        wait_event_interruptible(waiter, tpd_flag != 0);
        tpd_flag = 0;
        TPD_DEBUG_SET_TIME;
        set_current_state(TASK_RUNNING); 

	ssd253x_ts_work(&ssd2531_priv);        

    } while (!kthread_should_stop());
	
    return 0;
}


static int tpd_i2c_detect(struct i2c_client *client, int kind, struct i2c_board_info *info)
{
    strcpy(info->type, "mtk-tpd");
    return 0;
}


static int tpd_i2c_probe(struct i2c_client *client, const struct i2c_device_id *id)
{      
    int err = 0;
    i2c_client = client;

    TPD_DEBUG("Tp_init\r\n");
    hwPowerDown(TPD_POWER_SOURCE,"TP");
    hwPowerOn(TPD_POWER_SOURCE,VOL_2800,"TP");//LK@2010-9-1, 2.8v
    msleep(100);

//reset 	
    mt_set_gpio_mode(GPIO_CTP_RST_PIN, 0);		//GPIO_CTP_RST_PIN
    mt_set_gpio_dir(GPIO_CTP_RST_PIN, GPIO_DIR_OUT);		
    mt_set_gpio_out(GPIO_CTP_RST_PIN, GPIO_OUT_ZERO);
    mt_set_gpio_pull_enable(GPIO_CTP_RST_PIN, GPIO_PULL_ENABLE);
    mt_set_gpio_pull_select(GPIO_CTP_RST_PIN, GPIO_PULL_UP);

    // set INT mode
    mt_set_gpio_mode(GPIO_CTP_EINT_PIN, GPIO_CTP_EINT_PIN_M_EINT);
    mt_set_gpio_dir(GPIO_CTP_EINT_PIN, GPIO_DIR_IN);
    mt_set_gpio_pull_enable(GPIO_CTP_EINT_PIN, GPIO_PULL_ENABLE);
    mt_set_gpio_pull_select(GPIO_CTP_EINT_PIN, GPIO_PULL_UP);
    msleep(5);

//dev_set_drvdata(&client->dev, ssl_priv);
	

    err =deviceInit();
    if (err)
    {
	TPD_DMESG(TPD_DEVICE " fail to get tpd info %d\n", err );
	return err;
    }


    tpd_load_status = 1;
    ssd2531_priv.finger_count=4;
    hrtimer_init(&ssd2531_priv.timer, CLOCK_MONOTONIC, HRTIMER_MODE_REL);
    ssd2531_priv.timer.function = ssd253x_ts_timer;

	
    thread = kthread_run(touch_event_handler, 0, TPD_DEVICE);
    if (IS_ERR(thread)) { 
        err = PTR_ERR(thread);
        TPD_DMESG(TPD_DEVICE " failed to create kernel thread: %d\n", err);
    }

   #ifdef MT6516
    MT6516_EINT_Set_Sensitivity(CUST_EINT_TOUCH_PANEL_NUM, CUST_EINT_TOUCH_PANEL_SENSITIVE);
    MT6516_EINT_Set_HW_Debounce(CUST_EINT_TOUCH_PANEL_NUM, CUST_EINT_TOUCH_PANEL_DEBOUNCE_CN);
    MT6516_EINT_Registration(CUST_EINT_TOUCH_PANEL_NUM, CUST_EINT_TOUCH_PANEL_DEBOUNCE_EN, CUST_EINT_TOUCH_PANEL_POLARITY, tpd_eint_interrupt_handler, 1);
    MT6516_EINTIRQUnmask(CUST_EINT_TOUCH_PANEL_NUM);
   #endif

   #if defined(MT6573) || defined(MT6575)
    mt65xx_eint_set_sens(CUST_EINT_TOUCH_PANEL_NUM, CUST_EINT_TOUCH_PANEL_SENSITIVE);
    mt65xx_eint_set_hw_debounce(CUST_EINT_TOUCH_PANEL_NUM, CUST_EINT_TOUCH_PANEL_DEBOUNCE_CN);
    mt65xx_eint_registration(CUST_EINT_TOUCH_PANEL_NUM, CUST_EINT_TOUCH_PANEL_DEBOUNCE_EN, CUST_EINT_TOUCH_PANEL_POLARITY, tpd_eint_interrupt_handler, 1);
    //mt65xx_eint_registration(CUST_EINT_TOUCH_PANEL_NUM, CUST_EINT_TOUCH_PANEL_DEBOUNCE_EN, CUST_EINT_POLARITY_HIGH, tpd_eint_interrupt_handler, 1);
    mt65xx_eint_unmask(CUST_EINT_TOUCH_PANEL_NUM);
   #endif  


    return 0;
}

static int tpd_i2c_remove(struct i2c_client *client)
{
    return 0;
}


static int tpd_local_init(void) 
{

    TPD_DEBUG("tpd_local_init\r\n");

    if(i2c_add_driver(&tpd_i2c_driver)!=0)
    {
        TPD_DMESG("unable to add i2c driver.\n");
        return -1;
    }
    if(tpd_load_status == 0)
    {
    	TPD_DMESG("add error touch panel driver.\n");
    	i2c_del_driver(&tpd_i2c_driver);
    	return -1;
    }

    tpd_type_cap = 1;
    return 0;
}


static void tpd_suspend(struct early_suspend *h) {
    char sleep[2] = {0x25,0x00};
    TPD_DEBUG("tpd_suspend start\r\n");
	
#ifdef MT6516
    MT6516_EINTIRQMask(CUST_EINT_TOUCH_PANEL_NUM);
    MT6516_IRQMask(MT6516_TOUCH_IRQ_LINE);
#endif
#if defined(MT6573) || defined(MT6575)
    mt65xx_eint_mask(CUST_EINT_TOUCH_PANEL_NUM);
   // MT6573_IRQMask(MT6573_TOUCH_IRQ_LINE);  //longxw ?
#endif
    
    deviceSleep(&ssd2531_priv);  
 
    tpd_halt = 1;

}


static void tpd_resume(struct early_suspend *h) {
   TPD_DEBUG("tpd_resume start\r\n");

   deviceWakeUp(&ssd2531_priv);   
#ifdef MT6516	
    MT6516_IRQUnmask(MT6516_TOUCH_IRQ_LINE);    
    MT6516_EINTIRQUnmask(CUST_EINT_TOUCH_PANEL_NUM);    
#endif
#if defined(MT6573) || defined(MT6575)
    mt65xx_eint_unmask(CUST_EINT_TOUCH_PANEL_NUM); 
    //MT6573_IRQUnmask(MT6573_TOUCH_IRQ_LINE);  //longxw ?
#endif
    tpd_halt = 0;
}

static struct tpd_driver_t tpd_device_driver =
{
    .tpd_device_name = "ssd2531",
    .tpd_local_init = tpd_local_init,
    .suspend = tpd_suspend,
    .resume = tpd_resume,
#ifdef TPD_HAVE_BUTTON
    .tpd_have_button = 1,
#else
    .tpd_have_button = 0,
#endif		
};

/* called when loaded into kernel */
static int __init tpd_driver_init(void)
{
    TPD_DMESG("MediaTek ssd2531 touch panel driver init\n");

    if ( tpd_driver_add(&tpd_device_driver) < 0)
        TPD_DMESG("add generic driver failed\n");

    return 0;
}

/* should never be called */
static void __exit tpd_driver_exit(void)
{
    TPD_DMESG("MediaTek ssd2531 touch panel driver exit\n");
    //input_unregister_device(tpd->dev);
    tpd_driver_remove(&tpd_device_driver);
}

module_init(tpd_driver_init);
module_exit(tpd_driver_exit);
