/* Copyright Statement:
 *
 * This software/firmware and related documentation ("MediaTek Software") are
 * protected under relevant copyright laws. The information contained herein
 * is confidential and proprietary to MediaTek Inc. and/or its licensors.
 * Without the prior written permission of MediaTek inc. and/or its licensors,
 * any reproduction, modification, use or disclosure of MediaTek Software,
 * and information contained herein, in whole or in part, shall be strictly prohibited.
 *
 * MediaTek Inc. (C) 2010. All rights reserved.
 *
 * BY OPENING THIS FILE, RECEIVER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND AGREES
 * THAT THE SOFTWARE/FIRMWARE AND ITS DOCUMENTATIONS ("MEDIATEK SOFTWARE")
 * RECEIVED FROM MEDIATEK AND/OR ITS REPRESENTATIVES ARE PROVIDED TO RECEIVER ON
 * AN "AS-IS" BASIS ONLY. MEDIATEK EXPRESSLY DISCLAIMS ANY AND ALL WARRANTIES,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR NONINFRINGEMENT.
 * NEITHER DOES MEDIATEK PROVIDE ANY WARRANTY WHATSOEVER WITH RESPECT TO THE
 * SOFTWARE OF ANY THIRD PARTY WHICH MAY BE USED BY, INCORPORATED IN, OR
 * SUPPLIED WITH THE MEDIATEK SOFTWARE, AND RECEIVER AGREES TO LOOK ONLY TO SUCH
 * THIRD PARTY FOR ANY WARRANTY CLAIM RELATING THERETO. RECEIVER EXPRESSLY ACKNOWLEDGES
 * THAT IT IS RECEIVER'S SOLE RESPONSIBILITY TO OBTAIN FROM ANY THIRD PARTY ALL PROPER LICENSES
 * CONTAINED IN MEDIATEK SOFTWARE. MEDIATEK SHALL ALSO NOT BE RESPONSIBLE FOR ANY MEDIATEK
 * SOFTWARE RELEASES MADE TO RECEIVER'S SPECIFICATION OR TO CONFORM TO A PARTICULAR
 * STANDARD OR OPEN FORUM. RECEIVER'S SOLE AND EXCLUSIVE REMEDY AND MEDIATEK'S ENTIRE AND
 * CUMULATIVE LIABILITY WITH RESPECT TO THE MEDIATEK SOFTWARE RELEASED HEREUNDER WILL BE,
 * AT MEDIATEK'S OPTION, TO REVISE OR REPLACE THE MEDIATEK SOFTWARE AT ISSUE,
 * OR REFUND ANY SOFTWARE LICENSE FEES OR SERVICE CHARGE PAID BY RECEIVER TO
 * MEDIATEK FOR SUCH MEDIATEK SOFTWARE AT ISSUE.
 *
 * The following software/firmware and/or related documentation ("MediaTek Software")
 * have been modified by MediaTek Inc. All revisions are subject to any receiver's
 * applicable license agreements with MediaTek Inc.
 */

#include <mach/mt6575_typedefs.h>

#define FGAUGE_VOLTAGE_FACTOR           2.44 // mV
#define FGAUGE_CURRENT_FACTOR           6.25 // uV/Rsns
#define FGAUGE_CURRENT_OFFSET_FACTOR    1.56 // uV/Rsns
#define FGAUGE_CAR_FACTOR               6.25 // uV/Rsns
#define FGAUGE_RSNS_FACTOR              0.02 // Ohm

//#define COMPASATE_OCV                   80 // mV for evb
#define COMPASATE_OCV                   40 // mV for phone

#define BATTERY_VOLTAGE_MINIMUM         3400
#define BATTERY_VOLTAGE_MAXIMUM         4200

#if defined(ACER_Z1)
#define BATTERY_CAPACITY_MAXIMUM        1322
#else
#define BATTERY_CAPACITY_MAXIMUM        1500//1135,LK@I3000
#endif
#define TEMPERATURE_T0                  110
#define TEMPERATURE_T1                  0
#define TEMPERATURE_T2                  25
#define TEMPERATURE_T3                  50
#define TEMPERATURE_T                   255 // This should be fixed, never change the value

//#define BATT_CAPACITY                   1280
#if defined(SIMCOM_I3200)
#define BATT_CAPACITY                   3000
#elif defined(ACER_Z1)
#define BATT_CAPACITY                   1299
#else
#define BATT_CAPACITY                   1500//1135,LK@I300
#endif

#define ENABLE_SW_COULOMB_COUNTER       0 // 1 is enable, 0 is disable
//#define ENABLE_SW_COULOMB_COUNTER       1 // 1 is enable, 0 is disable

//#define FG_CURRENT_OFFSET_DISCHARGING 	31
#define FG_CURRENT_OFFSET_DISCHARGING 	0

#define FG_RESISTANCE 	20

#define FG_METER_RESISTANCE 	0
//#define FG_METER_RESISTANCE 	540 // current meter

//#define MAX_BOOTING_TIME_FGCURRENT	5*6 // 5 seconds, 6 points = 1s
#define MAX_BOOTING_TIME_FGCURRENT	1*10 // 10s

#if defined(CONFIG_POWER_EXT)
//#define OCV_BOARD_COMPESATE	32 //mV 
#define OCV_BOARD_COMPESATE	72 //mV 
#define R_FG_BOARD_BASE		1000
#define R_FG_BOARD_SLOPE	1000 //slope
#else
//#define OCV_BOARD_COMPESATE	0 //mV 
//#define OCV_BOARD_COMPESATE	48 //mV 
//#define OCV_BOARD_COMPESATE	25 //mV 
#define OCV_BOARD_COMPESATE	0 //mV 
#define R_FG_BOARD_BASE		1000
#define R_FG_BOARD_SLOPE	1000 //slope
//#define R_FG_BOARD_SLOPE	1057 //slope
//#define R_FG_BOARD_SLOPE	1075 //slope
#endif

#if defined(SIMCOM_I3200)
#define Q_MAX_POS_50	3020
#define Q_MAX_POS_25	3000
#define Q_MAX_POS_0		2800
#define Q_MAX_NEG_10	2667

#define Q_MAX_POS_50_H_CURRENT	2972
#define Q_MAX_POS_25_H_CURRENT	2915
#define Q_MAX_POS_0_H_CURRENT	2529
#define Q_MAX_NEG_10_H_CURRENT	1374
#elif defined(ACER_Z1)
#define Q_MAX_POS_50	1322
#define Q_MAX_POS_25	1299
#define Q_MAX_POS_0		1241
#define Q_MAX_NEG_10	1163

#define Q_MAX_POS_50_H_CURRENT	1308
#define Q_MAX_POS_25_H_CURRENT	1241
#define Q_MAX_POS_0_H_CURRENT	1197
#define Q_MAX_NEG_10_H_CURRENT	1018
#elif 1//LK@I3000
#define Q_MAX_POS_50	1510
#define Q_MAX_POS_25	1500
#define Q_MAX_POS_0		1400
#define Q_MAX_NEG_10	1334

#define Q_MAX_POS_50_H_CURRENT	1486
#define Q_MAX_POS_25_H_CURRENT	1458
#define Q_MAX_POS_0_H_CURRENT	1265
#define Q_MAX_NEG_10_H_CURRENT	687
#else
#define Q_MAX_POS_50	1135
#define Q_MAX_POS_25	1135
#define Q_MAX_POS_0		1062
#define Q_MAX_NEG_10	971

#define Q_MAX_POS_50_H_CURRENT	1119
#define Q_MAX_POS_25_H_CURRENT	1119
#define Q_MAX_POS_0_H_CURRENT	959
#define Q_MAX_NEG_10_H_CURRENT	817
#endif
#define R_FG_VALUE 				20 // mOhm, base is 20
#define CURRENT_DETECT_R_FG	100  //10mA

#define OSR_SELECT_7			0

#if defined(ACER_Z1)
#define CAR_TUNE_VALUE			99
#else
#define CAR_TUNE_VALUE			106 //1.06
#endif
/////////////////////////////////////////////////////////////////////
// <DOD, Battery_Voltage> Table
/////////////////////////////////////////////////////////////////////
typedef struct _BATTERY_PROFILE_STRUC
{
    kal_int32 percentage;
    kal_int32 voltage;
} BATTERY_PROFILE_STRUC, *BATTERY_PROFILE_STRUC_P;

typedef enum
{
    T1_0C,
    T2_25C,
    T3_50C
} PROFILE_TEMPERATURE;

#if defined(ACER_Z1)
// T0 -10C
BATTERY_PROFILE_STRUC battery_profile_t0[] =
{
    {0 ,4168},
    {2 ,4148},
    {3 ,4108},
    {5 ,4081},
    {7 ,4045},
    {9 ,4010},
    {10,3990},
    {12,3977},
    {14,3966},
    {15,3958},
    {17,3952},
    {19,3948},
    {21,3944},
    {22,3938},
    {24,3930},
    {26,3921},
    {27,3913},
    {29,3902},
    {31,3891},
    {33,3879},
    {34,3868},
    {36,3856},
    {38,3846},
    {39,3837},
    {41,3829},
    {43,3822},
    {45,3817},
    {46,3812},
    {48,3807},
    {50,3803},
    {52,3800},
    {53,3797},
    {55,3793},
    {57,3791},
    {58,3790},
    {60,3788},
    {62,3788},
    {63,3787},
    {65,3787},
    {67,3786},
    {69,3784},
    {70,3783},
    {72,3781},
    {74,3778},
    {75,3773},
    {77,3768},
    {79,3760},
    {81,3751},
    {82,3740},
    {84,3727},
    {86,3718},
    {88,3714},
    {89,3710},
    {91,3707},
    {93,3704},
    {94,3697},
    {96,3684},
    {97,3659},
    {97,3632},
    {98,3608},
    {98,3584},
    {99,3565},
    {99,3546},
    {99,3531},
    {99,3516},
    {100,3505},
    {100,3495},
    {100,3486},
    {100,3478},
    {100,3472},
    {100,3400}
};      
        
// T1 0C
BATTERY_PROFILE_STRUC battery_profile_t1[] =
{       
    {0 ,4152},
    {2 ,4125},
    {3 ,4108},
    {5 ,4096},
    {6 ,4090},
    {8 ,4082},
    {10,4056},
    {11,4023},
    {13,3999},
    {15,3984},
    {16,3973},
    {18,3965},
    {19,3959},
    {21,3956},
    {22,3952},
    {24,3945},
    {26,3936},
    {27,3928},
    {29,3920},
    {31,3912},
    {32,3903},
    {34,3894},
    {35,3884},
    {37,3872},
    {39,3860},
    {40,3848},
    {42,3837},
    {43,3828},
    {45,3821},
    {47,3815},
    {48,3809},
    {50,3806},
    {51,3801},
    {53,3797},
    {55,3794},
    {56,3792},
    {58,3788},
    {59,3787},
    {61,3785},
    {63,3784},
    {64,3784},
    {66,3785},
    {68,3784},
    {69,3783},
    {71,3783},
    {72,3782},
    {74,3779},
    {76,3777},
    {77,3771},
    {79,3765},
    {80,3756},
    {82,3745},
    {84,3732},
    {85,3718},
    {87,3711},
    {88,3708},
    {90,3704},
    {92,3702},
    {93,3700},
    {95,3691},
    {97,3645},
    {98,3560},
    {99,3497},
    {100,3453},
    {100,3419},
    {100,3396},
    {100,3379},
    {100,3368},
    {100,3358},
    {100,3351},
    {100,3351}
};      

// T2 25C
BATTERY_PROFILE_STRUC battery_profile_t2[] =
{
    {0 ,4178},
    {2 ,4158},
    {3 ,4141},
    {5 ,4125},
    {6 ,4109},
    {8 ,4095},
    {9 ,4083},
    {11,4076},
    {12,4067},
    {14,4046},
    {15,4020},
    {17,4001},
    {18,3988},
    {20,3981},
    {21,3975},
    {23,3969},
    {25,3960},
    {26,3951},
    {28,3943},
    {29,3933},
    {31,3925},
    {32,3917},
    {34,3909},
    {35,3901},
    {37,3893},
    {38,3885},
    {40,3876},
    {41,3864},
    {43,3850},
    {45,3838},
    {46,3827},
    {48,3819},
    {49,3813},
    {51,3808},
    {52,3803},
    {54,3799},
    {55,3795},
    {57,3792},
    {58,3789},
    {60,3785},
    {61,3782},
    {63,3780},
    {65,3778},
    {66,3777},
    {68,3776},
    {69,3775},
    {71,3773},
    {72,3772},
    {74,3769},
    {75,3766},
    {77,3760},
    {78,3753},
    {80,3748},
    {81,3742},
    {83,3730},
    {85,3719},
    {86,3705},
    {88,3695},
    {89,3692},
    {91,3691},
    {92,3689},
    {94,3688},
    {95,3679},
    {97,3633},
    {98,3554},
    {100,3424},
    {100,3318},
    {100,3290},
    {100,3280},
    {100,3270},
    {100,3270}
};

// T3 50C
BATTERY_PROFILE_STRUC battery_profile_t3[] =
{
    {0 ,4185},
    {2 ,4168},
    {3 ,4151},
    {5 ,4134},
    {6 ,4119},
    {8 ,4106},
    {9 ,4091},
    {11,4077},
    {12,4065},
    {14,4053},
    {15,4041},
    {17,4026},
    {18,4012},
    {20,4002},
    {21,3992},
    {23,3981},
    {24,3971},
    {26,3961},
    {27,3951},
    {29,3941},
    {30,3933},
    {32,3924},
    {33,3915},
    {35,3907},
    {36,3899},
    {38,3892},
    {39,3883},
    {41,3875},
    {42,3863},
    {44,3848},
    {45,3834},
    {47,3825},
    {48,3818},
    {50,3811},
    {51,3806},
    {53,3802},
    {54,3797},
    {56,3793},
    {57,3789},
    {59,3786},
    {60,3783},
    {62,3780},
    {63,3778},
    {65,3775},
    {66,3773},
    {68,3770},
    {69,3767},
    {71,3760},
    {72,3753},
    {74,3751},
    {75,3748},
    {77,3743},
    {79,3737},
    {80,3731},
    {82,3725},
    {83,3716},
    {85,3705},
    {86,3692},
    {88,3680},
    {89,3679},
    {91,3678},
    {92,3677},
    {94,3675},
    {95,3664},
    {97,3621},
    {98,3552},
    {100,3445},
    {100,3324},
    {100,3295},
    {100,3281},
    {100,3281}
};             

// battery profile for actual temperature. The size should be the same as T1, T2 and T3
BATTERY_PROFILE_STRUC battery_profile_temperature[] =
{
  {0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },  
	{0  , 0 }, 
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },  
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
  	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 }
};      

/////////////////////////////////////////////////////////////////////
// <Rbat, Battery_Voltage> Table
/////////////////////////////////////////////////////////////////////
typedef struct _R_PROFILE_STRUC
{
    kal_int32 resistance; // Ohm
    kal_int32 voltage;
} R_PROFILE_STRUC, *R_PROFILE_STRUC_P;

// T0 -10C
R_PROFILE_STRUC r_profile_t0[] =
{
    {335 ,4168},
    {335 ,4148},
    {368 ,4108},
    {468 ,4081},
    {490 ,4045},
    {490 ,4010},
    {500 ,3990},
    {508 ,3977},
    {510 ,3966},
    {515 ,3958},
    {523 ,3952},
    {533 ,3948},
    {540 ,3944},
    {545 ,3938},
    {548 ,3930},
    {548 ,3921},
    {550 ,3913},
    {545 ,3902},
    {540 ,3891},
    {533 ,3879},
    {528 ,3868},
    {520 ,3856},
    {518 ,3846},
    {518 ,3837},
    {518 ,3829},
    {518 ,3822},
    {525 ,3817},
    {530 ,3812},
    {535 ,3807},
    {543 ,3803},
    {548 ,3800},
    {558 ,3797},
    {560 ,3793},
    {565 ,3791},
    {573 ,3790},
    {575 ,3788},
    {583 ,3788},
    {588 ,3787},
    {595 ,3787},
    {603 ,3786},
    {610 ,3784},
    {620 ,3783},
    {630 ,3781},
    {640 ,3778},
    {648 ,3773},
    {660 ,3768},
    {670 ,3760},
    {685 ,3751},
    {703 ,3740},
    {720 ,3727},
    {743 ,3718},
    {785 ,3714},
    {838 ,3710},
    {915 ,3707},
    {1025,3704},
    {1183,3697},
    {1215,3684},
    {1155,3659},
    {1088,3632},
    {1030,3608},
    {968 ,3584},
    {913 ,3565},
    {875 ,3546},
    {835 ,3531},
    {800 ,3516},
    {765 ,3505},
    {745 ,3495},
    {720 ,3486},
    {703 ,3478},
    {683 ,3472},
    {513 ,3400}
};      

// T1 0C
R_PROFILE_STRUC r_profile_t1[] =
{
    {275,4152},
    {275,4125},
    {283,4108},
    {290,4096},
    {305,4090},
    {325,4082},
    {320,4056},
    {320,4023},
    {320,3999},
    {325,3984},
    {328,3973},
    {333,3965},
    {333,3959},
    {340,3956},
    {350,3952},
    {350,3945},
    {348,3936},
    {353,3928},
    {355,3920},
    {355,3912},
    {355,3903},
    {353,3894},
    {348,3884},
    {338,3872},
    {328,3860},
    {315,3848},
    {305,3837},
    {303,3828},
    {300,3821},
    {303,3815},
    {303,3809},
    {305,3806},
    {308,3801},
    {310,3797},
    {313,3794},
    {320,3792},
    {320,3788},
    {325,3787},
    {323,3785},
    {328,3784},
    {333,3784},
    {338,3785},
    {340,3784},
    {343,3783},
    {348,3783},
    {350,3782},
    {350,3779},
    {353,3777},
    {350,3771},
    {353,3765},
    {353,3756},
    {353,3745},
    {358,3732},
    {355,3718},
    {360,3711},
    {373,3708},
    {388,3704},
    {418,3702},
    {473,3700},
    {548,3691},
    {625,3645},
    {798,3560},
    {748,3497},
    {638,3453},
    {560,3419},
    {495,3396},
    {460,3379},
    {423,3368},
    {410,3358},
    {393,3351},
    {383,3351}
};      

// T2 25C
R_PROFILE_STRUC r_profile_t2[] =
{
    {148,4178},
    {148,4158},
    {153,4141},
    {155,4125},
    {155,4109},
    {160,4095},
    {163,4083},
    {170,4076},
    {178,4067},
    {175,4046},
    {173,4020},
    {175,4001},
    {175,3988},
    {178,3981},
    {185,3975},
    {190,3969},
    {188,3960},
    {193,3951},
    {200,3943},
    {198,3933},
    {203,3925},
    {208,3917},
    {213,3909},
    {213,3901},
    {215,3893},
    {213,3885},
    {210,3876},
    {200,3864},
    {185,3850},
    {173,3838},
    {163,3827},
    {155,3819},
    {158,3813},
    {158,3808},
    {158,3803},
    {160,3799},
    {160,3795},
    {163,3792},
    {163,3789},
    {163,3785},
    {163,3782},
    {165,3780},
    {168,3778},
    {170,3777},
    {170,3776},
    {173,3775},
    {170,3773},
    {173,3772},
    {170,3769},
    {173,3766},
    {165,3760},
    {163,3753},
    {165,3748},
    {170,3742},
    {165,3730},
    {168,3719},
    {165,3705},
    {160,3695},
    {160,3692},
    {170,3691},
    {178,3689},
    {190,3688},
    {200,3679},
    {205,3633},
    {233,3554},
    {283,3424},
    {300,3318},
    {230,3290},
    {203,3280},
    {185,3270},
    {185,3270} 
};

// T3 50C
R_PROFILE_STRUC r_profile_t3[] =
{
    {123,4185},
    {123,4168},
    {125,4151},
    {128,4134},
    {130,4119},
    {135,4106},
    {135,4091},
    {135,4077},
    {140,4065},
    {140,4053},
    {145,4041},
    {145,4026},
    {143,4012},
    {148,4002},
    {150,3992},
    {150,3981},
    {153,3971},
    {155,3961},
    {155,3951},
    {155,3941},
    {163,3933},
    {165,3924},
    {168,3915},
    {170,3907},
    {175,3899},
    {183,3892},
    {180,3883},
    {183,3875},
    {170,3863},
    {153,3848},
    {138,3834},
    {133,3825},
    {130,3818},
    {130,3811},
    {130,3806},
    {133,3802},
    {135,3797},
    {135,3793},
    {138,3789},
    {140,3786},
    {143,3783},
    {145,3780},
    {148,3778},
    {148,3775},
    {150,3773},
    {148,3770},
    {148,3767},
    {135,3760},
    {128,3753},
    {135,3751},
    {140,3748},
    {138,3743},
    {135,3737},
    {138,3731},
    {138,3725},
    {138,3716},
    {138,3705},
    {138,3692},
    {128,3680},
    {130,3679},
    {140,3678},
    {148,3677},
    {155,3675},
    {158,3664},
    {178,3621},
    {203,3552},
    {248,3445},
    {315,3324},
    {240,3295},
    {208,3281},
    {208,3281}
};

// r-table profile for actual temperature. The size should be the same as T1, T2 and T3
R_PROFILE_STRUC r_profile_temperature[] =
{	
  {0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },  
	{0  , 0 }, 
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },  
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 }
};      
#else
// T0 -10C
BATTERY_PROFILE_STRUC battery_profile_t0[] =
{
	{0  , 4164},
	{2  , 4145},
	{4  , 4119},
	{5  , 4084},
	{7  , 4042},
	{9  , 4006},
	{11 , 3987},
	{12 , 3974},
	{14 , 3963},
	{16 , 3951},
	{18 , 3941},
	{19 , 3928},
	{21 , 3919},
	{23 , 3906},
	{25 , 3897},
	{26 , 3883},
	{28 , 3873},
	{30 , 3858},
	{32 , 3846},
	{33 , 3835},
	{35 , 3825},
	{37 , 3815},
	{39 , 3807},
	{40 , 3802},
	{42 , 3796},
	{44 , 3793},
	{46 , 3791},
	{47 , 3788},  
	{49 , 3788}, 
	{51 , 3786},
	{53 , 3786},
	{55 , 3784},  
	{56 , 3782},
	{58 , 3780},
	{60 , 3778},
	{62 , 3776},
	{63 , 3770},
	{65 , 3764},
	{67 , 3753},
	{69 , 3741},
	{70 , 3728},
	{72 , 3711},
	{74 , 3692},
	{76 , 3670},
	{77 , 3646},
	{79 , 3618},
	{81 , 3591},
	{82 , 3575},
	{83 , 3565},
	{83 , 3556},
	{84 , 3550},
	{84 , 3546},
	{84 , 3540},
	{85 , 3538},
	{85 , 3533},
	{85 , 3531},
	{85 , 3529},
	{85 , 3527},
	{85 , 3526},
	{85 , 3521},
	{100 , 3400}
};      
        
// T1 0C
BATTERY_PROFILE_STRUC battery_profile_t1[] =
{       
	{0  , 4164},
	{2  , 4120},
	{4  , 4088},
	{5  , 4065},
	{7  , 4041},
	{9  , 4019},
	{11 , 4003},
	{12 , 3988},
	{14 , 3977},
	{16 , 3965},
	{18 , 3955},
	{19 , 3944},
	{21 , 3933},
	{23 , 3921},
	{25 , 3911},
	{26 , 3901},
	{28 , 3890},
	{30 , 3880},
	{32 , 3868},
	{33 , 3856},
	{35 , 3843},
	{37 , 3832},
	{39 , 3822},
	{40 , 3812},
	{42 , 3805},
	{44 , 3798},
	{46 , 3793},
	{47 , 3791},  
	{49 , 3787}, 
	{51 , 3785},
	{53 , 3785},
	{55 , 3784},  
	{56 , 3783},
	{58 , 3783},
	{60 , 3782},
	{62 , 3780},
	{63 , 3779},
	{65 , 3778},
	{67 , 3775},
	{69 , 3770},
	{70 , 3764},
	{72 , 3756},
	{74 , 3742},
	{76 , 3727},
	{77 , 3709},
	{79 , 3685},
	{81 , 3656},
	{83 , 3627},
	{84 , 3600},
	{86 , 3578},
	{88 , 3558},
	{90 , 3536},
	{91 , 3491},
	{92 , 3453},
	{93 , 3435},
	{93 , 3423},
	{93 , 3415},
	{93 , 3410},
	{93 , 3407},
	{94 , 3403},
	{100 , 3400}
};      

// T2 25C
BATTERY_PROFILE_STRUC battery_profile_t2[] =
{
	{0   , 4177},
	{2   , 4150},
	{4   , 4129},
	{5   , 4110},
	{7   , 4092},
	{9   , 4075},
	{11  , 4060},
	{12  , 4042},
	{14  , 4023},
	{16  , 4009},
	{18  , 3995},
	{19  , 3983},
	{21  , 3970},
	{23  , 3958},
	{25  , 3946},
	{26  , 3935},
	{28  , 3923},
	{30  , 3913},
	{32  , 3903},
	{33  , 3892},
	{35  , 3885},
	{37  , 3874},
	{39  , 3865},
	{40  , 3857},
	{42  , 3846},
	{44  , 3833},
	{46  , 3820},
	{47  , 3809},  
	{49  , 3800}, 
	{51  , 3793},
	{53  , 3788},
	{55  , 3785},  
	{56  , 3781},
	{58  , 3779},
	{60  , 3778},
	{62  , 3777},
	{63  , 3775},
	{65  , 3774},
	{67  , 3773},
	{69  , 3771},
	{70  , 3770},
	{72  , 3768},
	{74  , 3763},
	{76  , 3758},
	{77  , 3751},
	{79  , 3740},
	{81  , 3731},
	{83  , 3719},
	{84  , 3704},
	{86  , 3683},
	{88  , 3657},
	{90  , 3626},
	{91  , 3598},
	{93  , 3577},
	{95  , 3559},
	{97  , 3536},
	{99  , 3480},
	{100 , 3389},
	{100 , 3389},
	{100 , 3389},
	{100 , 3389}      
};

// T3 50C
BATTERY_PROFILE_STRUC battery_profile_t3[] =
{
	{0   , 4177},
	{2   , 4150},
	{4   , 4129},
	{5   , 4110},
	{7   , 4092},
	{9   , 4075},
	{11  , 4060},
	{12  , 4042},
	{14  , 4023},
	{16  , 4009},
	{18  , 3995},
	{19  , 3983},
	{21  , 3970},
	{23  , 3958},
	{25  , 3946},
	{26  , 3935},
	{28  , 3923},
	{30  , 3913},
	{32  , 3903},
	{33  , 3892},
	{35  , 3885},
	{37  , 3874},
	{39  , 3865},
	{40  , 3857},
	{42  , 3846},
	{44  , 3833},
	{46  , 3820},
	{47  , 3809},  
	{49  , 3800}, 
	{51  , 3793},
	{53  , 3788},
	{55  , 3785},  
	{56  , 3781},
	{58  , 3779},
	{60  , 3778},
	{62  , 3777},
	{63  , 3775},
	{65  , 3774},
	{67  , 3773},
	{69  , 3771},
	{70  , 3770},
	{72  , 3768},
	{74  , 3763},
	{76  , 3758},
	{77  , 3751},
	{79  , 3740},
	{81  , 3731},
	{83  , 3719},
	{84  , 3704},
	{86  , 3683},
	{88  , 3657},
	{90  , 3626},
	{91  , 3598},
	{93  , 3577},
	{95  , 3559},
	{97  , 3536},
	{99  , 3480},
	{100 , 3389},
	{100 , 3389},
	{100 , 3389},
	{100 , 3389} 
};             

// battery profile for actual temperature. The size should be the same as T1, T2 and T3
BATTERY_PROFILE_STRUC battery_profile_temperature[] =
{
  {0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },  
	{0  , 0 }, 
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },  
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 }
};      

/////////////////////////////////////////////////////////////////////
// <Rbat, Battery_Voltage> Table
/////////////////////////////////////////////////////////////////////
typedef struct _R_PROFILE_STRUC
{
    kal_int32 resistance; // Ohm
    kal_int32 voltage;
} R_PROFILE_STRUC, *R_PROFILE_STRUC_P;

// T0 -10C
R_PROFILE_STRUC r_profile_t0[] =
{
	{360 , 4164},
	{360 , 4145},
	{370 , 4119},
	{383 , 4084},
	{425 , 4042},
	{523 , 4006},
	{553 , 3987},
	{570 , 3974},
	{585 , 3963},
	{593 , 3951},
	{600 , 3941},
	{605 , 3928},
	{615 , 3919},
	{618 , 3906},
	{618 , 3897},
	{618 , 3883},
	{620 , 3873},
	{608 , 3858},
	{603 , 3846},
	{603 , 3835},
	{600 , 3825},
	{598 , 3815},
	{605 , 3807},
	{605 , 3802},
	{610 , 3796},
	{615 , 3793},
	{625 , 3791},
	{633 , 3788},  
	{640 , 3788}, 
	{648 , 3786},
	{660 , 3786},
	{663 , 3784},  
	{670 , 3782},
	{675 , 3780},
	{688 , 3778},
	{700 , 3776},
	{700 , 3770},
	{713 , 3764},
	{715 , 3753},
	{730 , 3741},
	{753 , 3728},
	{780 , 3711},
	{800 , 3692},
	{833 , 3670},
	{868 , 3646},
	{903 , 3618},
	{958 , 3591},
	{938 , 3575},
	{918 , 3565},
	{893 , 3556},
	{875 , 3550},
	{868 , 3546},
	{855 , 3540},
	{848 , 3538},
	{840 , 3533},
	{830 , 3531},
	{830 , 3529},
	{818 , 3527},
	{818 , 3526},
	{810 , 3521},
	{803 , 3400}
};      

// T1 0C
R_PROFILE_STRUC r_profile_t1[] =
{
	{268 , 4164},
	{268 , 4120},
	{315 , 4088},
	{333 , 4065},
	{335 , 4041},
	{340 , 4019},
	{353 , 4003},
	{358 , 3988},
	{368 , 3977},
	{370 , 3965},
	{375 , 3955},
	{383 , 3944},
	{390 , 3933},
	{390 , 3921},
	{390 , 3911},
	{400 , 3901},
	{398 , 3890},
	{400 , 3880},
	{393 , 3868},
	{385 , 3856},
	{375 , 3843},
	{368 , 3832},
	{368 , 3822},
	{363 , 3812},
	{363 , 3805},
	{358 , 3798},
	{360 , 3793},
	{368 , 3791},  
	{368 , 3787}, 
	{368 , 3785},
	{378 , 3785},
	{383 , 3784},  
	{385 , 3783},
	{395 , 3783},
	{400 , 3782},
	{405 , 3780},
	{413 , 3779},
	{420 , 3778},
	{423 , 3775},
	{425 , 3770},
	{425 , 3764},
	{438 , 3756},
	{445 , 3742},
	{458 , 3727},
	{480 , 3709},
	{490 , 3685},
	{490 , 3656},
	{488 , 3627},
	{495 , 3600},
	{523 , 3578},
	{563 , 3558},
	{633 , 3536},
	{688 , 3491},
	{638 , 3453},
	{590 , 3435},
	{560 , 3423},
	{543 , 3415},
	{528 , 3410},
	{525 , 3407},
	{515 , 3403},
	{498 , 3400}
};      

// T2 25C
R_PROFILE_STRUC r_profile_t2[] =
{
	{150 , 4177},
	{150 , 4150},
	{155 , 4129},
	{158 , 4110},
	{160 , 4092},
	{155 , 4075},
	{160 , 4060},
	{160 , 4042},
	{155 , 4023},
	{163 , 4009},
	{165 , 3995},
	{163 , 3983},
	{160 , 3970},
	{165 , 3958},
	{170 , 3946},
	{170 , 3935},
	{173 , 3923},
	{183 , 3913},
	{180 , 3903},
	{185 , 3892},
	{195 , 3885},
	{193 , 3874},
	{195 , 3865},
	{198 , 3857},
	{193 , 3846},
	{178 , 3833},
	{165 , 3820},
	{153 , 3809},  
	{148 , 3800}, 
	{150 , 3793},
	{148 , 3788},
	{150 , 3785},  
	{150 , 3781},
	{148 , 3779},
	{153 , 3778},
	{153 , 3777},
	{155 , 3775},
	{160 , 3774},
	{163 , 3773},
	{165 , 3771},
	{163 , 3770},
	{168 , 3768},
	{165 , 3763},
	{168 , 3758},
	{163 , 3751},
	{163 , 3740},
	{165 , 3731},
	{178 , 3719},
	{185 , 3704},
	{188 , 3683},
	{185 , 3657},
	{180 , 3626},
	{173 , 3598},
	{178 , 3577},
	{188 , 3559},
	{198 , 3536},
	{188 , 3480},
	{203 , 3389},
	{203 , 3389},
	{203 , 3389},
	{203 , 3389}      
};

// T3 50C
R_PROFILE_STRUC r_profile_t3[] =
{
	{150 , 4177},
	{150 , 4150},
	{155 , 4129},
	{158 , 4110},
	{160 , 4092},
	{155 , 4075},
	{160 , 4060},
	{160 , 4042},
	{155 , 4023},
	{163 , 4009},
	{165 , 3995},
	{163 , 3983},
	{160 , 3970},
	{165 , 3958},
	{170 , 3946},
	{170 , 3935},
	{173 , 3923},
	{183 , 3913},
	{180 , 3903},
	{185 , 3892},
	{195 , 3885},
	{193 , 3874},
	{195 , 3865},
	{198 , 3857},
	{193 , 3846},
	{178 , 3833},
	{165 , 3820},
	{153 , 3809},  
	{148 , 3800}, 
	{150 , 3793},
	{148 , 3788},
	{150 , 3785},  
	{150 , 3781},
	{148 , 3779},
	{153 , 3778},
	{153 , 3777},
	{155 , 3775},
	{160 , 3774},
	{163 , 3773},
	{165 , 3771},
	{163 , 3770},
	{168 , 3768},
	{165 , 3763},
	{168 , 3758},
	{163 , 3751},
	{163 , 3740},
	{165 , 3731},
	{178 , 3719},
	{185 , 3704},
	{188 , 3683},
	{185 , 3657},
	{180 , 3626},
	{173 , 3598},
	{178 , 3577},
	{188 , 3559},
	{198 , 3536},
	{188 , 3480},
	{203 , 3389},
	{203 , 3389},
	{203 , 3389},
	{203 , 3389} 
};

// r-table profile for actual temperature. The size should be the same as T1, T2 and T3
R_PROFILE_STRUC r_profile_temperature[] =
{	
  {0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },  
	{0  , 0 }, 
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },  
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 },
	{0  , 0 }
};      

#endif

int fgauge_get_saddles(void);
BATTERY_PROFILE_STRUC_P fgauge_get_profile(kal_uint32 temperature);

int fgauge_get_saddles_r_table(void);
R_PROFILE_STRUC_P fgauge_get_profile_r_table(kal_uint32 temperature);
