/* Copyright Statement:
 *
 * This software/firmware and related documentation ("MediaTek Software") are
 * protected under relevant copyright laws. The information contained herein
 * is confidential and proprietary to MediaTek Inc. and/or its licensors.
 * Without the prior written permission of MediaTek inc. and/or its licensors,
 * any reproduction, modification, use or disclosure of MediaTek Software,
 * and information contained herein, in whole or in part, shall be strictly prohibited.
 */
/* MediaTek Inc. (C) 2010. All rights reserved.
 *
 * BY OPENING THIS FILE, RECEIVER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND AGREES
 * THAT THE SOFTWARE/FIRMWARE AND ITS DOCUMENTATIONS ("MEDIATEK SOFTWARE")
 * RECEIVED FROM MEDIATEK AND/OR ITS REPRESENTATIVES ARE PROVIDED TO RECEIVER ON
 * AN "AS-IS" BASIS ONLY. MEDIATEK EXPRESSLY DISCLAIMS ANY AND ALL WARRANTIES,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR NONINFRINGEMENT.
 * NEITHER DOES MEDIATEK PROVIDE ANY WARRANTY WHATSOEVER WITH RESPECT TO THE
 * SOFTWARE OF ANY THIRD PARTY WHICH MAY BE USED BY, INCORPORATED IN, OR
 * SUPPLIED WITH THE MEDIATEK SOFTWARE, AND RECEIVER AGREES TO LOOK ONLY TO SUCH
 * THIRD PARTY FOR ANY WARRANTY CLAIM RELATING THERETO. RECEIVER EXPRESSLY ACKNOWLEDGES
 * THAT IT IS RECEIVER'S SOLE RESPONSIBILITY TO OBTAIN FROM ANY THIRD PARTY ALL PROPER LICENSES
 * CONTAINED IN MEDIATEK SOFTWARE. MEDIATEK SHALL ALSO NOT BE RESPONSIBLE FOR ANY MEDIATEK
 * SOFTWARE RELEASES MADE TO RECEIVER'S SPECIFICATION OR TO CONFORM TO A PARTICULAR
 * STANDARD OR OPEN FORUM. RECEIVER'S SOLE AND EXCLUSIVE REMEDY AND MEDIATEK'S ENTIRE AND
 * CUMULATIVE LIABILITY WITH RESPECT TO THE MEDIATEK SOFTWARE RELEASED HEREUNDER WILL BE,
 * AT MEDIATEK'S OPTION, TO REVISE OR REPLACE THE MEDIATEK SOFTWARE AT ISSUE,
 * OR REFUND ANY SOFTWARE LICENSE FEES OR SERVICE CHARGE PAID BY RECEIVER TO
 * MEDIATEK FOR SUCH MEDIATEK SOFTWARE AT ISSUE.
 *
 * The following software/firmware and/or related documentation ("MediaTek Software")
 * have been modified by MediaTek Inc. All revisions are subject to any receiver's
 * applicable license agreements with MediaTek Inc.
 */

#ifndef TOUCHPANEL_H__
#define TOUCHPANEL_H__

/* Pre-defined definition */
#define TPD_TYPE_CAPACITIVE
#define TPD_TYPE_RESISTIVE
#define TPD_POWER_SOURCE         MT6575_POWER_VGP2
#define TPD_I2C_NUMBER           0
#define TPD_WAKEUP_TRIAL         60
#define TPD_WAKEUP_DELAY         100

#define TPD_DELAY                (2*HZ/100)
//#define TPD_RES_X                480
//#define TPD_RES_Y                800
#define TPD_CALIBRATION_MATRIX  {962,0,0,0,1600,0,0,0};

#define TPD_HAVE_CALIBRATION
#define TPD_HAVE_BUTTON
#define TPD_HAVE_TREMBLE_ELIMINATION

#define TPD_NO_GPIO
#define TPD_RESET_PIN_ADDR   (PERICFG_BASE + 0xC000)
#define TPD_DITO_SENSOR
//#define TPD_CONDITION_SWITCH
#define TPD_RESET_ISSUE_WORKAROUND
#define TPD_MAX_RESET_COUNT 3

//LK@6575
#ifdef AUX_V900
//#define TPD_KEYS_BY_COORD  
#define TPD_BUTTON_HEIGHT_BY_COORD 90
#endif

#ifdef AUX_V900
#ifdef AUX_CHAOSHENG_CTA_CTP_MODULE
//no macro
#elif defined(AUX_CHAOSHENG_OFFICIAL_CTP_MODULE)
#define AUX_CHAOSHENG_CTP_MODULE
#else
#define AUX_GELIN_CTP_MODULE //module id:G040-12
#endif
#endif

#if defined(SIMCOM_I3000) || defined (SIMCOM_I3200)
#define TPD_X_RES 480
#define TPD_Y_RES 800
#else
#define TPD_X_RES 480
#define TPD_Y_RES 800
#endif

#if defined(SIMCOM_I3000)
  #if defined(AUX_GELIN_CTP_MODULE)||defined(AUX_CHAOSHENG_CTP_MODULE)
  #define TPD_WARP_Y(y) (y)
  #define TPD_WARP_X(x) (x)
  #else
  #define TPD_WARP_Y(y) ( TPD_Y_RES - 1 - y )
  #define TPD_WARP_X(x) (x)
  #endif
#else   
//default setting
#define TPD_WARP_Y(y) (y)
#define TPD_WARP_X(x) (x)
#endif


#ifdef TPD_DITO_SENSOR
static u8 cfg_data_version_d[] =
{
#if defined(SIMCOM_I3000)
  #if defined(AUX_V900)
    #ifdef AUX_CHAOSHENG_CTA_CTP_MODULE
    /*customer:aokesi module:chaosheng */
    //only for CTA.
    0x00,0x02,0x04,0x06,0x08,0x0A,0x0C,0x0E,
    0x10,0x12,0x73,0x33,0x63,0x33,0x53,0x33,
    0x43,0x33,0x33,0x33,0x23,0x33,0x13,0x33,
    0x03,0x33,0x83,0x33,0x93,0x33,0xA3,0x33,
    0xB3,0x33,0xC3,0x33,0xD3,0x33,0xE3,0x33,
    0xF3,0x33,0x17,0x03,0xA8,0xA8,0xA8,0x21,
    0x20,0x20,0x10,0x0F,0x0A,0x40,0x30,0x0D,
    0x03,0x00,0x05,0xE0,0x01,0x20,0x03,0x00,
    0x00,0x55,0x4F,0x58,0x52,0x00,0x00,0x04,
    0x14,0x00,0x08,0x00,0x00,0x00,0x00,0x00,
    0x14,0x10,0x74,0x03,0x00,0x00,0x00,0x00,
    0x00,0x00,0x88,0x4E,0x1F,0x00,0x0F,0x40,
    0x30,0x25,0x20,0x00,0x00,0x00,0x00,0x00,
    0x00,0x01
    #elif defined(AUX_CHAOSHENG_CTP_MODULE)
    0x12,0x10,0x0E,0x0C,0x0A,0x08,0x06,0x04,
    0x02,0x00,0x71,0x11,0x61,0x11,0x51,0x11,
    0x41,0x11,0x31,0x11,0x21,0x11,0x11,0x11,
    0x01,0x11,0x81,0x11,0x91,0x11,0xA1,0x11,
    0xB1,0x11,0xC1,0x11,0xD1,0x11,0xE1,0x11,
    0xF1,0x11,0x07,0x03,0x10,0x10,0x10,0x3A,
    0x3A,0x3A,0x10,0x10,0x0A,0x45,0x25,0x0D,
    0x03,0x00,0x05,0xE0,0x01,0x7A,0x03,0x00,
    0x00,0x58,0x4F,0x5C,0x52,0x00,0x00,0x23,
    0x14,0x25,0x04,0x00,0x00,0x00,0x00,0x00,
    0x14,0x10,0x74,0x03,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x01
    #elif defined(AUX_GELIN_CTP_MODULE)
	/*module:gelin[G040-12]*/
    0x12,0x10,0x0E,0x0C,0x0A,0x08,0x06,0x04,
    0x02,0x00,0x71,0x11,0x61,0x11,0x51,0x11,
    0x41,0x11,0x31,0x11,0x21,0x11,0x11,0x11,
    0x01,0x11,0x81,0x11,0x91,0x11,0xA1,0x11,
    0xB1,0x11,0xC1,0x11,0xD1,0x11,0xE1,0x11,
    0xF1,0x11,0x07,0x03,0x10,0x10,0x10,0x3A,
    0x3A,0x3A,0x10,0x10,0x0A,0x45,0x20,0x0D,
    0x03,0x00,0x05,0xE0,0x01,0x7A,0x03,0x00,
    0x00,0x55,0x4C,0x58,0x4F,0x00,0x00,0x23,
    0x14,0x25,0x04,0x00,0x00,0x00,0x00,0x00,
    0x14,0x10,0x53,0x03,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x01
    #endif
  #elif defined(VOTO_I3000)
	/*customer:weitu module:BYD[TP106646]*/
    0x00,0x02,0x04,0x06,0x08,0x0A,0x0C,0x0E,
    0x10,0x12,0x71,0x11,0x61,0x11,0x51,0x11,
    0x41,0x11,0x31,0x11,0x21,0x11,0x11,0x11,
    0x01,0x11,0x81,0x11,0x91,0x11,0xA1,0x11,
    0xB1,0x11,0xC1,0x11,0xD1,0x11,0xE1,0x11,
    0xF1,0x11,0x17,0x03,0x10,0x10,0x10,0x23,
    0x23,0x23,0x10,0x0F,0x0A,0x40,0x30,0x0D,
    0x03,0x00,0x05,0xE0,0x01,/*0x20*/0x36,0x03,0x00,
    0x00,0x58,0x54,0x5C,0x58,0x00,0x00,0x23,
    0x14,0x05,0x05,0x00,0x00,0x00,0x00,0x00,
    0x14,0x10,0xAC,0x03,0x00,0x00,0x00,0x00,
    0x00,0x00,0x95,0x6E,0x42,0x1A,0x0A,0x40,
    0x30,0x3C,0x28,0x00,0x00,0x00,0x00,0x00,
    0x00,0x01
  #elif defined(FEIXUN_IW007T)
      /*customer:feixun module:yushun */
       0x00,0x02,0x04,0x06,0x08,0x0A,0x0C,0x0E,
	0x10,0x12,0x81,0x11,0x91,0x11,0xA1,0x11,
	0xB1,0x11,0xC1,0x11,0xD1,0x11,0xE1,0x11,
	0xF1,0x11,0x71,0x11,0x61,0x11,0x51,0x11,
	0x41,0x11,0x31,0x11,0x21,0x11,0x11,0x11,
	0x01,0x11,0x37,0x03,0x68,0x68,0x68,0x20,
	0x20,0x20,0x10,0x0F,0x0A,0x40,0x20,0x09,
	0x03,0x00,0x05,0xE0,0x01,0x20,0x03,0x00,
	0x00,0x55,0x4F,0x58,0x52,0x00,0x00,0x23,
	0x14,0x25,0x07,0x00,0x00,0x00,0x00,0x00,
	0x14,0x10,0x74,0x03,0x00,0x00,0x00,0x00,
	0x00,0x00,0x96,0x6C,0x44,0x18,0x0D,0x40,
	0x20,0x3C,0x20,0x00,0x00,0x00,0x00,0x00,
	0x00,0x01
  #elif defined(I300M_I3000) //amy0418 
  0x00,0x02,0x04,0x06,0x08,0x0A,0x0C,0x0E,
  0x10,0x12,0x82,0x22,0x92,0x22,0xA2,0x22,
  0xB2,0x22,0xC2,0x22,0xD2,0x22,0xE2,0x22,
  0xF2,0x22,0x72,0x22,0x62,0x22,0x52,0x22,
  0x42,0x22,0x32,0x22,0x22,0x22,0x12,0x22,
  0x02,0x22,0x0B,0x13,0x10,0x10,0x10,0x39,
  0x39,0x39,0x10,0x0F,0x0A,0x45,0x2A,0x4D,
  0x03,0x00,0x05,0xE0,0x01,0x20,0x03,0x00,
  0x00,0x55,0x4F,0x58,0x52,0x00,0x00,0x05,
  0x19,0x45,0x09,0x00,0x00,0x00,0x00,0x00,
  0x19,0x14,0x74,0x03,0x00,0x40,0x0B,0x10,
  0x40,0x00,0xA0,0x70,0x40,0x10,0x0D,0x45,
  0x30,0x35,0x20,0x00,0x00,0x00,0x00,0x00,
  0x00,0x01
  	/*
      0x00,0x02,0x04,0x06,0x08,0x0A,0x0C,0x0E,
      0x10,0x12,0x81,0x11,0x91,0x11,0xA1,0x11,
      0xB1,0x11,0xC1,0x11,0xD1,0x11,0xE1,0x11,
      0xF1,0x11,0x71,0x11,0x61,0x11,0x51,0x11,
      0x41,0x11,0x31,0x11,0x21,0x11,0x11,0x11,
      0x01,0x11,0x0B,0x03,0x10,0x10,0x10,0x36,
      0x36,0x36,0x10,0x0F,0x0A,0x40,0x25,0x0D,
      0x03,0x00,0x05,0xE0,0x01,0x20,0x03,0x00,
      0x00,0x55,0x4F,0x58,0x52,0x00,0x00,0x05,
      0x14,0x45,0x08,0x00,0x00,0x00,0x00,0x00,
      0x14,0x10,0x74,0x03,0x00,0x40,0x0B,0x10,
      0x40,0x00,0xa0,0x70,0x40,0x11,0x0D,0x45,
      0x30,0x35,0x20,0x00,0x00,0x00,0x00,0x00,
      0x00,0x01
      */
  #elif defined(NUOLIXIN_I3000)
#if 1
/*
	0x00,0x02,0x04,0x06,0x08,0x0A,0x0C,0x0E,
	0x10,0x12,0x01,0x11,0x11,0x11,0x21,0x11,
	0x31,0x11,0x41,0x11,0x51,0x11,0x61,0x11,
	0x71,0x11,0x81,0x11,0x91,0x11,0xA1,0x11,
	0xB1,0x11,0xC1,0x11,0xD1,0x11,0xE1,0x11,
	0xF1,0x11,0x17,0x03,0x08,0x08,0x08,0x1A,
	0x1A,0x1A,0x10,0x0F,0x09,0x45,0x30,0x09,
	0x03,0x00,0x05,0x80,0x02,0xC0,0x03,0x00,
	0x00,0x30,0x32,0x60,0x61,0x00,0x00,0x13,
	0x14,0x15,0x05,0x00,0x00,0x00,0x00,0x00,
	0x14,0x10,0x06,0x04,0x00,0x00,0x00,0x00,
	0x00,0x00,0x20,0x80,0x00,0x00,0x0C,0x40,
	0x30,0x35,0x2E,0x00,0x00,0x00,0x00,0x00,
	0x00,0x01
	*/
	0x02,0x04,0x06,0x08,0x0A,0x0C,0x0E,0x10,0x12,0x00,
	0x73,0x33,0x63,0x33,0x53,0x33,0x43,0x33,0x33,0x33,
	0x23,0x33,0x13,0x33,0x03,0x33,0x83,0x33,0x93,0x33,
	0xA3,0x33,0xB3,0x33,0xC3,0x33,0xD3,0x33,0xE3,0x33,
	0xF3,0x33,0x17,0x03,0x88,0x88,0x88,0x20,0x20,0x20,
	0x10,0x0F,0x09,0x45,0x2A,0x09,0x03,0x00,0x05,0xE0,
	0x01,0x20,0x03,0x00,0x00,0x4F,0x4F,0x53,0x52,0x00,
	0x00,0x04,0x20,0x05,0x08,0x00,0x00,0x00,0x00,0x00,
	0x14,0x10,0x74,0x03,0x00,0x00,0x00,0x00,0x00,0x00,
	0x80,0x20,0x00,0x00,0x0C,0x45,0x30,0x20,0x14,0x00,
	0x00,0x00,0x00,0x00,0x00,0x01	
#else 
	0x02,0x04,0x06,0x08,0x0A,0x0C,0x0E,0x10,
	0x12,0x00,0x72,0x22,0x62,0x22,0x52,0x22,
	0x42,0x22,0x32,0x22,0x22,0x22,0x12,0x22,
	0x02,0x22,0x82,0x22,0x92,0x22,0xA2,0x22,
	0xB2,0x22,0xC2,0x22,0xD2,0x22,0xE2,0x22,
	0xF2,0x22,0x17,0x03,0x88,0x88,0x88,0x1C,
	0x1C,0x1C,0x10,0x0F,0x09,0x47,0x2A,0x09,
	0x03,0x00,0x05,0xE0,0x01,0x20,0x03,0x00,
	0x00,0x4F,0x4F,0x53,0x52,0x00,0x00,0x04,
	0x20,0x05,0x08,0x00,0x00,0x00,0x00,0x00,
	0x14,0x10,0x74,0x03,0x00,0x00,0x17,0x88,
	0x1D,0x00,0x80,0x20,0x00,0x00,0x0C,0x45,
	0x30,0x20,0x14,0x00,0x00,0x00,0x00,0x00,
	0x00,0x01
#endif
  #elif defined(CHUANGQI_H948)
    0x00,0x02,0x04,0x06,0x08,0x0A,0x0C,0x0E,
    0x10,0x12,0x71,0x11,0x61,0x11,0x51,0x11,
    0x41,0x11,0x31,0x11,0x21,0x11,0x11,0x11,
    0x01,0x11,0x81,0x11,0x91,0x11,0xA1,0x11,
    0xB1,0x11,0xC1,0x11,0xD1,0x11,0xE1,0x11,
    0xF1,0x11,0x07,0x03,0x10,0x10,0x10,0x39,
    0x39,0x39,0x10,0x0F,0x0A,0x50,0x25,0x0D,
    0x03,0x00,0x05,0xE0,0x01,0x20,0x03,0x00,
    0x00,0x55,0x4F,0x58,0x52,0x00,0x00,0x44,
    0x19,0x45,0x08,0x00,0x00,0x00,0x00,0x00,
    0x19,0x14,0x74,0x03,0x00,0x00,0x00,0x00,
    0x00,0x00,0x97,0x6E,0x43,0x19,0x0E,0x45,
    0x30,0x35,0x20,0x00,0x00,0x00,0x00,0x00,
    0x00,0x01  
  #elif defined(ZHIDA_I3000) 
     0x00,0x02,0x04,0x06,0x08,0x0A,0x0C,0x0E,0x10,0x12,
    0x73,0x33,0x63,0x33,0x53,0x33,0x43,0x33,0x33,0x33,
    0x23,0x33,0x13,0x33,0x03,0x33,0x83,0x33,0x93,0x33,
    0xA3,0x33,0xB3,0x33,0xC3,0x33,0xD3,0x33,0xE3,0x33,
    0xF3,0x33,0x07,0x13,0x48,0x48,0x48,0x14,0x14,0x14,0x10,
    0x0F,0x0A,0x40,0x25,0x0D,0x03,0x00,0x05,0xE0,0x01,0x20,
    0x03,0x00,0x00,0x55,0x4F,0x58,0x52,0x00,0x00,0x14,0x14,
    0x45,0x08,0x00,0x00,0x00,0x00,0x00,0x14,0x10,0x74,0x03,
    0x00,0x00,0x00,0x00,0x00,0x00,0x97,0x6E,0x43,0x19,
    0x0C,0x40,0x25,0x35,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x01 		 	
  #else
    #if 1//improve sensitivity
    0x00,0x02,0x04,0x06,0x08,0x0A,0x0C,0x0E,
    0x10,0x12,0x73,0x10,0x63,0x10,0x53,0x10,
    0x43,0x10,0x33,0x10,0x23,0x10,0x13,0x10,
    0x03,0x10,0x82,0x22,0x92,0x22,0xA2,0x22,
    0xB2,0x22,0xC2,0x22,0xD3,0x33,0xE2,0x22,
    0xF2,0x22,0x1B,0x03,0x10,0x10,0x10,0x24,
    0x24,0x24,0x10,0x0F,0x0A,0x40,0x25,0x0D,
    0x03,0x00,0x05,0xE0,0x01,0x20,0x03,0x00,
    0x00,0x55,0x4F,0x58,0x52,0x00,0x00,0x44,
    0x14,0x45,0x08,0x00,0x00,0x00,0x00,0x00,
    0x14,0x10,0x74,0x03,0x00,0x00,0x00,0x00,
    0x00,0x00,0x97,0x6E,0x43,0x19,0x0E,0x48,
    0x3C,0x35,0x20,0x00,0x00,0x00,0x00,0x00,
    0x00,0x01 
    #else//original
    0x00,0x02,0x04,0x06,0x08,0x0A,0x0C,0x0E,
    0x10,0x12,0x73,0x33,0x63,0x33,0x53,0x33,
    0x43,0x33,0x33,0x33,0x23,0x33,0x13,0x33,
    0x03,0x33,0x83,0x33,0x93,0x33,0xA3,0x33,
    0xB3,0x33,0xC3,0x33,0xD3,0x33,0xE3,0x33,
    0xF3,0x33,0x17,0x03,0xA8,0xA8,0xA8,0x21,
    0x20,0x20,0x10,0x0F,0x0A,0x40,0x30,0x0D,
    0x03,0x00,0x05,0xE0,0x01,0x20,0x03,0x00,
    0x00,0x55,0x4F,0x58,0x52,0x00,0x00,0x04,
    0x14,0x00,0x08,0x00,0x00,0x00,0x00,0x00,
    0x14,0x10,0x74,0x03,0x00,0x00,0x00,0x00,
    0x00,0x00,0x97,0x6E,0x43,0x19,0x0E,0x40,
    0x30,0x25,0x20,0x00,0x00,0x00,0x00,0x00,
    0x00,0x01
    #endif
  #endif
#elif defined(SIMCOM_I3200)
    0x00,0x02,0x04,0x06,0x08,0x0A,0x0C,0x0E,
    0x10,0x12,0x01,0x11,0x11,0x11,0x21,0x11,
    0x31,0x11,0x41,0x11,0x51,0x11,0x61,0x11,
    0x71,0x11,0x81,0x11,0x91,0x11,0xA1,0x11,
    0xB1,0x11,0xC1,0x11,0xD1,0x11,0xE1,0x11,
    0xF1,0x11,0x17,0x13,0x28,0x28,0x28,0x15,
    0x15,0x15,0x10,0x0F,0x0A,0x45,0x30,0x4B,
    0x03,0x00,0x05,0xE0,0x01,0x20,0x03,0x00,
    0x00,0x55,0x4F,0x58,0x52,0x00,0x00,0x03,
    0x14,0x05,0x06,0x00,0x00,0x00,0x00,0x00,
    0x14,0x10,0x74,0x03,0x00,0x00,0x00,0x00,
    0x00,0x00,0x19,0x43,0x6E,0x97,0x0E,0x40,
    0x30,0x25,0x20,0x00,0x00,0x00,0x00,0x00,
    0x00,0x01
#else
    0x00,0x02,0x04,0x06,0x08,0x0A,0x0C,0x0E,
    0x10,0x12,0x73,0x33,0x63,0x33,0x53,0x33,
    0x43,0x33,0x33,0x33,0x23,0x33,0x13,0x33,
    0x03,0x33,0x83,0x33,0x93,0x33,0xA3,0x33,
    0xB3,0x33,0xC3,0x33,0xD3,0x33,0xE3,0x33,
    0xF3,0x33,0x17,0x03,0xA8,0xA8,0xA8,0x21,
    0x20,0x20,0x10,0x0F,0x0A,0x40,0x30,0x0D,
    0x03,0x00,0x05,0xE0,0x01,0x20,0x03,0x00,
    0x00,0x55,0x4F,0x58,0x52,0x00,0x00,0x04,
    0x14,0x00,0x08,0x00,0x00,0x00,0x00,0x00,
    0x14,0x10,0x74,0x03,0x00,0x00,0x00,0x00,
    0x00,0x00,0x97,0x6E,0x43,0x19,0x0E,0x40,
    0x30,0x25,0x20,0x00,0x00,0x00,0x00,0x00,
    0x00,0x01
#endif
};

static u8 cfg_data_with_charger_version_d[] =
{
    /*
    0x00, 0x02, 0x04, 0x06, 0x08, 0x0A, 0x0C, 0x0E,
    0x10, 0x12, 0x60, 0x00, 0x50, 0x00, 0x40, 0x00,
    0x30, 0x00, 0x20, 0x00, 0x10, 0x00, 0x00, 0x00,
    0x70, 0x00, 0x80, 0x00, 0x90, 0x00, 0xA0, 0x00,
    0xB0, 0x00, 0xC0, 0x00, 0xD0, 0x00, 0xE0, 0x00,
    0x00, 0x00, 0x05, 0x03, 0x90, 0x90, 0x90, 0x30,
    0x30, 0x30, 0x0F, 0x0F, 0x0A, 0x50, 0x3C, 0x09,
    0x03, 0x00, 0x05, 0xE0, 0x01, 0x20, 0x03, 0x00,
    0x00, 0x00, 0x00, 0x40, 0x40, 0x00, 0x00, 0x01,
    0x19, 0x00, 0x0A, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x20, 0x10, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x38,
    0x00, 0x3C, 0x28, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x01
    */
    0x00,0x02,0x04,0x06,0x08,0x0A,0x0C,0x0E,
    0x10,0x12,0x82,0x22,0x92,0x22,0xA2,0x22,
    0xB2,0x22,0xC2,0x22,0xD2,0x22,0xE2,0x22,
    0xF2,0x22,0x72,0x22,0x62,0x22,0x52,0x22,
    0x42,0x22,0x32,0x22,0x22,0x22,0x12,0x22,
    0x02,0x22,0x37,0x13,0x88,0x88,0x88,0x1C,
    0x1C,0x1C,0x10,0x10,0x0A,0x3C,0x2C,0x49,
    0x03,0x00,0x05,0xE0,0x01,0x66,0x03,0x00,
    0x00,0x5C,0x5C,0x60,0x60,0x00,0x00,0x04,
    0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x14,0x10,0x06,0x04,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3C,
    0x2C,0x3C,0x28,0x00,0x00,0x00,0x00,0x00,
    0x00,0x01
};

//GT818_6573_DITO_config.gtx
static u8 cfg_data_version_b[] =
{
    0x00, 0x02, 0x04, 0x06, 0x08, 0x0A, 0x0C, 0x0E,
    0x10, 0x12, 0x60, 0x00, 0x50, 0x00, 0x40, 0x00,
    0x30, 0x00, 0x20, 0x00, 0x10, 0x00, 0x00, 0x00,
    0x70, 0x00, 0x80, 0x00, 0x90, 0x00, 0xA0, 0x00,
    0xB0, 0x00, 0xC0, 0x00, 0xD0, 0x00, 0xE0, 0x00,
    0x00, 0x00, 0x11, 0x13, 0x90, 0x90, 0x90, 0x40,
    0x40, 0x40, 0x0F, 0x0F, 0x0A, 0x50, 0x3C, 0x49,
    0x03, 0x00, 0x05, 0xE0, 0x01, 0x20, 0x03, 0x00,
    0x00, 0x64, 0x5A, 0x40, 0x40, 0x00, 0x00, 0x03,
    0x19, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x20, 0x10, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x38,
    0x00, 0x3C, 0x28, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x01
};

// GT818_6573_DITO_charger_577K.gtx
static u8 cfg_data_with_charger_version_b[] =
{
    0x00, 0x02, 0x04, 0x06, 0x08, 0x0A, 0x0C, 0x0E,
    0x10, 0x12, 0x60, 0x00, 0x50, 0x00, 0x40, 0x00,
    0x30, 0x00, 0x20, 0x00, 0x10, 0x00, 0x00, 0x00,
    0x70, 0x00, 0x80, 0x00, 0x90, 0x00, 0xA0, 0x00,
    0xB0, 0x00, 0xC0, 0x00, 0xD0, 0x00, 0xE0, 0x00,
    0x00, 0x00, 0x2F, 0x13, 0x10, 0x10, 0x10, 0x60,
    0x60, 0x60, 0x0F, 0x0F, 0x0A, 0x78, 0x5A, 0x49,
    0x03, 0x64, 0x05, 0xE0, 0x01, 0x20, 0x03, 0x00,
    0x00, 0x64, 0x5A, 0x40, 0x40, 0x00, 0x00, 0x03,
    0x19, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x20, 0x10, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x38,
    0x00, 0x3C, 0x28, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x01
};

#else //SITO
// 6573_SITO_config.gtx
static u8 cfg_data_version_b[] =
{
    0x00, 0x02, 0x04, 0x06, 0x08, 0x0A, 0x0C, 0x0E,
    0x10, 0x12, 0x80, 0x00, 0x90, 0x00, 0xA0, 0x00,
    0xB0, 0x00, 0xC0, 0x00, 0xD0, 0x00, 0xE0, 0x00,
    0xF0, 0x00, 0x70, 0x00, 0x60, 0x00, 0x50, 0x00,
    0x40, 0x00, 0x30, 0x00, 0x20, 0x00, 0x10, 0x00,
    0x00, 0x00, 0x27, 0x13, 0xE0, 0xE0, 0xE0, 0x1A,
    0x1A, 0x1A, 0x10, 0x10, 0x0A, 0x50, 0x3C, 0x0D,
    0x00, 0x00, 0x05, 0xE0, 0x01, 0x20, 0x03, 0x00,
    0x00, 0x64, 0x5A, 0x40, 0x40, 0x00, 0x00, 0x03,
    0x19, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x20, 0x10, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x38,
    0x00, 0x3C, 0x28, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x01
};

//6573_SITO_charger.gtx
static u8 cfg_data_with_charger_version_b[] =
{
    0x00, 0x02, 0x04, 0x06, 0x08, 0x0A, 0x0C, 0x0E,
    0x10, 0x12, 0x80, 0x00, 0x90, 0x00, 0xA0, 0x00,
    0xB0, 0x00, 0xC0, 0x00, 0xD0, 0x00, 0xE0, 0x00,
    0xF0, 0x00, 0x70, 0x00, 0x60, 0x00, 0x50, 0x00,
    0x40, 0x00, 0x30, 0x00, 0x20, 0x00, 0x10, 0x00,
    0x00, 0x00, 0x2B, 0x13, 0x50, 0x50, 0x50, 0x51,
    0x61, 0x71, 0x10, 0x10, 0x0A, 0x64, 0x50, 0x4D,
    0x00, 0x00, 0x05, 0xE0, 0x01, 0x20, 0x03, 0x00,
    0x00, 0x64, 0x5A, 0x40, 0x40, 0x00, 0x00, 0x03,
    0x19, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x20, 0x10, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x38,
    0x00, 0x3C, 0x28, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x01
};
#endif
#endif /* TOUCHPANEL_H__ */
